SystemOrganization addCategory: #'Monticello2-Announcements'!
SystemOrganization addCategory: #'Monticello2-Elements'!
SystemOrganization addCategory: #'Monticello2-Fakes'!
SystemOrganization addCategory: #'Monticello2-Project'!
SystemOrganization addCategory: #'Monticello2-Repositories'!
SystemOrganization addCategory: #'Monticello2-Serialization'!
SystemOrganization addCategory: #'Monticello2-Slices'!
SystemOrganization addCategory: #'Monticello2-Tests'!
SystemOrganization addCategory: #'Monticello2-Utilities'!
SystemOrganization addCategory: #'Monticello2-Versions'!

!String methodsFor: '*monticello2' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aMarshal 
	aMarshal writeString: self! !

!Class methodsFor: '*monticello2-serialization' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	aSerializer serializeClass: self! !

TestCase subclass: #MDAdaptionTest
	instanceVariableNames: 'domain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDAdaptionTest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/6/2005 22:33'!
isAbstract
	^ self name = #MDAdaptionTest! !

!MDAdaptionTest methodsFor: 'constants' stamp: 'cwp 9/12/2009 22:29'!
adaptorSelectors
	^ #(isPresent isUpToDate: load: remove update: merge:into:onFailure:)! !

!MDAdaptionTest methodsFor: 'configuration' stamp: 'jf 10/21/2009 16:19'!
domainClass
	self subclassResponsibility! !

!MDAdaptionTest methodsFor: 'running' stamp: 'jf 10/21/2009 16:19'!
setUp
	domain := self domainClass new! !

!MDAdaptionTest methodsFor: 'constructing' stamp: 'cwp 3/15/2005 22:22'!
slice
	^ MDExplicitSlice named: 'Foo'! !

!MDAdaptionTest methodsFor: 'running' stamp: 'jf 10/21/2009 16:11'!
tryAdapting: anElement 
	| adaptor |
	adaptor := domain adapt: anElement.
	self adaptorSelectors do: [ :ea | self assert: (adaptor respondsTo: ea) ]! !

MDAdaptionTest subclass: #MDSmalltalkAdaptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

MDSmalltalkAdaptionTest subclass: #MDFakeAdaptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDFakeAdaptionTest methodsFor: 'converting' stamp: 'jf 10/21/2009 16:19'!
domainClass
	^ MDFakeDomain! !

!MDSmalltalkAdaptionTest class methodsFor: 'as yet unclassified' stamp: 'cwp 9/12/2009 22:42'!
isAbstract
	^ self name = #MDSmalltalkAdaptionTest! !

!MDSmalltalkAdaptionTest methodsFor: 'tests' stamp: 'cwp 9/12/2009 22:32'!
testClassComment
	self tryAdapting: (MDClassCommentElement className: #MDBogusA)! !

!MDSmalltalkAdaptionTest methodsFor: 'tests' stamp: 'cwp 9/12/2009 22:32'!
testClassElement
	self tryAdapting: (MDClassElement className: #MDBogusA)! !

!MDSmalltalkAdaptionTest methodsFor: 'tests' stamp: 'cwp 9/12/2009 22:32'!
testClassInstVarElement
	self tryAdapting: (MDClassInstVarElement className: #MDBogusA name: 'beth')! !

!MDSmalltalkAdaptionTest methodsFor: 'tests' stamp: 'cwp 9/12/2009 22:32'!
testClassVarElement
	self tryAdapting: (MDClassVarElement className: #MDBogusA name: 'Beta')! !

!MDSmalltalkAdaptionTest methodsFor: 'tests' stamp: 'cwp 9/12/2009 22:33'!
testInstVarElement
	self tryAdapting: (MDInstVarElement className: #MDBogusA name: 'one')! !

!MDSmalltalkAdaptionTest methodsFor: 'tests' stamp: 'cwp 9/12/2009 22:33'!
testMethodElement
	self tryAdapting: (MDMethodElement className: #MDBogusA selector: #method1)! !

!MDSmalltalkAdaptionTest methodsFor: 'tests' stamp: 'cwp 9/12/2009 22:33'!
testPoolImportElement
	self tryAdapting: (MDPoolImportElement 
			className: #MDBogusA
			name: #MDBogusPoolB)! !

TestCase subclass: #MDAnnouncementTest
	instanceVariableNames: 'element project slice received environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 03:00'!
environment
	^ environment! !

!MDAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/28/2008 07:19'!
runCase
	MDAnnouncer isolate: [super runCase]! !

!MDAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'jf 10/21/2009 16:33'!
setUp
	element := MDMethodElement 
		className: #MDBogusA
		selector: #griffle.
	environment := MDEnvironment forTesting.
	project := MDProject forTesting.
	environment addProject: project.
	slice := environment addSlice: MDExplicitSlice forTesting.
	slice addElement: element.
	project addSlice: slice.
	environment subscribe.
	received := OrderedCollection new.! !

!MDAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'jf 9/6/2009 14:22'!
subscribeTo: aClass 
	MDAnnouncer default 
		observe: aClass
		do: [ :ann | received add: ann ]! !

!MDAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/14/2009 22:22'!
testAdded
	MDAnnouncer announce: (MDElementAdded for: element).
	self assert: (self environment isDirty: slice)! !

!MDAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'jf 9/6/2009 14:22'!
testDirty
	self subscribeTo: MDSliceDirty.
	MDAnnouncer announce: (MDElementAdded for: element).
	self deny: received isEmpty.
	self assert: received first slice = slice! !

!MDAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/14/2009 22:22'!
testModified
	MDAnnouncer announce: (MDElementModified for: element).
	self assert: (self environment isDirty: slice)! !

!MDAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'jf 9/8/2009 23:42'!
testProjectRemoved
	self subscribeTo: MDElementRemoved.
	self environment removeProjectId: project id.
	self deny: received isEmpty.
	self assert: (received first isKindOf: MDElementRemoved).
	self assert: (received first element isKindOf: MDProjectElement).
	self assert: received first element id = project id.
	! !

!MDAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'jf 9/6/2009 14:25'!
testProjectRenamed
	
	self subscribeTo: MDElementModified.
	project name: 'someOtherProject'.
	self deny: received isEmpty.
	self assert: (received first isKindOf: MDElementModified).
	self assert: received first element id = project id.
	! !

!MDAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/14/2009 22:22'!
testRemoved
	MDAnnouncer announce: (MDElementRemoved for: element).
	self assert: (self environment isDirty: slice)! !

!MDAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'jf 10/21/2009 16:47'!
testRepositoryAdded
	| repository |
	self subscribeTo: MDElementAdded.
	repository := environment addRepository: (MDMemoryRepository named: 'anotherTest').
	self deny: received isEmpty.
	self assert: (received first isKindOf: MDElementAdded).
	self assert: (received first element isKindOf: MDRepositoryElement).
	self assert: received first element id = repository id! !

!MDAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/8/2009 23:35'!
testRepositoryAssociationAdded
	| repository |
	self subscribeTo: MDElementAdded.
	repository := MDMemoryRepository named: 'anotherTest'.
	environment addRepository: repository toProject: project.
	self deny: received isEmpty.
	self assert: (received first isKindOf: MDElementAdded).
	self assert: (received first element isKindOf: MDRepositoryElement).
	self assert: received first element id = repository id.
	self assert: (received second isKindOf: MDElementAdded).
	self assert: (received second element isKindOf: MDRepositoryAssociationElement).
	self assert: received second element projectId = project id.
	self assert: received second element repositoryId = repository id! !

!MDAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'jf 10/21/2009 16:47'!
testRepositoryAssociationRemoved
	
	| repository |
	repository := project addRepository: MDMemoryRepository forTesting.
	self subscribeTo: MDElementRemoved.
	project removeRepository: repository.
	self deny: received isEmpty.
	self assert: (received first isKindOf: MDElementRemoved).
	self assert: (received first element isKindOf: MDRepositoryAssociationElement).
	self assert: received first element projectId = project id.
	self assert: received first element repositoryId = repository id! !

!MDAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'jf 9/8/2009 23:58'!
testRepositoryRemoved
	
	| repository |
	repository := MDMemoryRepository forTesting.
	environment addRepository: repository.
	project addRepository: repository.
	self subscribeTo: MDElementRemoved.
	environment removeRepositoryId: repository id.
	self deny: received isEmpty.
	self assert: (received first isKindOf: MDElementRemoved).
	self assert: (received first element isKindOf: MDRepositoryAssociationElement).
	self assert: received first element projectId = project id.
	self assert: received first element repositoryId = repository id.
	self assert: (received second isKindOf: MDElementRemoved).
	self assert: (received second element isKindOf: MDRepositoryElement).
	self assert: received second element id = repository id.! !

!MDAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'jf 10/21/2009 16:33'!
testSliceAdded
	| anotherSlice |
	self subscribeTo: MDElementAdded.
	anotherSlice := environment addSlice: (MDExplicitSlice named: 'anotherTest').
	self deny: received isEmpty.
	self assert: (received first isKindOf: MDElementAdded).
	self assert: (received first element isKindOf: MDSliceElement).
	self assert: received first element id = anotherSlice id.! !

!MDAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/8/2009 23:36'!
testSliceAssociationAdded
	| anotherSlice |
	self subscribeTo: MDElementAdded.
	anotherSlice := MDExplicitSlice named: 'anotherTest'.
	environment addSlice: anotherSlice toProject: project.
	self deny: received isEmpty.
	self assert: (received first isKindOf: MDElementAdded).
	self assert: (received first element isKindOf: MDSliceElement).
	self assert: received first element id = anotherSlice id.
	self assert: (received second isKindOf: MDElementAdded).
	self assert: (received second element isKindOf: MDSliceAssociationElement).
	self assert: received second element projectId = project id.
	self assert: received second element sliceId = anotherSlice id.! !

!MDAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'jf 9/8/2009 18:19'!
testSliceAssociationRemoved
	
	self subscribeTo: MDElementRemoved.
	project removeSlice: slice.
	self deny: received isEmpty.
	self assert: (received first isKindOf: MDElementRemoved).
	self assert: (received first element isKindOf: MDSliceAssociationElement).
	self assert: received first element projectId = project id.
	self assert: received first element sliceId = slice id.! !

!MDAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'jf 9/8/2009 23:26'!
testSliceRemoved
	
	self subscribeTo: MDElementRemoved.
	environment removeSliceId: slice id.
	self deny: received isEmpty.
	self assert: (received first isKindOf: MDElementRemoved).
	self assert: (received first element isKindOf: MDSliceAssociationElement).
	self assert: received first element projectId = project id.
	self assert: received first element sliceId = slice id.
	self assert: (received second isKindOf: MDElementRemoved).
	self assert: (received second element isKindOf: MDSliceElement).
	self assert: received second element id = slice id.! !

TestCase subclass: #MDDefaultDomainTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDDefaultDomainTest methodsFor: 'asserting' stamp: 'cwp 6/15/2008 20:25'!
assertDefaultIdentityFor: aSymbol
	| first second |
	first := MDDomain defaultForType: aSymbol.
	second := MDDomain defaultForType: aSymbol.
	self assert: first == second! !

TestCase subclass: #MDEnvironmentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDEnvironmentTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2009 15:19'!
testAddProject
	| environment project |
	environment := MDEnvironment new.
	project := MDProject forTesting.
	environment addProject: project.
	self assert: (environment projects includes: project)! !

!MDEnvironmentTest methodsFor: 'as yet unclassified' stamp: 'jf 10/21/2009 16:48'!
testAddRepository
	| environment repository |
	environment := MDEnvironment new.
	repository := environment addRepository: MDMemoryRepository forTesting.
	self assert: (environment repositories includes: repository)! !

!MDEnvironmentTest methodsFor: 'as yet unclassified' stamp: 'jf 10/21/2009 16:34'!
testAddSlice
	| environment slice slice2 |
	environment := MDEnvironment new.
	slice := MDExplicitSlice forTesting.
	slice2 := environment addSlice: slice.
	self assert: (environment slices includes: slice).
	self assert: slice == slice2! !

!MDEnvironmentTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2009 11:08'!
testDefault
	self assert: MDEnvironment default class == MDEnvironment! !

TestCase subclass: #MDHashstampTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDHashstampTest methodsFor: 'support' stamp: 'cwp 8/8/2009 16:19'!
tag
	^ #(215 214 124 149 170 226 94 130 56 54 75 164 35 251 0 20 106 252 22) asByteArray.! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 8/8/2009 16:27'!
testCheckByte
	| hashstamp |
	hashstamp := MDHashstamp 
		tag: #(215 214 124 149 170 226 94 130 56 54 75 164 35 251 0 20 106 252 22) asByteArray
		timestamp: (MDTimestamp fromInteger: 929031339).
	self assert: hashstamp checkByte = 251! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 8/8/2009 16:04'!
testEqual
	| first second now |
	now := MDTimestamp now.
	first := MDHashstamp timestamp: now.
	second := MDHashstamp tag: first tag timestamp: now.
	self assert: first = second! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 8/8/2009 16:11'!
testHash
	| first second now tag |
	now := MDTimestamp now.
	tag := self tag.
	first := MDHashstamp tag: tag timestamp: now.
	tag at: 1 put: 20.
	second := MDHashstamp tag: tag timestamp: now.
	self deny: first hash = second hash.
	self deny: first = second! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 8/8/2009 16:31'!
testInvalid
	| hashstamp byte |
	hashstamp := MDHashstamp new.
	byte := hashstamp checkByte + 1.
	byte < 0 ifTrue: [byte := 255].
	byte > 255 ifTrue: [byte := 0].
	hashstamp at: 24 put: byte.
	self deny: hashstamp isValid! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testLessThan
	| first second |
	first := MDHashstamp fromString: 'bjrm0RTKT7KesZu0C1N9d0Dv+-Fez-No'.
	second := MDHashstamp fromString: 'c0qD0lTwM3oFdWJn9yYiSxGZjuhr9NHe'.
	self assert: first <= second! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 8/8/2009 16:18'!
testNew
	| hashstamp |
	hashstamp := MDHashstamp new.
	self assert: hashstamp size = MDHashstamp hashstampSize.
	self assert: (MDTimestamp now asInteger - hashstamp timestamp asInteger) < 5.
	self assert: hashstamp tag size = 19.
	self assert: hashstamp checkByte < 255.
	self assert: hashstamp isValid.! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 8/8/2009 16:27'!
testPrinting
	| hashstamp |
	hashstamp := MDHashstamp 
		tag: self tag
		timestamp: (MDTimestamp fromInteger: 929030771).
	self assert: hashstamp printString = 'BpzWQxTKT7KesZu0C1N9d0Dv+-Fez-Oq'! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 8/8/2009 16:12'!
testRead
	| hashstamp |
	hashstamp := MDHashstamp new.
	self assert: hashstamp = (MDHashstamp fromString: hashstamp asString)
! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 8/8/2009 16:16'!
testTag
	| hashstamp tag |
	tag := #(215 214 124 149 170 226 94 130 56 54 75 164 35 251 0 20 106 252 22) asByteArray.
	hashstamp := MDHashstamp 
		tag: tag
		timestamp: (MDTimestamp fromInteger: 929031339).
	self assert: hashstamp tag = tag.
	self deny: hashstamp tag == tag! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 8/8/2009 15:49'!
testTimestamp
	| first second now then |
	now := MDTimestamp now.
	then := MDTimestamp fromInteger: (now asInteger - 1).
	first := MDHashstamp timestamp: then.
	second := MDHashstamp timestamp: now.
	self deny: first timestamp = second timestamp.
	self deny: first = second! !

TestCase subclass: #MDHistorianTest
	instanceVariableNames: 'historian slice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDHistorianTest methodsFor: 'support' stamp: 'cwp 3/6/2008 20:09'!
createMemo
	^ MDMemo
		snapshot: (MDSnapshot withVersions: Array new) 
		slice: slice
		parents: Array new
		properties: MDPropertyDictionary new.! !

!MDHistorianTest methodsFor: 'support' stamp: 'cwp 5/22/2008 00:10'!
markDirty
	| element |
	element := MDFakeElement named: #a.
	slice addElement: element.
	historian noteElementChanged: element.
! !

!MDHistorianTest methodsFor: 'support' stamp: 'cwp 3/6/2008 18:45'!
memo
	^ self memoWithComment: 'This is a test'! !

!MDHistorianTest methodsFor: 'support' stamp: 'cwp 3/8/2008 14:02'!
memoWithComment: aString
	^ [historian memo]
		on: MDCommentRequest
		do: [:req | req resume: aString]! !

!MDHistorianTest methodsFor: 'support' stamp: 'cwp 5/22/2008 00:10'!
setUp
	slice := MDExplicitSlice named: 'test'.
	historian := MDHistorian forSlice: slice.
! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testCancelCommentRequest
	| memo |
	memo := self memoWithComment: nil.
	self assert: memo isNil! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testComment
	| memo |
	memo := self memoWithComment: 'test123'.
	self assert: (memo properties comment = 'test123')! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 3/9/2008 22:25'!
testDirty
	
	self markDirty.
	self assert: historian isDirty! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testEmptyComment
	| memo |
	memo := self memoWithComment: ''.
	self deny: (memo properties includesKey: #comment)! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testIncludeUpdatesOrdinal
	
	| child first second |
	first := self createMemo.
	second := self createMemo.
	second properties ordinal: 5.
	historian noteLoad: first.
	historian noteInclude: second.
	child := self memo.
	self assert: child properties ordinal = 6! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testLoad
	
	| parent child |
	parent := self createMemo.
	historian noteLoad: parent.
	child := self memo.
	self assert: child parents size = 1.
	self assert: child parents anyOne = parent hashstamp! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testLoadAndInclude
	
	| child first second |
	first := self createMemo.
	second := self createMemo.
	historian noteLoad: first.
	historian noteInclude: second.
	child := self memo.
	self assert: child parents size = 2.
	self assert: child parents first = first hashstamp.
	self assert: child parents second = second hashstamp.! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testLoadAndSave
	
	| child first second |
	first := self createMemo.
	second := self createMemo.
	historian noteLoad: first.
	historian noteSave: second.
	child := self memo.
	self assert: child parents size = 1.
	self assert: child parents anyOne = second hashstamp.
! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testLoadClearsDirtyFlag
	
	| parent |
	self markDirty.
	parent := self createMemo.
	historian noteLoad: parent.
	self deny: historian isDirty! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testLoadUpdatesOrdinal
	
	| parent child |
	parent := self createMemo.
	parent properties ordinal: 5.
	historian noteLoad: parent.
	child := self memo.
	self assert: child properties ordinal = 6! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 3/6/2008 19:23'!
testNoParents
	
	self assert: self memo parents isEmpty! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testNotDirty
	| element |
	element := MDFakeElement named: #a.
	historian noteElementChanged: element.
	self deny: historian isDirty! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testOrdinalsIncreaseByOne
	| memo |
	self memo.
	memo := self memo.
	self assert: memo properties ordinal = 2! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 12/28/2007 23:56'!
testOrdinalsStartAtOne

	self assert: self memo properties ordinal = 1! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testPlatformProperties
	| properties memo |
	properties := MDPropertyDictionary new.
	MDPlatform current updateMemoProperties: properties.
	
	memo := self memo.
	properties keysAndValuesDo:
		[:k :v | self assert: (memo properties at: k) = v]! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testSave
	
	| parent child |
	parent := self memo.
	parent setSnapshot: (MDSnapshot withVersions: Array new) slice: slice. 
	historian noteSave: parent.
	child := self memo.
	self assert: child parents size = 1.
	self assert: child parents anyOne = parent hashstamp! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testSaveAndInclude
	
	| child first second |
	first := self memo.
	second := self createMemo.
	first setSnapshot: (MDSnapshot withVersions: Array new) slice: slice. 
	historian noteSave: first.
	historian noteInclude: second.
	child := self memo.
	self assert: child parents size = 2.
	self assert: child parents first = first hashstamp.
	self assert: child parents second = second hashstamp.! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testSaveClearsDirtyFlag
	| parent |
	self markDirty.	
	parent := self memo.
	parent setSnapshot: (MDSnapshot withVersions: Array new) slice: slice. 
	historian noteSave: parent.
	
	self deny: historian isDirty! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 3/8/2008 21:16'!
testStartsClean
	self deny: historian isDirty! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 12/28/2007 23:57'!
testUpdate
	
	historian properties abc: 123.
	self assert: self memo properties abc = 123! !

TestCase subclass: #MDMaterializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDMaterializerTest class methodsFor: 'as yet unclassified' stamp: 'cwp 4/16/2008 22:04'!
isAbstract
	^ self name = #MDMaterializerTest! !

MDMaterializerTest subclass: #MDUtf8MaterializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDUtf8MaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/15/2008 12:53'!
assert: aByteArray yields: expected
	| actual |
	actual := MDMaterializer materialize: aByteArray.
	self assert: actual = expected! !

!MDUtf8MaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/23/2008 08:57'!
testAboriginal
	self
		assert: #(15 9 3 225 144 129 225 144 130 225 144 131)
		yields: MDPlatform current aboriginalAbc! !

!MDUtf8MaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 14:36'!
testAscii
	self
		assert: #(15 9 3 97 98 99)
		yields: 'abc'! !

!MDUtf8MaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/17/2008 01:07'!
testLatin
	self
		assert: #(15 9 3 195 161 98 99)
		yields: 'bc'! !

TestCase subclass: #MDPropertyDictionaryTest
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDPropertyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:10'!
setUp
	properties := MDPropertyDictionary new.! !

!MDPropertyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2005 20:32'!
testGetNil
	self assert: (properties at: #undefined) isNil! !

!MDPropertyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2005 20:29'!
testImplicitGet
	properties at: #one put: 1.
	self assert: properties one = 1! !

!MDPropertyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2005 20:28'!
testImplicitPut
	properties one: 1.
	self assert: (properties at: #one) = 1! !

!MDPropertyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2005 20:30'!
testPutNil
	properties at: #undefined put: nil.
	self assert: properties isEmpty! !

TestCase subclass: #MDRegistryTest
	instanceVariableNames: 'registry slice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDRegistryTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:10'!
setUp
	registry := MDRegistry new.
	slice := MDExplicitSlice new.
! !

!MDRegistryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 21:58'!
testIncludesId
	registry register: slice.
	self assert: (registry includesId: slice id)! !

!MDRegistryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 21:58'!
testObjectWithIdSatsifies
	registry register: slice.
	self assert: (registry objectWithId: slice id satisfies: [:o | o == slice]) ! !

!MDRegistryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 21:58'!
testRegistration
	registry register: slice.
	self assert: (registry objectWithId: slice id) == slice ! !

!MDRegistryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 21:58'!
testRemoval
	registry register: slice.
	registry unregisterId: slice id.
	self assert: registry objects isEmpty! !

!MDRegistryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:37'!
testRemoveId
	registry register: slice.
	registry unregisterId: slice id.
	self assert: registry objects isEmpty! !

!MDRegistryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:37'!
testUnregister
	registry register: slice.
	registry unregister: slice.
	self assert: registry objects isEmpty! !

TestCase subclass: #MDReplicatorTest
	instanceVariableNames: 'source dest replicator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDReplicatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 21:00'!
assertDestIncludesMemo: memo 
	| snapshot |
	self assert: (dest memos includes: memo).
	self assert: (dest allHashstamps includes: memo reference).
	snapshot := dest get: memo reference.
	self assert: (dest allHashstamps includesAllOf: snapshot contents)! !

!MDReplicatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 20:57'!
buildSource: aSymbol 
	| versions builder snapshot memo properties |
	builder := MDTestBuilder new.
	versions := #(#alpha #beta #gamma ) collect: 
		[ :letter | 
		| v |
		v := builder 
			versionFor: letter
			with: letter.
		source put: v.
		v ].
	snapshot := MDSnapshot withVersions: versions.
	source put: snapshot.
	properties := MDPropertyDictionary new.
	properties tag: aSymbol.
	memo := MDMemo 
		parents: Set new
		properties: properties.
	memo 
		setSnapshot: snapshot
		slice: builder slice.
	source put: memo! !

!MDReplicatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 20:56'!
setUp
	source := MDMemoryRepository new.
	dest := MDMemoryRepository new.
	replicator := MDReplicator 
		from: source
		to: dest.
	self buildSource: #one! !

!MDReplicatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 20:52'!
testCopyAll
	replicator copyAll.
	self assert: (dest selectFrom: source allHashstamps) isEmpty! !

!MDReplicatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 20:54'!
testCopyAllReferenced
	| version |
	version := MDTestBuilder new 
		versionFor: #zappa
		with: #fribbitz.
	source put: version.
	replicator copyAll.
	self deny: (dest includes: version)! !

!MDReplicatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/10/2008 22:15'!
testCopyMemo
	| memo |
	memo := source memos anyOne.
	replicator copyMemo: memo.
	self assertDestIncludesMemo: memo! !

!MDReplicatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 21:03'!
testReject
	| memo |
	self buildSource: #two.
	replicator reject: [:ea | ea properties tag = #two].
	self assert: dest memos size = 1.
	memo := dest memos anyOne.
	self assert: memo properties tag = #one.
	self assertDestIncludesMemo: memo! !

!MDReplicatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 21:02'!
testSelect
	| memo |
	self buildSource: #two.
	replicator select: [:ea | ea properties tag = #two].
	self assert: dest memos size = 1.
	memo := dest memos anyOne.
	self assert: memo properties tag = #two.
	self assertDestIncludesMemo: memo! !

TestCase subclass: #MDRepositoryTest
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

MDRepositoryTest subclass: #MDMemoryRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDMemoryRepositoryTest methodsFor: 'constructing' stamp: 'avi 3/12/2005 02:39'!
assert: anElementVersion isEquivalentTo: otherElementVersion
	^ anElementVersion == otherElementVersion! !

!MDMemoryRepositoryTest methodsFor: 'constructing' stamp: 'cwp 5/24/2008 13:07'!
newRepository
	^ MDMemoryRepository named: 'test'! !

!MDMemoryRepositoryTest methodsFor: 'tests' stamp: 'cwp 5/31/2008 22:42'!
testLoad
	| properties |
	properties := MDPropertyDictionary new
		name: 'renamed';
		type: #Memory;
		yourself.
	repository properties: properties.
	self assert: repository name = 'renamed'! !

!MDMemoryRepositoryTest methodsFor: 'tests' stamp: 'cwp 10/19/2009 02:23'!
testProperties
	| properties |
	properties := repository properties.
	self assert: properties name = 'test'! !

!MDRepositoryTest class methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2005 00:46'!
isAbstract
	^ self name = #MDRepositoryTest! !

!MDRepositoryTest methodsFor: 'asserting' stamp: 'cwp 7/27/2008 15:28'!
assert: anElementVersion isEquivalentTo: otherElementVersion
	self assert: (MDMarshal serialize: anElementVersion) = (MDMarshal serialize: otherElementVersion)! !

!MDRepositoryTest methodsFor: 'constructing' stamp: 'cwp 5/22/2008 00:10'!
memo
	| memo |
	memo := MDMemo new.
	memo setSnapshot: self snapshot slice: self slice.
	^ memo! !

!MDRepositoryTest methodsFor: 'constructing' stamp: 'avi 3/12/2005 00:45'!
newRepository
	self subclassResponsibility! !

!MDRepositoryTest methodsFor: 'constructing' stamp: 'cwp 12/23/2007 00:09'!
secondRepository
	^ self newRepository! !

!MDRepositoryTest methodsFor: 'running' stamp: 'cwp 5/22/2008 00:10'!
setUp
	repository := self newRepository! !

!MDRepositoryTest methodsFor: 'constructing' stamp: 'cwp 1/19/2007 22:31'!
slice
	^ MDExplicitSlice named: 'Test Slice'! !

!MDRepositoryTest methodsFor: 'constructing' stamp: 'cwp 3/23/2005 22:53'!
snapshot
	^ MDSnapshot withVersions: (Set with: self version)! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testGetUnknownVersion
	| snapshot |
	snapshot := self snapshot.
	self assert: (repository get: snapshot hashstamp) isNil! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 5/24/2008 13:06'!
testId
	self assert: (repository id isKindOf: MDHashstamp)! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testMemos
	| memo memos |
	
	memo := self memo.
	repository put: memo.
	
	memos :=  repository memos.
	
	self assert: memos size = 1.
	self assert: (memos anyOne = memo).
! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testPush
	| other version |
	other := self secondRepository.
	version := self version.
	repository put: version.
	repository pushTo: other.
	self assert: (other includes: version hashstamp)! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testStoreSnapshot
	| snapshot |
	snapshot := self snapshot.
	repository put: snapshot.
	self assert: (repository get: snapshot hashstamp) isEquivalentTo: snapshot! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testStoreVersion
	| version |
	version := self version.
	repository put: version.
	self assert: (repository get: version hashstamp) isEquivalentTo: version! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testSynchronizeWith
	| versionOne versionTwo other |
	versionOne := self version.
	repository put: versionOne.
	
	other := self secondRepository.
	versionTwo := self version.
	other put: versionTwo.
	
	repository synchronizeWith: other.
	
	self assert: (repository includes: versionTwo hashstamp).
	self assert: (other includes: versionOne hashstamp)! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 5/24/2008 13:06'!
testTimestamp
	self assert: (repository id timestamp isKindOf: MDTimestamp)! !

!MDRepositoryTest methodsFor: 'constructing' stamp: 'dc 6/21/2007 18:31'!
version
	^ (MDFakeElement named: #Alpha) newElementVersion! !

MDRepositoryTest subclass: #MDStoreTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDStoreTest methodsFor: 'construction' stamp: 'cwp 3/13/2005 00:33'!
newRepository
	^ MDStore new
		addRepository: MDMemoryRepository new;
		addRepository: MDMemoryRepository new;
		yourself! !

!MDStoreTest methodsFor: 'tests' stamp: 'cwp 5/31/2008 22:50'!
testLoad
	self 
		shouldnt:[repository properties: MDPropertyDictionary new]
		raise: Error! !

!MDStoreTest methodsFor: 'tests' stamp: 'cwp 3/10/2008 20:17'!
testMemoDuplication
	| store griffle plonk memo1 memo2 |
	store := MDStore new.
	griffle := MDMemoryRepository new.
	plonk := MDMemoryRepository new.
	store
		addRepository: griffle;
		addRepository: plonk.
		
	memo1 := MDMemo
				snapshot: (MDSnapshot withVersions: #())
				slice: (MDExplicitSlice named: 'test')
				parents: #()
				properties: MDPropertyDictionary new.
	memo2 := MDMarshal materialize: (MDMarshal serialize: memo1).
	
	griffle put: memo1.
	plonk put: memo2.
	
	self assert: store memos size = 1! !

!MDStoreTest methodsFor: 'tests' stamp: 'cwp 10/19/2009 02:22'!
testProperties
	| properties |
	properties := repository properties.
	self assert: properties name = 'store'.
! !

!MDStoreTest methodsFor: 'tests' stamp: 'cwp 3/12/2005 22:56'!
testSingleton
	self assert: MDStore default == MDStore default! !

TestCase subclass: #MDSerializationBytesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSerializationBytesTest methodsFor: 'asserting' stamp: 'cwp 11/15/2008 12:59'!
assert: anObject serializesTo: anArray 
	| expected actual |
	actual := MDSerializer serialize: anObject.
	expected := anArray asByteArray.
	self assert: actual = expected! !

!MDSerializationBytesTest methodsFor: 'running' stamp: 'cwp 11/15/2008 13:00'!
setUp
	super setUp.
	MDMaterializer initializeTypes! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 18:50'!
testArray
	self 
		assert: #(1 2 3 )
		serializesTo: #(17 9 3 9 1 9 2 9 3)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 18:50'!
testBytesObject
	self 
		assert: #(1 2 3 ) asByteArray
		serializesTo: #(1 4 14 9 9 66 121 116 101 65 114 114 97 121 9 0 9 3 1 2 3)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 21:41'!
testClass
	self 
		assert: self class
		serializesTo: #(2 14 9 24 77 68 83 101 114 105 97 108 
					105 122 97 116 105 111 110 66 121 116 
					101 115 84 101 115 116 9 1 15 9 12 116 
					101 115 116 83 101 108 101 99 116 111 114)
		! !

!MDSerializationBytesTest methodsFor: 'tests - smalltalk' stamp: 'cwp 11/12/2008 18:50'!
testClassCommentElement
	self 
		assert: (MDClassCommentElement className: #MDBogusA)
		serializesTo: #(1 5 9 10 14 9 8 77 68 66 111 103 117 115 65)! !

!MDSerializationBytesTest methodsFor: 'tests - smalltalk' stamp: 'cwp 11/12/2008 18:50'!
testClassElement
	self 
		assert: (MDClassElement className: #MDBogusA)
		serializesTo: #(1 5 9 9 14 9 8 77 68 66 111 103 117 115 65)! !

!MDSerializationBytesTest methodsFor: 'tests - smalltalk' stamp: 'cwp 11/12/2008 18:51'!
testClassInstVarElement
	self 
		assert: (MDClassInstVarElement 
				className: #MDBogusA
				name: 'beth')
		serializesTo: #(1 5 9 13 14 9 8 77 68 66 111 103 117 115 65 15 9 4 98 101 116 104)! !

!MDSerializationBytesTest methodsFor: 'tests - smalltalk' stamp: 'cwp 11/12/2008 18:51'!
testClassMethodElement
	| element |
	element := MDMethodElement 
		className: #MDBogusA
		selector: #one
		classIsMeta: true.
	self 
		assert: element
		serializesTo: #(1 5 9 15 14 9 8 77 68 66 111 103 117 115 65 14 9 3 111 110 101 7)! !

!MDSerializationBytesTest methodsFor: 'tests - smalltalk' stamp: 'cwp 11/12/2008 18:51'!
testClassVarElement
	self 
		assert: (MDClassVarElement className: #MDBogusA name: 'Alpha')
		serializesTo: #(1 5 9 12 14 9 8 77 68 66 111 103 117 115 65 15 9 5 65 108 112 104 97)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 18:52'!
testDictionary
	| dict |
	dict := Dictionary new
		at: #a put: 1;
		at: #b put: 2;
		yourself.
	self 
		assert: dict
		serializesTo: #(19 9 2 14 9 1 97 9 1 14 9 1 98 9 2)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 20:06'!
testElementDefinition
	| definition |
	definition := MDTestBuilder new definition.
 	self assert: definition serializesTo: #(1 5 9 2 1 5 9 8 14 9 5 65 108 112 104 97 20 9 0)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:02'!
testElementRemoval
| removal |
	removal := MDTestBuilder new removal.
	self assert: removal serializesTo: #(1 5 9 3 1 5 9 8 14 9 5 65 108 112 104 97)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:03'!
testFakeElement
| element |
	element := MDTestBuilder new element.
	self assert: element serializesTo: #(1 5 9 8 14 9 5 65 108 112 104 97)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:04'!
testFalse
	self assert: false serializesTo: #(8)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 8/9/2009 01:14'!
testHashstamp
	| hashstamp |
	hashstamp := MDHashstamp 
		tag: #(125 157 216 208 156 108 194 80 120 113 37 62 186 106 129 6 71 54 62) asByteArray
		timestamp: (MDTimestamp fromInteger: 905800829).
	self 
		assert: hashstamp 
		serializesTo: #(22 53 253 108 125 125 157 216 208 156 108 194 80 120 113 37 62 186 106 129 6 71 54 62 31)! !

!MDSerializationBytesTest methodsFor: 'tests - smalltalk' stamp: 'cwp 11/12/2008 19:06'!
testInstVarElement
	| element |
	element := MDInstVarElement className: #MDBogusA name: 'one'.
	self assert: element serializesTo: #(1 5 9 11 14 9 8 77 68 66 111 103 117 115 65 15 9 3 111 110 101)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:07'!
testLongString
	| string |
	string := String new: 300.
	string atAllPut: $a.

	self 
		assert: string 
		serializesTo: #(15 10 1 44 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 
					97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 
					97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 
					97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 
					97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 
					97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 
					97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 
					97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97
					97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 
					97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 
					97 97 97 97 97 97 97 97 97 97 97 97 97 97)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 8/9/2009 01:24'!
testMemo
	| memo |
	memo := MDTestBuilder new memo.
	memo instVarAt: 1 put: (MDHashstamp fromString: 'BTpiEUqnmCG0M-vpGmAqClg7Epiwyh+k').
	memo instVarAt: 2 put: (MDHashstamp fromString: 'BTpifCLy1McVFvfIDx7ZkWv5YA5quh3d').
	memo instVarAt: 5 put: (MDHashstamp fromString: 'Bq-Yoy3kfy4i+GisbhjJr6tIIPB7lHFr').
	MDSerializer serialize: memo.
	self 
		assert: memo 
		serializesTo: #(23 5 9 7 22 53 253 110 66 13 179 200 228 130 96 30 245 75 35 54 59 27 9 67 91 
					188 250 208 48 22 53 253 110 172 229 254 13 138 33 71 186 212 63 210 101 194 46 
					199 144 193 246 234 209 105 18 9 0 20 9 2 14 9 2 105 100 14 9 3 97 98 99 14 9 9 
					115 108 105 99 101 78 97 109 101 15 9 9 84 101 115 116 83 108 105 99 101 22 55 96
					100 211 225 112 175 225 174 1 43 184 158 219 213 220 142 84 81 179 73 197 52 119)! !

!MDSerializationBytesTest methodsFor: 'tests - smalltalk' stamp: 'cwp 11/12/2008 19:11'!
testMethodElement
	| element |
	element := MDMethodElement className: #MDBogusA selector: #one.
	self
		assert: element
		serializesTo: #(1 5 9 15 14 9 8 77 68 66 111 103 117 115 65 14 9 3 111 110 101 8)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:12'!
testMultiString
	| ws |
	ws := MDPlatform current wideString.
	self assert: ws serializesTo: #(16 9 3 0 97 0 98 0 99)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:13'!
testNegativeLargeInteger
	self
		assert: SmallInteger minVal - 1
		serializesTo: #(13 9 4 64 0 0 1)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:15'!
testNegativeOneByteInteger
	self
		assert: -3
		serializesTo: #(11 0 3)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:16'!
testNegativeTwoByteInteger
	self 
		assert: -300
		serializesTo: #(11 1 44)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:16'!
testNil
	self assert: nil serializesTo: #(6)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:17'!
testOneByteInteger
	self assert: 7 serializesTo: #(9 7)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:18'!
testPointersObject
	| object |
	object := MDPlatform current variablePointersObject.
	self 
		assert: object 
		serializesTo: #(1 3 14 9 14 65 99 116 105 111 110 83 
					101 113 117 101 110 99 101 9 0 9 2 14 9 
					1 97 14 9 1 98)! !

!MDSerializationBytesTest methodsFor: 'tests - smalltalk' stamp: 'cwp 11/12/2008 19:33'!
testPoolImportElement
| element |
	element := MDPoolImportElement 
		className: #MDBogusA
		name: #MDBogusPoolA.
	self
		assert: element
		serializesTo: #(1 5 9 14 14 9 8 77 68 66 111 103 117 115 
					65 14 9 12 77 68 66 111 103 117 115 80 111 
					111 108 65)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:34'!
testPositiveLargeInteger
	self
		assert: SmallInteger maxVal + 1
		serializesTo: #(12 9 4 64 0 0 0)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:37'!
testPropertyDictionary
	| properties |
	properties := MDPropertyDictionary new
		first: 1;
		second: 'two';
		yourself.

	self
		assert: properties
		serializesTo: #(20 9 2 14 9 5 102 105 114 115 116 9 1 
					14 9 6 115 101 99 111 110 100 15 9 3 116 
					119 111)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:38'!
testSet
	self
		assert: #(1 2 3) asSet
		serializesTo: #(18 9 3 9 1 9 2 9 3)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'jf 9/6/2009 13:44'!
testSliceElement
| element |
	element := MDSliceElement 
		id: (MDHashstamp fromString: 'Bq-ZYEPFlgGUuIsEFFkb-TDVFkUHkOWs').
	self
		assert: element
		serializesTo: #(1 5 9 1 22 55 96 101 145 6 209 198 196 160 233 78 16 69 28 39 5 243 225 71 8 19 193 168 184)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:47'!
testSnapshot
| contents snapshot |
	contents := #('BTploHISPGtEjxw7iNSRzI4sPrBSpkcx' 'BTploIM6Z+ffONzz9IfyCOaH7I8zZPk-') 
		collect: [:ea | MDHashstamp fromString: ea].
	snapshot := MDSnapshot new.
	snapshot instVarAt: 1 put: (MDTimestamp fromInteger: 905802042).
	snapshot instVarAt: 2 put: contents.

	self 
		assert: snapshot
		serializesTo: #(23 5 9 6 21 53 253 113 58 17 9 2 22 53 253 113 209 53 30 109 46 80 
					191 223 9 185 151 157 253 65 184 111 115 94 215 10 61 22 53 253 113 
					209 70 8 148 10 235 105 159 255 45 74 254 57 169 147 37 66 191 149 188 1)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:53'!
testString
	self
		assert: 'abc'
		serializesTo: #(15 9 3 97 98 99)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/17/2008 01:07'!
testStringWithAccent
	self
		assert: 'bc'
		serializesTo: #(15 9 3 195 161 98 99)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:54'!
testSymbol
	self assert: #one serializesTo: #(14 9 3 111 110 101)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:55'!
testThreeByteInteger
	| number |
	number := (2 raisedTo: 16) + 1.
	self
		assert: number
		serializesTo: #(12 9 3 1 0 1)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:58'!
testTimestamp
	| ts |
	ts := MDTimestamp fromInteger: 905803057.
	self assert: ts serializesTo: #(21 53 253 117 49)	! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:59'!
testTrue
	self assert: true serializesTo: #(7)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 20:00'!
testTwoByteInteger
	self assert: 355 serializesTo: #(10 1 99)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 20:04'!
testVersion
	| version |
	version := MDTestBuilder new version.
	version instVarAt: 1 put: (MDTimestamp fromInteger: 905803456).
	self 
		assert: version
		serializesTo: #(23 5 9 5 21 53 253 118 192 1 5 9 2 1 5 9 8 14 9 
					5 65 108 112 104 97 20 9 0 18 9 0)! !

TestCase subclass: #MDSerializationClassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSerializationClassTest commentStamp: 'cwp 4/19/2008 14:31' prior: 0!
This suite of tests ensures that well-known classes are serialized using these class ids:

	    -- core --
	 1  MDSliceElement
	 2  MDDefinitionVariant
	 3  MDRemovalVariant
	 4  MDNullVersion
	 5  MDElementVersion
	 6  MDSnapshot
	 7  MDMemo

	     -- testing --
	 8  MDFakeElement

	    -- smalltalk --
	 9  MDClassElement
	10  MDClassCommentElement
	11  MDInstVarElement
	12  MDClassVarElement
	13  MDClassInstVarElement
	14  MDMethodElement

!

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 14:22'!
assert: anObject hasClassId: anInteger
	| bytes |
	bytes := MDMarshal serialize: anObject.
	self assert: (#(1 23) includes: bytes first).	"type object"
	self assert: bytes second = 5.					"well-known class"
	self assert: bytes third = 9.					"byte integer"
	self assert: bytes fourth = anInteger! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 11:16'!
test01SliceElement
	self 
		assert: MDSliceElement new
		hasClassId: 1! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 14:16'!
test02DefinitionVariant
	self 
		assert: MDDefinitionVariant new
		hasClassId: 2! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 14:17'!
test03RemovalVariant
	self 
		assert: MDRemovalVariant new
		hasClassId: 3! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 14:17'!
test04NullVersion
	self 
		assert: MDNullVersion new
		hasClassId: 4! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 14:23'!
test05ElementVersion
	self 
		assert: MDElementVersion new
		hasClassId: 5! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 14:23'!
test06Snapshot
	self 
		assert: MDSnapshot new
		hasClassId: 6! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 14:24'!
test07Memo
	self 
		assert: MDMemo new
		hasClassId: 7! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 14:25'!
test08FakeElement
	self 
		assert: MDFakeElement new
		hasClassId: 8! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 14:26'!
test09ClassElement
	self 
		assert: MDClassElement new
		hasClassId: 9! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 14:28'!
test10ClassCommentElement
	self 
		assert: MDClassCommentElement new
		hasClassId: 10! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 14:28'!
test11InstVarElement
	self 
		assert: MDInstVarElement new
		hasClassId: 11! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 14:28'!
test12ClassVarElement
	self 
		assert: MDClassVarElement new
		hasClassId: 12! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 14:29'!
test13ClassInstVarElement
	self 
		assert: MDClassInstVarElement new
		hasClassId: 13! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/30/2008 07:00'!
test14PoolImportElement
	self 
		assert: MDPoolImportElement new
		hasClassId: 14! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/30/2008 06:59'!
test15MethodElement
	self 
		assert: MDMethodElement new
		hasClassId: 15! !

TestCase subclass: #MDSerializationTypeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSerializationTypeTest commentStamp: 'cwp 4/19/2008 12:04' prior: 0!
Here's the type specifications that this class enforces:

     1  object
     2  class (fixed)
     3  class (pointers)
     4  class (bytes)
     5  class (well-known)
     6  nil
     7  true
     8  false
     9  8 bit unsigned integer
    10  small positive integer
    11  small negative integer
    12  large positive integer
    13  large negative integer
    14  symbol (utf-8)
    15  string (utf-8)
    16  string (utf-16be)
    17  array
    18  set
    19  dictionary
    20  properties
    21  timestamp
    22  hashstamp
    23  hashed object!

!MDSerializationTypeTest methodsFor: 'asserting' stamp: 'cwp 3/1/2008 22:57'!
assertObject: anObject hasType: anInteger
	| bytes |
	bytes := MDMarshal serialize: anObject.
	self assert: bytes first = anInteger! !

!MDSerializationTypeTest methodsFor: 'running' stamp: 'cwp 4/8/2008 20:11'!
setUp
	super setUp.
	MDMarshal resetMap! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 3/2/2008 13:28'!
test01Object
	self assertObject: self hasType: 1! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 3/2/2008 13:28'!
test02FixedClass
	self assertObject: self class hasType: 2! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 3/2/2008 13:29'!
test03PointersClass
	self 
		assertObject: MDPlatform current variablePointersObject class
		hasType: 3! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 3/2/2008 13:30'!
test04BytesClass
	self 
		assertObject: ByteArray
		hasType: 4! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 12:01'!
test05WellKnownClass
	self 
		assertObject: MDElementVersion
		hasType: 5! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:14'!
test06Nil
	self assertObject: nil hasType: 6! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:14'!
test07True
	self assertObject: true hasType: 7! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:14'!
test08False
	self assertObject: false hasType: 8! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:14'!
test09ByteInteger
	self assertObject: 3 hasType: 9! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:14'!
test10SmallPostiveInteger
	self assertObject: 355 hasType: 10! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:13'!
test11SmallNegativeInteger
	self assertObject: -300 hasType: 11! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:13'!
test12LargePositiveInteger
	self assertObject: SmallInteger maxVal + 1 hasType: 12! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:21'!
test13LargeNegativeInteger
	self assertObject: SmallInteger minVal - 1 hasType: 13! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:13'!
test14Symbol
	self assertObject: #testSymbol hasType: 14! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:13'!
test15Utf8String
	self assertObject: 'abc' hasType: 15! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 6/23/2008 08:42'!
test16Utf16String
	self 
		assertObject: (MDPlatform current wideString) 
		hasType: 16! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:12'!
test17Array
	self
		assertObject: Array new
		hasType: 17! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:12'!
test18Set
	self
		assertObject: Set new
		hasType: 18! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:12'!
test19Dictionary
	self
		assertObject: Dictionary new
		hasType: 19! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:11'!
test20Properties
	self
		assertObject: MDPropertyDictionary new
		hasType: 20! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:11'!
test21Timestamp
	self
		assertObject: MDTimestamp now
		hasType: 21! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:11'!
test22Hashstamp
	self
		assertObject: (MDHashstamp fromString: 'AbjG2m8xWqxTBPAOm0Sq4bCsci7JbfKX')
		hasType: 22! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:11'!
test23HashedObject
	self
		assertObject: (MDSnapshot withVersions: Set new)
		hasType: 23! !

TestCase subclass: #MDSerializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSerializerTest class methodsFor: 'as yet unclassified' stamp: 'cwp 4/16/2008 22:06'!
isAbstract
	^ self name = #MDSerializerTest! !

!MDSerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/15/2008 23:49'!
assert: actual equals: expected
	| limit |
	limit := actual size min: expected size.
	1 to: limit do: [:index | self assert: (actual at: index) = (expected at: index)].
	self assert: actual size = expected size! !

!MDSerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/15/2008 12:19'!
assert: anObject yields: expected 
	| stream actual |
	stream := ByteArray new writeStream.
	self serialize: anObject on: stream.
	actual := stream contents.
	self 
		assert: actual
		equals: expected! !

MDSerializerTest subclass: #MDUtf16SerializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDUtf16SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/15/2008 12:19'!
serialize: anObject on: aStream
	| serializer |
	serializer := MDSerializer on: aStream.
	serializer serializeUtf16String: anObject.! !

!MDUtf16SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 12:10'!
serializer
	^ MDUtf16Serializer type: 16! !

!MDUtf16SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/23/2008 08:57'!
testAboriginal
	self 
		assert: MDPlatform current aboriginalAbc
		yields: #(16 9 3 20 1 20 2 20 3)! !

!MDUtf16SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 12:05'!
testAscii
	self 
		assert: 'abc' 
		yields: #(16 9 3 0 97 0 98 0 99)! !

!MDUtf16SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/17/2008 01:07'!
testLatin
	self 
		assert: 'bc' 
		yields: #(16 9 3 0 225 0 98 0 99)
	! !

MDSerializerTest subclass: #MDUtf8SerializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDUtf8SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/15/2008 12:20'!
serialize: anObject on: aStream
	| serializer |
	serializer := MDSerializer on: aStream.
	serializer serializeUtf8String: anObject.! !

!MDUtf8SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 12:09'!
serializer
	^ MDUtf8Serializer type: 15! !

!MDUtf8SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/23/2008 08:57'!
testAboriginal
	self 
		assert: MDPlatform current aboriginalAbc
		yields: #(15 9 3 225 144 129 225 144 130 225 144 131)! !

!MDUtf8SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 12:06'!
testAscii
	self assert: 'abc' yields: #(15 9 3 97 98 99)! !

!MDUtf8SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/17/2008 01:07'!
testLatin
	self assert: 'bc' yields: #(15 9 3 195 161 98 99)! !

TestCase subclass: #MDSliceTest
	instanceVariableNames: 'slice elements environment domain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSliceTest commentStamp: 'cwp 8/29/2005 00:40' prior: 0!
This comment needs to be here, or #testComment won't pass.!

!MDSliceTest class methodsFor: 'testing' stamp: 'cwp 3/16/2005 01:05'!
isAbstract
	^ self name = #MDSliceTest! !

!MDSliceTest class methodsFor: 'testing' stamp: 'cwp 3/16/2005 01:05'!
shouldInheritSelectors
	^ true! !

!MDSliceTest methodsFor: 'asserting' stamp: 'dc 6/26/2007 21:48'!
assertAllOf: expectedLabels butNoneOf: forbiddenLabels as: aBlock 
	self assertAllOf: expectedLabels butNoneOf: forbiddenLabels enumeratedAs: aBlock.
	self assertAllOf: expectedLabels butNoneOf: forbiddenLabels includedAs: aBlock.! !

!MDSliceTest methodsFor: 'asserting' stamp: 'cwp 5/22/2008 00:10'!
assertAllOf: expectedLabels butNoneOf: forbiddenLabels enumeratedAs: aBlock 
	| expected forbidden |
	expected := expectedLabels collect: aBlock.
	forbidden := forbiddenLabels collect: aBlock.
	elements := slice elements.
	self assert: (elements includesAllOf: expected).
	self deny: (elements includesAnyOf: forbidden)! !

!MDSliceTest methodsFor: 'asserting' stamp: 'cwp 3/3/2006 11:28'!
assertAllOf: expectedLabels butNoneOf: forbiddenLabels includedAs: aBlock 
	| expected forbidden |
	expected := expectedLabels collect: aBlock.
	expected do: [:ea | self assert: (slice includes: ea)].

	forbidden := forbiddenLabels collect: aBlock.
	forbidden do: [:ea | self deny: (slice includes: ea)]! !

!MDSliceTest methodsFor: 'accessing' stamp: 'jf 10/21/2009 16:02'!
domain
	^ domain ifNil: [ domain := MDMonticelloDomain on: self environment ]! !

!MDSliceTest methodsFor: 'accessing' stamp: 'jf 10/21/2009 15:56'!
environment
	^ environment ifNil: [ environment := MDEnvironment forTesting ]! !

!MDSliceTest methodsFor: 'running' stamp: 'jf 10/21/2009 16:37'!
setUp
	slice := self environment addSlice: self createSlice! !

!MDSliceTest methodsFor: 'accessing' stamp: 'jf 10/21/2009 16:08'!
sliceProperties
	^ (slice asElement adaptedFor: self domain) properties! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 1/19/2007 22:59'!
testId
	self assert: (slice id isKindOf: MDHashstamp)! !

MDSliceTest subclass: #MDSmalltalkSliceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

MDSmalltalkSliceTest subclass: #MDChangeSetSliceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDChangeSetSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:10'!
createSlice
	| changeset |
	changeset := ChangeSet basicNewNamed: 'test'.
	changeset
		atClass: #MDBogusA add: #comment;
		atClass: #MDSliceTest add: #comment;
		changeClass: MDBogusA from: MDBogusA;
		changeClass: MDBogusA class from: MDBogusA class;
		noteNewMethod: nil forClass: MDSliceTest selector: #classes priorMethod: nil;
		noteNewMethod: nil forClass: MDSliceTest selector: #methods priorMethod: nil;
		noteNewMethod: nil forClass: MDSliceTest class selector: #bogusMethodA priorMethod: nil;
		noteNewMethod: nil forClass: MDSliceTest class selector: #bogusMethodB priorMethod: nil.
	^ MDChangeSetSlice on: changeset! !

!MDChangeSetSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/28/2008 21:49'!
testName
	self assert: slice name = 'test'! !

!MDChangeSetSliceTest methodsFor: 'as yet unclassified' stamp: 'jf 10/21/2009 16:05'!
testProperties
	| properties |
	properties := self sliceProperties.
	self assert: properties name = 'test'.
	! !

MDSmalltalkSliceTest subclass: #MDExplicitSliceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDExplicitSliceTest methodsFor: 'constucting' stamp: 'cwp 10/2/2008 20:24'!
createSlice
	^ (MDExplicitSlice named: 'TestSlice')
		addElement: (MDClassElement className: #MDBogusA);
		addElement: (MDClassElement className: #MDSliceTest);
		addElement: (MDClassCommentElement className: #MDBogusA);
		addElement: (MDClassCommentElement className: #MDSliceTest);
		addElement: (MDMethodElement 
				className: #MDSliceTest
				selector: #classes);
		addElement: (MDMethodElement 
				className: #MDSliceTest
				selector: #methods);
		addElement: (MDMethodElement 
				className: #MDSliceTest
				selector: #bogusMethodA
				classIsMeta: true);
		addElement: (MDMethodElement 
				className: #MDSliceTest
				selector: #bogusMethodB
				classIsMeta: true);
		addElement: (MDInstVarElement 
				className: #MDBogusA
				name: 'one');
		addElement: (MDClassVarElement 
				className: #MDBogusA
				name: 'MDAlpha');
		addElement: (MDClassInstVarElement 
				className: #MDBogusA
				name: 'aleph');
		addElement: (MDPoolImportElement 
				className: #MDBogusA
				name: 'MDBogusPoolA');
		addElement: (MDPoolImportElement 
				className: #MDBogusA
				name: 'TextConstants');
		yourself! !

!MDExplicitSliceTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:04'!
testProperties
	| properties |
	properties := self sliceProperties.
	self assert: properties name = 'TestSlice'.
	self assert: properties elements = slice elements! !

!MDSmalltalkSliceTest class methodsFor: 'as yet unclassified' stamp: 'cwp 6/5/2008 07:21'!
isAbstract
	^ self name = #MDSmalltalkSliceTest! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 6/14/2008 12:51'!
testClassInstVarClasses
	self 
		assertAllOf: #(MDBogusA)
		butNoneOf: #(MDNonexistentClass)
		as: [:name | MDClassInstVarElement 
								className: name 
								name: #aleph]. 
		
! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 6/1/2008 23:03'!
testClassInstVars
	self 
		assertAllOf: #(aleph)
		butNoneOf: #(doesntexist)
		as: [:name | MDClassInstVarElement 
								className: #MDBogusA 
								name: name]. 
		
! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 6/14/2008 12:54'!
testClassMethodClasses
	self 
		assertAllOf: #(MDSliceTest)
		butNoneOf: #(MDNonexistentClass)
		as: 
			[:name | 
			MDMethodElement 
				className: name
				selector: #bogusMethodA
				classIsMeta: true]! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 6/1/2008 23:03'!
testClassMethods
	self 
		assertAllOf: #(#bogusMethodA #bogusMethodB )
		butNoneOf: #(#methodDoesntExist )
		as: 
			[:sel | 
			MDMethodElement 
				className: #MDSliceTest
				selector: sel
				classIsMeta: true]! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 10/2/2008 20:22'!
testClassVarClasses
	self 
		assertAllOf: #(MDBogusA)
		butNoneOf: #(MDNonexistentClass)
		as: [:name | MDClassVarElement className: name name: #MDAlpha]! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 10/2/2008 20:22'!
testClassVars
	self 
		assertAllOf: #('MDAlpha' )
		butNoneOf: #('DoesntExist' )
		as: [:name | MDClassVarElement className: #MDBogusA name: name]! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 6/14/2008 12:41'!
testClasses
	self 
		assertAllOf: #(#MDBogusA #MDSliceTest )
		butNoneOf: #(#MDNonexistentClass)
		as: [:name | MDClassElement className: name]! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 6/14/2008 12:54'!
testComments
	self 
		assertAllOf: #(#MDSliceTest )
		butNoneOf: #(#MDNonexistentClass)
		as: [:name | MDClassCommentElement className: name]! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 6/1/2008 23:03'!
testIncludedComments
	self 
		assertAllOf: #(MDBogusA MDSliceTest)
		butNoneOf: #(Object)
		includedAs: [:name | MDClassCommentElement className: name]! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 6/14/2008 12:46'!
testInstVarClasses
	self 
		assertAllOf: #(MDBogusA)
		butNoneOf: #(MDNonexistentClass)
		as: [:name | MDInstVarElement className: name name: 'one']! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 6/1/2008 23:03'!
testInstVars
	self 
		assertAllOf: #('one' )
		butNoneOf: #('doesntexist' )
		as: [:name | MDInstVarElement className: #MDBogusA name: name]! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 6/14/2008 12:56'!
testMethodClasses
	self 
		assertAllOf: #(MDSliceTest)
		butNoneOf: #(MDNonexistentClass)
		as: [:name | MDMethodElement className: name selector: #classes]! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 6/1/2008 23:03'!
testMethods
	self 
		assertAllOf: #(#classes #methods )
		butNoneOf: #(#methodDoesntExist )
		as: [:sel | MDMethodElement className: #MDSliceTest selector: sel]! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 6/14/2008 12:57'!
testPoolImportClasses
	self 
		assertAllOf: #(MDBogusA)
		butNoneOf: #(MDNonexistentClass)
		as: 
			[ :name | 
			MDPoolImportElement 
				className: name
				name: #MDBogusPoolA ]! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 6/1/2008 23:04'!
testPoolImports
	self 
		assertAllOf: #(#MDBogusPoolA #TextConstants )
		butNoneOf: #(#PoolDoesntExist )
		as: 
			[ :name | 
			MDPoolImportElement 
				className: #MDBogusA
				name: name ]! !

MDSmalltalkSliceTest subclass: #MDUnionSliceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDUnionSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/19/2008 18:56'!
createSlice
	^ MDUnionSlice 
		name: 'TestSlice'
		slices: {  (self createSliceA). (self createSliceB)  }! !

!MDUnionSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/3/2008 20:43'!
createSliceA
	^ (MDExplicitSlice named: 'TestSlice')
		addElement: (MDClassElement className: #MDBogusA);
		addElement: (MDClassElement className: #MDSliceTest);
		addElement: (MDClassCommentElement className: #MDBogusA);
		addElement: (MDClassCommentElement className: #MDSliceTest);
		addElement: (MDMethodElement className: #MDSliceTest selector: #classes);
		addElement: (MDMethodElement className: #MDSliceTest selector: #methods);
		addElement: (MDMethodElement 
						className: #MDSliceTest 
						selector: #bogusMethodA 
						classIsMeta: true);
		yourself! !

!MDUnionSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/2/2008 20:25'!
createSliceB
	^ (MDExplicitSlice named: 'TestSlice2')
		addElement: (MDMethodElement 
				className: #MDSliceTest
				selector: #bogusMethodB
				classIsMeta: true);
		addElement: (MDInstVarElement 
				className: #MDBogusA
				name: 'one');
		addElement: (MDClassVarElement 
				className: #MDBogusA
				name: 'MDAlpha');
		addElement: (MDClassInstVarElement 
				className: #MDBogusA
				name: 'aleph');
		addElement: (MDPoolImportElement 
				className: #MDBogusA
				name: 'MDBogusPoolA');
		addElement: (MDPoolImportElement 
				className: #MDBogusA
				name: 'TextConstants');
		yourself! !

!MDUnionSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/14/2008 16:55'!
testIntersectingSlices
	| a b |
	a := (MDExplicitSlice named: 'A')
		addElement: (MDFakeElement named: #x);
		yourself.
	b := (MDExplicitSlice named: 'B')
		addElement: (MDFakeElement named: #x);
		yourself.
	slice := MDUnionSlice 
		name: 'Intersection'
		slices: {  a. b  }.
	elements := Array streamContents: [ :stream | slice elementsDo: [ :ea | stream nextPut: ea ] ].
	self assert: elements size = 1.
	self assert: elements first name = #x! !

!MDUnionSliceTest methodsFor: 'as yet unclassified' stamp: 'jf 10/21/2009 16:05'!
testProperties
	| properties |
	properties := self sliceProperties.
	self assert: properties sliceIds isCollection! !

TestCase subclass: #MDStElementDisplayTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDStElementDisplayTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/22/2008 21:53'!
testClass
	| element string |
	element := MDClassElement className: #MDBogusA.
	string := element printString.
	self assert: string = 'MDBogusA'! !

!MDStElementDisplayTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/22/2008 21:54'!
testClassComment
	| element string |
	element := MDClassCommentElement className: #MDBogusA.
	string := element printString.
	self assert: string = 'MDBogusA comment'! !

!MDStElementDisplayTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/22/2008 21:47'!
testClassInstVar
	| element string |
	element := MDClassInstVarElement 
		className: #MDBogusA
		name: 'one'.
	string := element printString.
	self assert: string = 'MDBogusA: class instance variable ''one'''! !

!MDStElementDisplayTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/22/2008 22:00'!
testClassMethod
	| element string |
	element := MDMethodElement className: #MDBogusA selector: #one classIsMeta: true.
	string := element printString.
	self assert: string = 'MDBogusA class>>one'! !

!MDStElementDisplayTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/22/2008 21:44'!
testClassVar
	| element string |
	element := MDClassVarElement 
		className: #MDBogusA
		name: 'MDAlpha'.
	string := element printString.
	self assert: string = 'MDBogusA: class variable ''MDAlpha'''! !

!MDStElementDisplayTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/22/2008 21:46'!
testInstVar
	| element string |
	element := MDInstVarElement 
		className: #MDBogusA
		name: 'one'.
	string := element printString.
	self assert: string = 'MDBogusA: instance variable ''one'''! !

!MDStElementDisplayTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/22/2008 21:56'!
testMethod
	| element string |
	element := MDMethodElement className: #MDBogusA selector: #one.
	string := element printString.
	self assert: string = 'MDBogusA>>one'! !

!MDStElementDisplayTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/22/2008 21:49'!
testPoolImport
	| element string |
	element := MDPoolImportElement
		className: #MDBogusA
		name: 'one'.
	string := element printString.
	self assert: string = 'MDBogusA: pool import ''one'''! !

TestCase subclass: #MDTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

MDTestCase subclass: #MDAncestryTest
	instanceVariableNames: 'parent child'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDAncestryTest methodsFor: 'constructing' stamp: 'cwp 3/2/2005 23:15'!
null
	^ MDNullVersion forElement: self element! !

!MDAncestryTest methodsFor: 'running' stamp: 'cwp 3/2/2005 22:46'!
setUp
	parent := self version.
	child := self 
				updateVersion: parent
				property: #foo
				put: 'alpha2'! !

!MDAncestryTest methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:55'!
sibling
	^self 
		updateVersion: parent
		property: #bar
		put: 'bar'! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:47'!
testChildConflictsWithParent
	self deny: (child conflictsWith: parent)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:14'!
testChildConflictsWithSibling
	self assert: (child conflictsWith: self sibling)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:47'!
testChildPrecedesParent
	self deny: (child precedes: parent)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:17'!
testChildPreceedsNull
	self deny: (child precedes: self null)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:16'!
testChildSucceedsNull
	self assert: (child succeeds: self null)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:47'!
testChildSucceedsParent
	self assert: (child succeeds: parent)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:18'!
testChildSuccessorNull
	self assert: (child successor: self null onConflict: [:p | self fail]) == child! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:19'!
testChildSuccessorParent
	self assert: (child successor: parent onConflict: [:p | self fail]) == child! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 10/16/2005 14:07'!
testChildSuccessorSibling
	| result merged sibling |
	sibling := self sibling.
	merged := child successor: sibling
				onConflict: 
					[result := self definition.
					result properties at: #merged put: true.
					result].
	self assert: (merged succeeds: child).
	self assert: (merged succeeds: sibling).
	self assert: merged variant properties merged! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:14'!
testNullPrecedesChild
	self assert: (self null precedes: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:16'!
testNullSucceedsChild
	self deny: (self null succeeds: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:18'!
testNullSuccessorChild
	self assert: (child successor: self null onConflict: [:p | self fail]) == child! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:46'!
testParentConflictsWithChild
	self deny: (parent conflictsWith: child).! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:48'!
testParentPrecedesChild
	self assert: (parent precedes: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:48'!
testParentSucceedsChild
	self deny: (parent succeeds: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:19'!
testParentSuccessorChild
	self assert: (parent successor: child onConflict: [:p | self fail]) == child! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:15'!
testSiblingConflictsWithChild
	self assert: (self sibling conflictsWith: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:59'!
testSiblingPreceedsChild
	self deny: (self sibling precedes: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/3/2005 00:00'!
testSiblingSucceedsChild
	self deny: (self sibling succeeds: child)! !

MDTestCase subclass: #MDDomainTest
	instanceVariableNames: 'environment domain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

MDDomainTest subclass: #MDChangeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDChangeTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2009 14:23'!
testAddition
	| change element |
	element := self element.
	self atProperty: #one put: 'beta'.
	change := environment workspace changeForElement: element do: [:v | v].
	self assert: (change version isKindOf: MDNullVersion).
	self assert: change variant element = element.
	self assert: change variant properties one = 'beta'! !

!MDChangeTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2009 14:23'!
testModification
	| version change |
	version := self versionWith: 'alpha'.
	environment workspace loadVersion: version.
	self atProperty: #one put: 'beta'.
	change := environment workspace changeForElement: version element do: [:v | v].
	self assert: change version = version.
	self assert: change variant element = version element.
	self assert: change variant properties one = 'beta'! !

!MDChangeTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2009 14:22'!
testNoChange
	| version change |
	version := self versionWith: 'alpha'.
	environment workspace loadVersion: version.
	change := environment workspace changeForElement: version element do: [:v | self fail].
	self assert: change isNil! !

!MDChangeTest methodsFor: 'as yet unclassified' stamp: 'jf 10/21/2009 16:13'!
testRemoval
	| version change |
	version := self versionWith: 'alpha'.
	environment workspace loadVersion: version.
	domain removeElement: version element.
	change := environment workspace 
		changeForElement: version element
		do: [ :v | v ].
	self assert: change version = version.
	self assert: change variant isRemoval! !

MDDomainTest subclass: #MDDomainOpsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDDomainOpsTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testCurrentDefinition
	| variant |
	self 
		atElement: self element
		property: #one
		put: 1.
	variant := self definition.
	domain updateVariant: variant.
	self assert: (variant properties at: #one) = 1! !

!MDDomainOpsTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testIsLoadable
	| variant |
	variant := self definition.
	variant properties 
		at: #one
		put: 1.
	self assert: (domain isLoadable: variant)! !

!MDDomainOpsTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testLoadAndUpdate
	| original retrieved |
	original := self definition.
	original properties
		at: #one
			put: 1;
		at: #two
			put: 2;
		at: #three
			put: 3.
	domain loadVariant: original.
	retrieved := domain updateVariant: self definition.
	self assert: original properties = retrieved properties! !

!MDDomainOpsTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testLoadAndUpdateRemoval
	| original retrieved |
	original := self definition.
	original properties
		at: #one
			put: 1;
		at: #two
			put: 2;
		at: #three
			put: 3.
	domain loadVariant: original.
	retrieved := domain updateVariant: self removal.
	self assert: retrieved properties = original properties! !

!MDDomainOpsTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testLoadDefinition
	| variant |
	variant := self definition.
	variant properties
		at: #one
			put: 1;
		at: #two
			put: 2;
		at: #three
			put: 3.
	domain loadVariant: variant.
	self assert: (self 
			atElement: self element
			property: #one) = 1.
	self assert: (self 
			atElement: self element
			property: #two) = 2.
	self assert: (self 
			atElement: self element
			property: #three) = 3! !

!MDDomainOpsTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testLoadRemoveAndUpdate
	| original retrieved |
	original := self definition.
	original properties
		at: #one
			put: 1;
		at: #two
			put: 2;
		at: #three
			put: 3.
	domain loadVariant: original.
	domain loadVariant: self removal.
	retrieved := domain updateVariant: self definition.
	self assert: retrieved element = self element.
	self assert: retrieved isRemoval! !

!MDDomainOpsTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testNotLoadable
	| variant |
	variant := self definition: #'Alpha/Delta'.
	variant properties 
		at: #one
		put: 1.
	self deny: (domain isLoadable: variant)! !

!MDDomainOpsTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testRemoval
	| variant |
	self 
		atElement: self element
		property: #one
		put: '1'.
	variant := self removal.
	domain loadVariant: variant.
	self assert: (self 
			atElement: self element
			property: #one) isNil! !

!MDDomainOpsTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testRemovalLoadable
	| variant |
	variant := self removal: #'Alpha/Delta'.
	self assert: (domain isLoadable: variant)! !

!MDDomainOpsTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testRemovalUpToDate
	| variant removal |
	variant := self definition.
	removal := self removal.
	variant properties one: '1'.
	domain loadVariant: variant.
	self deny: (domain isUpToDate: removal).
	domain loadVariant: removal.
	self assert: (domain isUpToDate: removal)! !

!MDDomainOpsTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testTransaction
	| variant |
	variant := self definition.
	variant properties 
		at: #one
		put: 1.
	domain transaction: [ domain loadVariant: variant ].
	self assert: (self 
			atElement: self element
			property: #one) = 1! !

!MDDomainOpsTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testUpToDate
	| variant |
	variant := self definition.
	variant properties source: 'one ^ 1'.
	domain loadVariant: variant.
	self assert: (domain isUpToDate: variant).
	self 
		atElement: self element
		property: #source
		put: 'one ^ 11'.
	self deny: (domain isUpToDate: variant)! !

!MDDomainOpsTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testUpdateDoesntChangeElement
	| variant original |
	variant := self definition.
	original := variant element.
	domain updateVariant: variant.
	self assert: variant element = original! !

!MDDomainTest class methodsFor: 'testing' stamp: 'jf 10/21/2009 16:14'!
isAbstract
	^ self name = #MDDomainTest! !

!MDDomainTest methodsFor: 'asserting' stamp: 'cwp 3/25/2005 22:37'!
assertElement: elem property: prop hasValue: value
	self assert: (self atElement: (self element: elem) property: prop) = value! !

!MDDomainTest methodsFor: 'asserting' stamp: 'cwp 3/25/2005 22:52'!
assertElementHasDefaultValue: aSymbol
	self assertElement: aSymbol property: #one hasValue: aSymbol asLowercase! !

!MDDomainTest methodsFor: 'asserting' stamp: 'cwp 3/25/2005 22:46'!
assertElementHasValue: value
	self assert: (self atElement: self element property: #one) = value! !

!MDDomainTest methodsFor: 'proxy access' stamp: 'jf 10/21/2009 16:13'!
atElement: element property: property 
	^ (domain at: element) 
		at: property
		ifAbsent: [ nil ]! !

!MDDomainTest methodsFor: 'proxy access' stamp: 'jf 10/21/2009 16:13'!
atElement: element property: property put: value 
	"This will need to be overriden in tests that use a real image proxy."
	(domain at: element) 
		at: property
		put: value! !

!MDDomainTest methodsFor: 'proxy access' stamp: 'cwp 2/5/2005 20:16'!
atProperty: aSymbol
	^ self atElement: self element property: aSymbol! !

!MDDomainTest methodsFor: 'proxy access' stamp: 'cwp 2/5/2005 20:17'!
atProperty: aSymbol put: aValue
	self atElement: self element property: aSymbol put: aValue
! !

!MDDomainTest methodsFor: 'configuration' stamp: 'jf 10/21/2009 16:19'!
domainClass
	^ MDFakeDomain! !

!MDDomainTest methodsFor: 'running' stamp: 'jf 10/21/2009 16:39'!
setUp
	environment := MDEnvironment new.
	domain := environment addDomain: self domainClass new! !

MDDomainTest subclass: #MDMergeTest
	instanceVariableNames: 'wc merge local remote'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDMergeTest methodsFor: 'running' stamp: 'cwp 9/4/2009 14:19'!
local: localVersion remote: remoteVersion
	local := localVersion.
	environment workspace loadVersion: local.
	remote := remoteVersion.
	merge := MDMerge toInclude: remote in: environment workspace.
! !

!MDMergeTest methodsFor: 'tests' stamp: 'cwp 9/4/2009 14:18'!
testApplyLocal
	self 
		local: (self versionWith: 'local')
		remote: (self versionWith: 'remote').
	merge chooseLocal.
	merge applyTo: environment workspace.
	self assertElementHasValue: 'local'! !

!MDMergeTest methodsFor: 'tests' stamp: 'cwp 9/4/2009 14:17'!
testApplyRemote
	self 
		local: (self versionWith: 'local')
		remote: (self versionWith: 'remote').
	merge chooseRemote.
	merge applyTo: environment workspace.
	self assertElementHasValue: 'remote'! !

!MDMergeTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:05'!
testChooseLocal
	self local: self version remote: self version.
	self assert: merge isConflict.
	merge chooseLocal.
	self assert: merge isLocal.
	self assert: merge resolution == local! !

!MDMergeTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:06'!
testChooseRemote
	self local: self version remote: self version.
	self assert: merge isConflict.
	merge chooseRemote.
	self assert: merge isRemote.
	self assert: merge resolution == remote! !

!MDMergeTest methodsFor: 'tests' stamp: 'cwp 8/9/2009 01:29'!
testIsConflict
	| version |
	version := self version.
	self local: version remote: version copy.
	self assert: merge isConflict.
	self assert: merge isLocal.
	self deny: merge isRemote.
! !

!MDMergeTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testIsLocal
	remote := self version.
	local := self updateVersion: remote property: #one put: 'alpha2'.
	self local: local remote: remote.
	self assert: merge isLocal.
	self deny: merge isRemote.
	self deny: merge isConflict.! !

!MDMergeTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testIsRemote
	local := self version.
	remote := self updateVersion: local property: #one put: 'alpha2'.
	self local: local remote: remote.
	self assert: merge isRemote.
	self deny: merge isLocal.
	self deny: merge isConflict.
! !

MDDomainTest subclass: #MDSliceOpsTest
	instanceVariableNames: 'repository snapshot workspace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:26'!
addToBoth: aVersion
	snapshot add: aVersion.
	repository add: aVersion! !

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:25'!
addToRepository: aVersion
	repository add: aVersion! !

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:25'!
addToSnapshot: aVersion
	snapshot add: aVersion! !

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:28'!
prepare
	self prepare: 
		[self addToBoth: (self versionFor: #Alpha with: 'alpha').
		self addToBoth: (self versionFor: #Beta with: 'beta')].
! !

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 5/22/2008 00:10'!
prepare: aBlock
	| repositoryVersions |
	repository := Set new.
	snapshot := Set new.
	aBlock value.
	repositoryVersions := repository.
	repository := MDMemoryRepository new.
	repositoryVersions do: [:ea | repository put: ea].
	snapshot := MDSnapshot withVersions: snapshot
	
	! !

!MDSliceOpsTest methodsFor: 'running' stamp: 'cwp 9/4/2009 16:47'!
setUp
	super setUp.
	workspace := environment workspace! !

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 3/16/2005 00:24'!
slice
	^ (MDExplicitSlice named: 'TestSlice')
		addElement: (self element: #Alpha);
		addElement: (self element: #Beta);
		yourself
	! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testAsExplicitSlice
	| original copy |
	original := self slice.
	copy := original asExplicitSlice.
	self assert: (copy isKindOf: MDExplicitSlice).
	self assert: copy elements = original elements! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 9/4/2009 16:47'!
testIncludeSnapshot
	self prepare.
	
	[ self slice 
		include: snapshot
		from: repository
		in: workspace ] 
		on: MDMergeRequest
		do: [ :ex | ex merges do: [ :ea | ea applyTo: workspace ] ].
	self assertElementHasDefaultValue: #Alpha.
	self assertElementHasDefaultValue: #Beta! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 9/4/2009 16:47'!
testLoadEqualSnapshot
	self prepare.
	self slice 
		load: snapshot
		from: repository
		to: workspace.
	self assertElementHasDefaultValue: #Alpha.
	self assertElementHasDefaultValue: #Beta! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 9/4/2009 16:47'!
testLoadLargerSnapshot
	| slice alpha beta |
	self prepare.
	alpha := self element: #Alpha.
	beta := self element: #Beta.
	slice := MDExplicitSlice named: 'TestSlice'.
	slice addElement: alpha.
	slice 
		load: snapshot
		from: repository
		to: workspace.
	self assert: (self 
			atElement: alpha
			property: #one) = 'alpha'.
	self assert: (self 
			atElement: beta
			property: #one) = 'beta'.
	self assert: slice elements size = 1! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 9/4/2009 16:47'!
testLoadSmallerSnapshot
	self prepare: [ self addToBoth: (self 
				versionFor: #Alpha
				with: 'alpha') ].
	self slice 
		load: snapshot
		from: repository
		to: workspace.
	self assertElementHasDefaultValue: #Alpha.
	self 
		assertElement: #Beta
		property: #one
		hasValue: nil! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 9/4/2009 16:47'!
testLoadWithDepenencies
	self prepare: 
		[ self addToBoth: (self versionFor: #Alpha).
		self addToBoth: (self versionFor: #Beta).
		self addToBoth: (self 
				versionFor: #'Alpha/Delta'
				with: 'ad') ].
	self slice 
		load: snapshot
		from: repository
		to: workspace.
	self
		assertElementHasDefaultValue: #Alpha;
		assertElementHasDefaultValue: #Beta;
		assertElement: #'Alpha/Delta'
			property: #one
			hasValue: 'ad'! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 9/4/2009 16:47'!
testSaveWithMemo
	| slice versions memo |
	self prepare: [  ].
	slice := self slice.
	memo := self memo.
	snapshot := slice 
		saveFrom: workspace
		to: repository
		memo: memo.
	versions := snapshot getVersionsFrom: repository.
	slice do: 
		[ :element | 
		self assert: (versions anySatisfy: [ :version | version element = element ]) ].
	self deny: (repository get: snapshot hashstamp) isNil.
	self deny: (repository get: memo hashstamp) isNil! !

MDDomainTest subclass: #MDWorkspaceTest
	instanceVariableNames: 'workspace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDWorkspaceTest methodsFor: 'asserting' stamp: 'jf 9/8/2009 16:25'!
assertConflictIncluding: anElementVersion 
	workspace 
		includeVersion: anElementVersion
		onConflict: [ :a :b | ^ self ].
	self assert: false! !

!MDWorkspaceTest methodsFor: 'asserting' stamp: 'jf 9/8/2009 16:25'!
assertNoConflictIncluding: anElementVersion 
	workspace 
		includeVersion: anElementVersion
		onConflict: 
			[ :a :b | 
			self assert: false.
			^ self ]! !

!MDWorkspaceTest methodsFor: 'running' stamp: 'jf 9/8/2009 16:25'!
setUp
	super setUp.
	workspace := environment workspace! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 9/8/2009 16:25'!
testImplicitDomainCreation
	| domain |
	domain := workspace domainForElement: (MDClassElement className: #MDBogusA).
	self assert: domain class type = #smalltalk! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'cwp 10/16/2005 14:20'!
testIncludeAbsentVersion
	| version |
	version := self version.
	version variant properties one: 'bar'.
	self assertNoConflictIncluding: version.
	self assert: (self atProperty: #one) = 'bar'! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 9/8/2009 16:25'!
testIncludeConflictingVersion
	| version newVersion newVersion2 |
	version := self version.
	version variant properties source: 'one'.
	newVersion := self 
		updateVersion: version
		property: #source
		put: 'two'.
	newVersion2 := self 
		updateVersion: version
		property: #source
		put: 'three'.
	workspace loadVersion: newVersion.
	self assertConflictIncluding: newVersion2! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 9/8/2009 16:25'!
testIncludeNewVersion
	| version newVersion |
	version := self version.
	version variant properties source: 'one'.
	workspace loadVersion: version.
	newVersion := self 
		updateVersion: version
		property: #source
		put: 'two'.
	self assertNoConflictIncluding: newVersion.
	self assert: (self atProperty: #source) = 'two'! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 9/8/2009 16:25'!
testIncludeOldVersion
	| version newVersion |
	version := self version.
	version variant properties source: 'one'.
	newVersion := self 
		updateVersion: version
		property: #source
		put: 'two'.
	workspace loadVersion: newVersion.
	self assert: (self atProperty: #source) = 'two'.
	self assertNoConflictIncluding: version.
	self assert: (self atProperty: #source) = 'two'! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 9/8/2009 16:25'!
testLoad
	| version |
	version := self version.
	version variant properties one: '1'.
	workspace loadVersion: version.
	self assert: (self atProperty: #one) = '1'! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 9/8/2009 16:25'!
testLoadAndSave
	| version |
	version := self version.
	version variant properties one: '1'.
	workspace loadVersion: version.
	self assert: (workspace versionForElement: version element) == version! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testLoadDeleteAndSave
	| version newVersion |
	version := self version.
	version variant properties source: 'one'.
	workspace loadVersion: version.
	domain removeElement: version element.
	newVersion := workspace versionForElement: version element.
	workspace loadVersion: newVersion.
	self deny: (domain includesElement: version element)! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 9/8/2009 16:25'!
testLoadModifyAndSave
	| version newVersion |
	version := self version.
	version variant properties source: 'one'.
	workspace loadVersion: version.
	self assert: (workspace versionForElement: version element) == version.
	self 
		atProperty: #source
		put: 'two'.
	newVersion := workspace versionForElement: version element.
	self deny: newVersion == version.
	self assert: (newVersion succeeds: version)! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 9/8/2009 16:25'!
testLoadModifySaveAndSave
	| version newVersion newVersion2 |
	version := self version.
	version variant properties source: 'one'.
	workspace loadVersion: version.
	self assert: (workspace versionForElement: version element) == version.
	self 
		atProperty: #source
		put: 'two'.
	newVersion := workspace versionForElement: version element.
	newVersion2 := workspace versionForElement: version element.
	self assert: newVersion == newVersion2! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 9/8/2009 16:25'!
testLoadOldVersion
	| version newVersion |
	version := self version.
	version variant properties source: 'one'.
	newVersion := self 
		updateVersion: version
		property: #source
		put: 'two'.
	workspace loadVersion: newVersion.
	self assert: (self atProperty: #source) = 'two'.
	workspace loadVersion: version.
	self assert: (self atProperty: #source) = 'one'! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 9/8/2009 16:25'!
testModifyAndIncludeConflictingVersion
	| version newVersion |
	version := self version.
	version variant properties source: 'one'.
	workspace loadVersion: version.
	newVersion := self 
		updateVersion: version
		property: #source
		put: 'two'.
	self 
		atProperty: #source
		put: 'three'.
	self assertConflictIncluding: newVersion! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 9/8/2009 16:25'!
testResolveConflict
	| version newVersion newVersion2 mergedVersion |
	version := self version.
	version variant properties source: 'one'.
	newVersion := self 
		updateVersion: version
		property: #source
		put: 'two'.
	newVersion2 := self 
		updateVersion: version
		property: #source
		put: 'three'.
	workspace loadVersion: newVersion.
	workspace 
		includeVersion: newVersion2
		onConflict: 
			[ :a :b | 
			self assert: a variant properties source = 'two'.
			b variant ].
	self assert: (self atProperty: #source) = 'three'.
	mergedVersion := workspace versionForElement: version element.
	self assert: mergedVersion variant = newVersion2 variant.
	self assert: (mergedVersion succeeds: newVersion).
	self assert: (mergedVersion succeeds: newVersion2)! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 9/8/2009 16:25'!
testSaveAbsentVersion
	| saved constructed |
	saved := workspace versionForElement: self element.
	constructed := self versionFor: #Alpha.
	self assert: saved ancestry isEmpty.
	self assert: (constructed succeeds: saved)! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 9/8/2009 16:25'!
testSaveFirstVersion
	| version |
	self 
		atElement: self element
		property: #one
		put: 'one'.
	version := workspace versionForElement: self element.
	self assert: version ancestry isEmpty.
	self assert: version variant properties one = 'one'! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testTransaction
	| version |
	version := self version.
	version variant properties one: '1'.
	workspace transaction: 
		[ workspace loadVersion: version.
		self deny: (domain includesElement: version element) ].
	self assert: (self atProperty: #one) = '1'! !

MDTestCase subclass: #MDMemoTest
	instanceVariableNames: 'memo snapshot slice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDMemoTest methodsFor: 'accessing' stamp: 'cwp 1/19/2007 22:27'!
parents
	^ Set
		with: (self memo: #a)
		with: (self memo: #b)! !

!MDMemoTest methodsFor: 'accessing' stamp: 'cwp 1/15/2007 22:13'!
properties
	^ MDPropertyDictionary new! !

!MDMemoTest methodsFor: 'running' stamp: 'cwp 5/22/2008 00:10'!
setUp
	memo := MDMemo 
		parents: self parents
		properties: self properties.
	snapshot := self snapshot.
	slice := self slice.
	memo setSnapshot: snapshot slice: slice
! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 8/10/2009 22:05'!
testDescription
	memo 
		instVarNamed: 'hashstamp' 
		put: (MDHashstamp timestamp: (MDTimestamp fromInteger: 886029518)).
	memo properties 
		author: 'Colin Putney <cputney@wireong.ca>';
		comment: 'Snapshot for testing.';
		initials: 'cwp';
		ordinal: 1;
		sliceName: 'Bogus'.
	self assert: memo description = 'timestamp: 28 March 2008 11:18:38 pm
author: ''Colin Putney <cputney@wireong.ca>''

Snapshot for testing.'! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 11/17/2007 01:27'!
testName
	memo properties initials: 'abc'.
	memo properties ordinal: 23.
	self assert: memo name = 'TestSlice-abc.23'! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 1/19/2007 22:36'!
testParents
	self assert: memo parents size = 2.
	self assert: (memo parents allSatisfy: [:ea | ea isKindOf: MDMemo]).
! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 1/19/2007 22:36'!
testProperties
	self assert: (memo properties isKindOf: MDPropertyDictionary)! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 1/19/2007 22:38'!
testSlice
	self assert: (memo matchesSlice: slice)! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 1/19/2007 23:01'!
testSliceName
	self assert: (memo sliceName = slice name)! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 1/19/2007 22:37'!
testSnapshot
	self assert: (memo hashstamp isKindOf: MDHashstamp).
	self assert: (memo reference isKindOf: MDHashstamp).
	self assert: memo reference = snapshot hashstamp.
	self deny: memo reference = memo hashstamp.
! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testSortByAuthor
	| other |
	other := memo deepCopy.
	
	memo properties initials: 'abd'.
	memo properties ordinal: 23.
	
	other properties initials: 'abc'.
	other properties ordinal: 23.
	self assert: other <= memo! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testSortByOrdinal
	| other |
	other := memo deepCopy.
	
	memo properties initials: 'abc'.
	memo properties ordinal: 23.
	
	other properties initials: 'abc'.
	other properties ordinal: 22.
	self assert: other <= memo! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testSortByOrdinalFirst
	| other |
	other := memo deepCopy.
	
	memo properties initials: 'abc'.
	memo properties ordinal: 23.
	
	other properties initials: 'abd'.
	other properties ordinal: 22.
	self assert: other <= memo! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testSortWithoutAuthors
	| other |
	other := memo deepCopy.
	memo properties ordinal: 23.
	other properties ordinal: 22.
	self assert: other <= memo! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testSortWithoutOrdinals
	| other |
	other := memo deepCopy.
	memo properties initials: 'abd'.
	other properties initials: 'abc'.
	self assert: other <= memo! !

MDTestCase subclass: #MDSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSerializationTest methodsFor: 'asserting' stamp: 'cwp 3/4/2005 17:39'!
assertEqualityOf: anObject
	^ self assertEqualityOf: anObject using: [:before :after | self assert: after = before]! !

!MDSerializationTest methodsFor: 'asserting' stamp: 'cwp 3/8/2005 00:22'!
assertEqualityOf: anObject using: aBlock 
	| other buffer |
	buffer := MDMarshal serialize: anObject.
	other := MDMarshal materialize: buffer.
	aBlock value: anObject value: other! !

!MDSerializationTest methodsFor: 'asserting' stamp: 'cwp 3/2/2008 11:04'!
assertIdentityOf: anObject
	^ self assertEqualityOf: anObject using: [:before :after | self assert: after == before]! !

!MDSerializationTest methodsFor: 'running' stamp: 'cwp 4/8/2008 20:10'!
setUp
	super setUp.
	MDMarshal resetMap! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 11:13'!
testArray
	self assertEqualityOf: #(1 2 3)! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 14:02'!
testBytesObject
	self assertEqualityOf: #(1 2 3) asByteArray! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 11:45'!
testClass
	self assertIdentityOf: self class! !

!MDSerializationTest methodsFor: 'tests - smalltalk' stamp: 'cwp 3/7/2005 16:20'!
testClassCommentElement
	self assertEqualityOf: (MDClassCommentElement className: #MDBogusA)! !

!MDSerializationTest methodsFor: 'tests - smalltalk' stamp: 'cwp 3/7/2005 16:20'!
testClassElement
	self assertEqualityOf: (MDClassElement className: #MDBogusA)! !

!MDSerializationTest methodsFor: 'tests - smalltalk' stamp: 'cwp 3/7/2005 16:22'!
testClassInstVarElement
	self assertEqualityOf: (MDClassInstVarElement className: #MDBogusA name: 'beth')! !

!MDSerializationTest methodsFor: 'tests - smalltalk' stamp: 'cwp 3/9/2005 21:45'!
testClassMethodElement
	self assertEqualityOf: (MDMethodElement 
							className: #MDBogusA 
							selector: #one 
							classIsMeta: true)! !

!MDSerializationTest methodsFor: 'tests - smalltalk' stamp: 'cwp 3/7/2005 16:21'!
testClassVarElement
	self assertEqualityOf: (MDClassVarElement className: #MDBogusA name: 'Alpha')! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 11:29'!
testDictionary
	| dict |
	dict := Dictionary new
			at: #a put: 1;
			at: #b put: 2;
			yourself.
	self assertEqualityOf: dict! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/7/2005 17:21'!
testElementDefinition
	self assertEqualityOf: self definition! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/7/2005 17:04'!
testElementRemoval
	self assertEqualityOf: self removal.! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/7/2005 15:35'!
testFakeElement
	self assertEqualityOf: self element! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 11:04'!
testFalse
	self assertIdentityOf: false ! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 8/8/2009 17:30'!
testHashstamp
	self assertEqualityOf: MDHashstamp new! !

!MDSerializationTest methodsFor: 'tests - smalltalk' stamp: 'cwp 3/7/2005 16:21'!
testInstVarElement
	self assertEqualityOf: (MDInstVarElement className: #MDBogusA name: 'one')! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 5/22/2008 00:10'!
testLongString
	| string |
	string := String new: 300.
	string atAllPut: $a.
	self assertEqualityOf: string! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 1/19/2007 22:27'!
testMemo
	self assertEqualityOf: self memo ! !

!MDSerializationTest methodsFor: 'tests - smalltalk' stamp: 'cwp 3/7/2005 16:23'!
testMethodElement
	self assertEqualityOf: (MDMethodElement className: #MDBogusA selector: #one)! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 6/23/2008 13:22'!
testMultiString
	| ws |
	ws := MDPlatform current wideString.
	ws ifNotNil: [self assertEqualityOf: ws]! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 10:26'!
testNegativeLargeInteger
	self assertEqualityOf: SmallInteger minVal - 1! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 02:03'!
testNegativeOneByteInteger
	self assertEqualityOf: -3! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 10:20'!
testNegativeTwoByteInteger
	self assertEqualityOf: -300! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 11:05'!
testNil
	self assertIdentityOf: nil! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/7/2005 16:27'!
testOneByteInteger
	self assertEqualityOf: 7! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 14:06'!
testPointersObject
	self assertEqualityOf: MDPlatform current variablePointersObject ! !

!MDSerializationTest methodsFor: 'tests - smalltalk' stamp: 'cwp 4/28/2008 22:04'!
testPoolImportElement
	self assertEqualityOf: (MDPoolImportElement 
			className: #MDBogusA
			name: #MDBogusPoolA)! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 10:26'!
testPositiveLargeInteger
	self assertEqualityOf: SmallInteger maxVal + 1! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 5/22/2008 00:10'!
testPropertyDictionary
	| properties |
	properties := MDPropertyDictionary new.
	properties
		first: 1;
		second: 'two'.
	self assertEqualityOf: properties! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 11:25'!
testSet
	self assertEqualityOf: #(1 2 3) asSet! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'jf 9/6/2009 12:56'!
testSliceElement
	self assertEqualityOf: (MDSliceElement 
							for: (MDExplicitSlice named: 'TestSlice'))! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/10/2005 23:41'!
testSnapshot
	self assertEqualityOf: self snapshot ! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/4/2005 17:22'!
testString
	self assertEqualityOf: 'abc'.! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 4/15/2008 21:40'!
testStringWithAccent
	self assertEqualityOf: 'bc'.! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/7/2005 17:15'!
testSymbol
	self assertEqualityOf: #one using: [:before :after | self assert: before == after]! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 6/5/2008 22:29'!
testThreeByteInteger
	self assertEqualityOf: (2 raisedTo: 16) + 1! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 4/13/2008 23:28'!
testTimestamp
	| ts buffer |
	ts := MDTimestamp now.
	buffer := MDMarshal serialize: ts.
	self assert: buffer size = 5.
	self assert: (MDMarshal materialize: buffer) = ts! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 11:04'!
testTrue
	self assertIdentityOf: true! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/7/2005 16:44'!
testTwoByteInteger
	self assertEqualityOf: 355! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 10/16/2005 14:42'!
testVersion
	self 
		assertEqualityOf: self version 
		using: [:before :after |
				self assert: before variant = after variant.
				self assert: before hashstamp = after hashstamp.
				self assert: before ancestry = after ancestry]! !

!MDTestCase class methodsFor: 'testing' stamp: 'cwp 3/2/2005 22:35'!
isAbstract
	^ self name = #MDTestCase! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 5/24/2008 14:41'!
builder
	^ MDTestBuilder new! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 10/16/2005 13:43'!
definition
	^ MDDefinitionVariant forElement: self element! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 5/22/2008 00:10'!
definition: aSymbol
	| definition |
	definition := MDDefinitionVariant forElement: (self element: aSymbol).
	definition properties at: #one put: 1.
	^ definition! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:31'!
element
	^ self element: #Alpha! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:31'!
element: aSymbol
	^ MDFakeElement named: aSymbol! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:31'!
elements
	^ Set
		with: (MDFakeElement named: #Alpha)
		with: (MDFakeElement named: #Beta)! !

!MDTestCase methodsFor: 'asserting' stamp: 'cwp 3/2/2005 22:51'!
fail
	self signalFailure: 'Assertion failed'! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 1/19/2007 22:26'!
memo
	^ self memo: #abc! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 1/19/2007 22:28'!
memo: aSymbol
	^ MDMemo
		snapshot: self snapshot
		slice: self slice
		parents: Set new
		properties: (MDPropertyDictionary new id: aSymbol; yourself)! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 10/16/2005 13:45'!
removal
	^ MDRemovalVariant forElement: self element! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 10/16/2005 13:45'!
removal: aSymbol
	^ MDRemovalVariant forElement: (self element: aSymbol)! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 1/19/2007 23:12'!
slice
	^ MDExplicitSlice named: 'TestSlice'.! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 5/22/2008 00:10'!
sliceVersion
	| element variant slice |
	slice := self slice.
	element := MDSliceElement forSlice: slice.
	variant := MDDefinitionVariant forElement: element.
	slice properties keysAndValuesDo: [:k :v | variant properties at: k put: v].
	^ MDElementVersion variant: variant! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:09'!
snapshot
	^ self snapshot: [:versions | ].
! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 5/24/2008 13:21'!
snapshot: aBlock
	| versions |
	versions := Set new.	
	versions 
		add: (self versionFor: #Alpha with: 'alpha');
		add: (self versionFor: #Beta with: 'beta')	.
	aBlock value: versions.
	^ MDSnapshot withVersions: versions! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 10/16/2005 14:12'!
updateVersion: anElementVersion property: aSymbol put: anObject 
	| newVariant |
	newVariant := anElementVersion variant copy.
	newVariant properties at: aSymbol put: anObject.
	^MDElementVersion 
		variant: newVariant
		ancestry: anElementVersion fullAncestry! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 10/16/2005 14:39'!
version
	^ MDElementVersion variant: self definition! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/25/2005 22:55'!
versionFor: elementName
	^ self versionFor: elementName with: elementName asLowercase! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 5/22/2008 00:10'!
versionFor: elementName with: value
	| element snapshot |
	element := MDFakeElement named: elementName.
	snapshot := MDDefinitionVariant forElement: element.
	snapshot properties at: #one put: value.
	^ MDElementVersion variant: snapshot! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 5/22/2008 00:10'!
versionWith: value
	| snapshot |
	snapshot := MDDefinitionVariant forElement: self element.
	snapshot properties at: #one put: value.
	^ MDElementVersion variant: snapshot! !

TestCase subclass: #MDTimestampPrinterTest
	instanceVariableNames: 'ts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDTimestampPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:10'!
assert: format prints: expected
	| actual |
	actual := ts printFormat: format.
	self assert: expected = actual! !

!MDTimestampPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:10'!
testNativePrintOn
	ts := MDTimestamp
			year: 2006
			month: 5
			day: 4
			hour: 3
			minute: 2
			second: 1.
	self assert: '%e %B %Y %i:%M:%S %p' prints: '4 May 2006 3:02:01 am'! !

!MDTimestampPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:10'!
testSqueakMethodStampAm
	ts := MDTimestamp
			year: 2006
			month: 5
			day: 4
			hour: 1
			minute: 2
			second: 1.
	self assert: '%l/%e/%Y %H:%M' prints: '5/4/2006 01:02'! !

!MDTimestampPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:10'!
testSqueakMethodStampPm
	ts := MDTimestamp
			year: 2006
			month: 5
			day: 4
			hour: 15
			minute: 2
			second: 1.
	self assert: '%l/%e/%Y %H:%M' prints: '5/4/2006 15:02'! !

TestCase subclass: #MDTimestampTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDTimestampTest methodsFor: 'support' stamp: 'cwp 5/22/2008 00:10'!
intWithBytes: anArray
	| int |
	int := 0.
	1 to: 4 do: [:i | int := (int bitShift: 8) + (anArray at: i)].
	^ int! !

!MDTimestampTest methodsFor: 'support' stamp: 'cwp 5/22/2008 00:10'!
recompose: units
	| int |
	int := MDTimestamp compose: units.
	^ (MDTimestamp fromInteger: int) decompose! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testAsInteger
	| int ts |
	int := self intWithBytes: #(1 2 3 4).
	ts := MDTimestamp fromInteger: int.
	self assert: ts asInteger = int.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testByteOrder
	| ts |
	ts := self tsWithBytes: #(1 2 3 4).
	self assert: (ts byteAt: 1) = 1.
	self assert: (ts byteAt: 2) = 2.
	self assert: (ts byteAt: 3) = 3.
	self assert: (ts byteAt: 4) = 4.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testComposition1
	| units |
	units := #(1 2 3 4 5 6 7).
	self assert: (self recompose: units) = units! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testComposition2
	| before after |
	before := #(7 3 5 4 3 2 1).
	after := self recompose: before.
	self assert: before = after! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 4/16/2005 16:50'!
testDays
	self assert: (self ts: #(2001 02 23 00 00 00)) day = 23.
	self assert: (self ts: #(2001 02 23 00 00 01)) day = 23.
	self assert: (self ts: #(2001 02 23 23 59 59)) day = 23.
	self assert: (self ts: #(2005 02 23 12 00 00)) day = 23.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 4/9/2005 01:38'!
testEndOfEpoch
	self 
	should: [MDTimestamp fromInteger: MDTimestamp last asInteger + 1]
	raise: Error! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testEpoch
	| ts |
	ts := MDTimestamp epoch.
	self assert: ts byteSize <= 4.
	self assert: ts asInteger = 0! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testEquality
	| left right |
	left := MDTimestamp now.
	right := left copy.
	self deny: left == right.
	self assert: left = right.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testHour01
	self assert: (self ts: #(2001 02 23 00 00 00)) hour = 0.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testHour02
	self assert: (self ts: #(2001 02 23 01 00 01)) hour = 1.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testHour03
	self assert: (self ts: #(2001 02 23 23 59 59)) hour = 23.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:20'!
testHour04
	self assert: (self ts: #(2005 04 07 01 30 00)) hour = 1.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 23:02'!
testLeapYear
	| ts |
	ts := self ts: #(2004 02 29 01 00 00).
	self assert: ts day = 29.
	self assert: ts month = 2! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testMagnitude01
	| a b |
	a := self tsWithBytes: #(1 2 3 4).
	b := self tsWithBytes: #(1 2 3 5).
	self assert: a < b! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testMagnitude02
	| a b |
	a := self tsWithBytes: #(1 2 3 4).
	b := self tsWithBytes: #(1 2 3 4).
	self deny: a < b! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testMagnitude03
	| a b |
	a := self tsWithBytes: #(1 2 3 4).
	b := self tsWithBytes: #(1 2 3 3).
	self deny: a < b! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testMagnitude04
	| a b |
	a := self tsWithBytes: #(1 2 3 4).
	b := self tsWithBytes: #(1 2 4 4).
	self assert: a < b! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testMinute01
	self assert: (self ts: #(2001 02 23 00 00 00)) minute = 0.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testMinute02
	self assert: (self ts: #(2001 02 23 01 01 01)) minute = 1.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testMinute03
	self assert: (self ts: #(2001 02 23 23 59 59)) minute = 59.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testMonths
	| base increment ts |
	base :=  24969600. 			"Value of Dec 15, the year of the epoch"
	increment := 86400 * 30.		"Number of seconds in 30 days"
	
	"Start at Jan 15, and add 30 days at a time, to test each month."
	1 to: 12 do: 
		[:i | 
		ts := MDTimestamp fromInteger: i * increment + base.
		self assert: ts month = i]! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testNow
	| ts |
	ts := MDTimestamp now.
	self assert: ts size <= 4.
	self assert: ts asInteger positive! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 6/18/2005 16:04'!
testPrinting1
	| ts |
	ts := self ts: #(2000 03 01 00 00 00).
	self assert: ts printString = '1 March 2000 12:00:00 am'.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 6/18/2005 16:04'!
testPrinting2
	| ts |
	ts := self ts: #(2005 04 07 23 28 31).
	self assert: ts printString = '7 April 2005 11:28:31 pm'! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 6/18/2005 16:04'!
testPrinting3
	| ts |
	ts := self ts: #(2005 04 07 03 28 31).
	self assert: ts printString = '7 April 2005 3:28:31 am'! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testRange
	| begin end |
	begin := MDTimestamp epoch.
	end := MDTimestamp last.
	self assert: MDTimestamp range = (end asInteger - begin asInteger)! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:18'!
testSecond01
	self assert: (self ts: #(2001 02 23 00 00 00)) second = 0.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:18'!
testSecond02
	self assert: (self ts: #(2001 02 23 01 01 01)) second = 1.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:18'!
testSecond03
	self assert: (self ts: #(2001 02 23 23 59 59)) second = 59.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:28'!
testYear01
	self assert: (self ts: #(1984 02 28 00 01 00)) year = 1984.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:28'!
testYear02
	self assert: (self ts: #(1984 02 29 00 01 00)) year = 1984.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:28'!
testYear03
	self assert: (self ts: #(1984 03 01 00 01 00)) year = 1984.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:28'!
testYear04
	self assert: (self ts: #(2001 02 23 00 01 00)) year = 2001.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:28'!
testYear05
	self assert: (self ts: #(2001 02 28 23 59 59)) year = 2001.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:29'!
testYear06
	self assert: (self ts: #(2001 03 01 00 00 00)) year = 2001.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:29'!
testYear07
	self assert: (self ts: #(2001 03 01 00 00 01)) year = 2001.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:29'!
testYear08
	self assert: (self ts: #(2003 02 23 00 01 00)) year = 2003.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:30'!
testYear09
	self assert: (self ts: #(2003 02 23 00 01 00)) year = 2003.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:38'!
testYear10
	self assert: (self ts: #(2004 02 23 00 01 00)) year = 2004.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:33'!
testYear11
	self assert: (self ts: #(2004 02 29 00 01 00)) year = 2004.
	! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:34'!
testYear12
	self assert: (self ts: #(2004 04 29 00 01 00)) year = 2004.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:34'!
testYear13
	self assert: (self ts: #(2005 02 23 00 01 00)) year = 2005.
	! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 20:30'!
testYear14
	self assert: (self ts: #(2004 01 07 09 11 00)) year = 2004.
! !

!MDTimestampTest methodsFor: 'support' stamp: 'cwp 6/18/2005 16:04'!
ts: anArray
	| parts |
	parts := Array new: 6.
	parts atAllPut: 0.
	anArray withIndexDo: [:ea :i | parts at: i put: ea].
	^ MDTimestamp
		year: (parts at: 1)
		month: (parts at: 2)
		day: (parts at: 3)
		hour: (parts at: 4)
		minute: (parts at: 5)
		second: (parts at: 6)! !

!MDTimestampTest methodsFor: 'support' stamp: 'cwp 9/11/2005 18:25'!
tsWithBytes: anArray
	^ MDTimestamp fromInteger: (self intWithBytes: anArray)! !

!MethodReference methodsFor: '*monticello2' stamp: 'cwp 3/3/2005 02:15'!
asElement
	^ MDMethodElement 
		className: classSymbol 
		selector: methodSymbol
		classIsMeta: classIsMeta! !

!Symbol methodsFor: '*monticello2' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	aSerializer serializeSymbol: self! !

Object subclass: #MDAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Announcements'!

MDAnnouncement subclass: #MDElementChange
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Announcements'!

MDElementChange subclass: #MDElementAdded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Announcements'!

!MDElementChange class methodsFor: 'as yet unclassified' stamp: 'cwp 7/28/2008 07:26'!
for: anElement
	^ self new setElement: anElement! !

!MDElementChange methodsFor: 'as yet unclassified' stamp: 'cwp 7/28/2008 07:26'!
element
	^ element! !

!MDElementChange methodsFor: 'as yet unclassified' stamp: 'cwp 7/28/2008 07:26'!
setElement: anElement
	element := anElement! !

MDElementChange subclass: #MDElementModified
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Announcements'!

MDElementChange subclass: #MDElementRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Announcements'!

MDAnnouncement subclass: #MDSliceTouched
	instanceVariableNames: 'slice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Announcements'!

MDSliceTouched subclass: #MDSliceClean
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Announcements'!

MDSliceTouched subclass: #MDSliceDirty
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Announcements'!

!MDSliceTouched class methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2008 21:41'!
for: aSlice
	^ self new setSlice: aSlice! !

!MDSliceTouched methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2008 21:41'!
setSlice: aSlice
	slice := aSlice! !

!MDSliceTouched methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2008 21:41'!
slice
	^ slice! !

Object subclass: #MDAnnouncer
	instanceVariableNames: 'subscriptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Announcements'!

MDAnnouncer class
	instanceVariableNames: 'default'!

!MDAnnouncer commentStamp: 'cwp 7/28/2008 07:06' prior: 0!
This is copied from OmniBrowser. This should be factored out into a separate library that's used by both, but hey, it's only a handful of methods. !

MDAnnouncer class
	instanceVariableNames: 'default'!

!MDAnnouncer class methodsFor: 'announcing' stamp: 'cwp 7/28/2008 07:29'!
announce: anAnnouncement
	self default announce: anAnnouncement! !

!MDAnnouncer class methodsFor: 'instance creation' stamp: 'cwp 7/28/2008 07:09'!
default
	^ default ifNil: [default := self new]! !

!MDAnnouncer class methodsFor: 'testing' stamp: 'cwp 7/28/2008 07:15'!
isolate: aBlock
	| old |
	old := default.
	[default := self new.
	aBlock value]
		ensure: [default := old]! !

!MDAnnouncer class methodsFor: 'instance creation' stamp: 'cwp 7/27/2008 20:29'!
new
	^ self basicNew initialize! !

!MDAnnouncer methodsFor: 'subscription' stamp: 'cwp 7/27/2008 20:29'!
announce: anObject

	| ann |
	ann _ anObject asAnnouncement.
	subscriptions keysAndValuesDo:
		[:class :action |
		(ann isKindOf: class) ifTrue: [action valueWithArguments: (Array with: ann)]].
	^ ann! !

!MDAnnouncer methodsFor: 'initialize-release' stamp: 'cwp 7/27/2008 20:29'!
initialize
	subscriptions _ IdentityDictionary new.! !

!MDAnnouncer methodsFor: 'subscription' stamp: 'cwp 7/27/2008 20:29'!
observe: aClass do: aValuable 
	| actions |
	actions _ subscriptions at: aClass ifAbsent: [ActionSequence new].
	subscriptions at: aClass put: (actions copyWith: aValuable).! !

!MDAnnouncer methodsFor: 'subscription' stamp: 'cwp 7/27/2008 20:29'!
observe: aClass send: aSelector to: anObject
	self
		observe: aClass
		do: (MessageSend receiver: anObject selector: aSelector)! !

!MDAnnouncer methodsFor: 'accessing' stamp: 'cwp 8/3/2008 22:53'!
subscribers
	^ subscriptions
		inject: IdentitySet new
		into: 
			[:subscribers :actions | 
			actions do: [:ea | subscribers add: ea receiver]. 
			subscribers]! !

!MDAnnouncer methodsFor: 'subscription' stamp: 'cwp 7/27/2008 20:29'!
unsubscribe: anObject
	subscriptions keysAndValuesDo:
		[:class :actions |
		subscriptions at: class put: (actions reject: [:ea | ea receiver == anObject])].
	subscriptions keysAndValuesRemove: [:key :value | value isEmpty]! !

Object subclass: #MDChange
	instanceVariableNames: 'version variant'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Utilities'!

!MDChange class methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2008 15:52'!
version: aVersion variant: aVariant
	^ self new setVersion: aVersion variant: aVariant! !

!MDChange methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2008 21:45'!
<= other
	^ self element printString <= other element printString! !

!MDChange methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2008 21:43'!
element
	^ variant element! !

!MDChange methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2008 22:18'!
final
	^ variant! !

!MDChange methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2008 16:14'!
hasEffect
	^ version variant ~= variant! !

!MDChange methodsFor: 'as yet unclassified' stamp: 'cwp 7/26/2008 16:10'!
name
	^ variant properties name ifNil: [self element printString]! !

!MDChange methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2008 22:18'!
original
	^ version variant! !

!MDChange methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2008 15:52'!
setVersion: aVersion variant: aVariant
	version := aVersion.
	variant := aVariant! !

!MDChange methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2008 15:52'!
variant
	^ variant! !

!MDChange methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2008 15:52'!
version
	^ version
	! !

Object subclass: #MDDomain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDDomain commentStamp: 'dc 6/14/2007 05:59' prior: 0!
I am an abstract superclass. I present an interface to a Smalltalk image. I have methods for querying the state of elements in the image and modifying them. My protocol is expressed in terms of Elements and Variants; I know nothing about Versions.

My subclasses must implement an adaption method for each subclass of ImageElement.

This is a facade for the class structures of the image. It presents a protocol for querying the state of the image or modifying it using variants.!

!MDDomain class methodsFor: 'as yet unclassified' stamp: 'cwp 6/15/2008 20:30'!
classForType: aSymbol
	^ self allSubclassesDo: [:ea | ea type = aSymbol ifTrue: [^ ea]]! !

!MDDomain class methodsFor: 'as yet unclassified' stamp: 'cwp 6/15/2008 20:31'!
defaultForType: aSymbol
	| class |
	class := self classForType: aSymbol.
	^ class default! !

!MDDomain class methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2008 18:47'!
new
	^ self basicNew initialize! !

!MDDomain methodsFor: 'public' stamp: 'cwp 10/16/2009 22:06'!
adapt: anElement
	self subclassResponsibility! !

!MDDomain methodsFor: 'public' stamp: 'cwp 10/16/2009 22:38'!
hasElement: anElement
	^ (self adapt: anElement) isPresent! !

!MDDomain methodsFor: 'public' stamp: 'cwp 2/4/2006 20:40'!
isLoadable: aVariant 
	^aVariant isLoadableInto: self! !

!MDDomain methodsFor: 'public' stamp: 'cwp 2/4/2006 20:41'!
isUpToDate: aVariant 
	^aVariant isUpToDateFor: self! !

!MDDomain methodsFor: 'public' stamp: 'cwp 10/16/2005 14:16'!
loadVariant: aVariant 
	aVariant loadInto: self! !

!MDDomain methodsFor: 'public' stamp: 'cwp 3/2/2006 18:25'!
transaction: aBlock
	^ aBlock value! !

!MDDomain methodsFor: 'public' stamp: 'cwp 10/16/2005 14:17'!
updateVariant: aVariant 
	^aVariant updateFrom: self! !

MDDomain subclass: #MDFakeDomain
	instanceVariableNames: 'dict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Fakes'!

!MDFakeDomain class methodsFor: 'instance creation' stamp: 'cwp 8/18/2009 22:18'!
default
	^ self new! !

!MDFakeDomain class methodsFor: 'as yet unclassified' stamp: 'cwp 6/15/2008 20:31'!
type
	^ #fake! !

!MDFakeDomain methodsFor: 'public' stamp: 'cwp 10/17/2009 22:32'!
adapt: anElement
	^ MDFakeElementAdaptor forElement: anElement inImage: self! !

!MDFakeDomain methodsFor: 'accessing' stamp: 'cwp 5/18/2008 20:07'!
allElements
	^ dict keys! !

!MDFakeDomain methodsFor: 'private' stamp: 'cwp 5/11/2008 22:24'!
at: anElement
	(self includesElement: anElement) ifFalse:
		[dict at: anElement put: Dictionary new].
	^ dict at: anElement! !

!MDFakeDomain methodsFor: 'private' stamp: 'cwp 5/11/2008 12:32'!
at: anElement ifAbsent: aBlock
	^ dict at: anElement ifAbsent: aBlock! !

!MDFakeDomain methodsFor: 'private' stamp: 'cwp 11/28/2004 15:25'!
at: anElement put: aPropertyDictionary
	dict at: anElement put: aPropertyDictionary! !

!MDFakeDomain methodsFor: 'accessing' stamp: 'cwp 5/18/2008 20:08'!
elements
	| result |
	result := Set new.
	dict keysAndValuesDo: [ :element :version | version ifNotNil: [ result add: element ] ].
	^ result! !

!MDFakeDomain methodsFor: 'private' stamp: 'cwp 5/11/2008 22:07'!
includesElement: anElement 
	^ (dict at: anElement ifAbsent: [^ false]) notNil! !

!MDFakeDomain methodsFor: 'initialize-release' stamp: 'dc 6/14/2007 06:43'!
initialize
	dict := Dictionary new! !

!MDFakeDomain methodsFor: 'accessing' stamp: 'cwp 5/26/2008 22:04'!
name
	^ #fake! !

!MDFakeDomain methodsFor: 'private' stamp: 'cwp 5/11/2008 22:02'!
removeElement: anElement
	(dict includesKey: anElement)
		ifTrue: [dict at: anElement put: nil]! !

Object subclass: #MDElementHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDElementHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 22:18'!
handle: anElement
	^ anElement handleWith: self! !

!MDElementHandler methodsFor: 'smalltalk' stamp: 'jf 10/21/2009 17:33'!
handleClass: aClassElement 
	^ self handleSmalltalkElement: aClassElement! !

!MDElementHandler methodsFor: 'smalltalk' stamp: 'jf 10/21/2009 17:33'!
handleClassComment: anElement 
	^ self handleSmalltalkElement: anElement! !

!MDElementHandler methodsFor: 'smalltalk' stamp: 'jf 10/21/2009 17:33'!
handleClassInstVar: anElement 
	^ self handleSmalltalkElement: anElement! !

!MDElementHandler methodsFor: 'smalltalk' stamp: 'jf 10/21/2009 17:33'!
handleClassVar: anElement 
	^ self handleSmalltalkElement: anElement! !

!MDElementHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 22:17'!
handleElement: anElement 
	! !

!MDElementHandler methodsFor: 'fakes' stamp: 'cwp 10/16/2009 22:30'!
handleFake: anElement
	^ self handleElement: anElement! !

!MDElementHandler methodsFor: 'smalltalk' stamp: 'jf 10/21/2009 17:33'!
handleInstVar: anElement 
	^ self handleSmalltalkElement: anElement! !

!MDElementHandler methodsFor: 'smalltalk' stamp: 'jf 10/21/2009 17:33'!
handleMethod: aMethodElement 
	^ self handleSmalltalkElement: aMethodElement! !

!MDElementHandler methodsFor: 'smalltalk' stamp: 'jf 10/21/2009 17:32'!
handlePoolImport: anElement 
	^ self handleSmalltalkElement: anElement! !

!MDElementHandler methodsFor: 'smalltalk' stamp: 'jf 10/21/2009 17:32'!
handleSmalltalkElement: aClassElement 
	^ self handleElement: aClassElement! !

MDElementHandler subclass: #MDSliceInclusionHandler
	instanceVariableNames: 'slice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDSliceInclusionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 22:17'!
handleElement: anElement 
	^ false! !

!MDSliceInclusionHandler methodsFor: 'initialize-release' stamp: 'cwp 10/16/2009 21:39'!
setSlice: aSlice
	slice := aSlice! !

MDSliceInclusionHandler subclass: #MDSmalltalkInclusionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDSmalltalkInclusionHandler class methodsFor: 'instance creation' stamp: 'cwp 10/16/2009 16:56'!
on: aSlice
	^ self new setSlice: aSlice! !

!MDSmalltalkInclusionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 17:04'!
handleClass: aClassElement 
	^ slice includesClass: aClassElement! !

!MDSmalltalkInclusionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 20:35'!
handleClassComment: anElement
	^ slice includesClassComment: anElement! !

!MDSmalltalkInclusionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 20:36'!
handleClassInstVar: aClassElement 
	^ slice includesClassInstVar: aClassElement! !

!MDSmalltalkInclusionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 20:36'!
handleClassVar: aClassElement 
	^ slice includesClassVar: aClassElement! !

!MDSmalltalkInclusionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 20:37'!
handleInstVar: anElement 
	^ slice includesInstVar: anElement! !

!MDSmalltalkInclusionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 17:03'!
handleMethod: aMethodElement 
	^ slice includesMethod: aMethodElement! !

!MDSmalltalkInclusionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 21:16'!
handlePoolImport: anElement
	^ slice includesPoolImport: anElement! !

Object subclass: #MDEnvironment
	instanceVariableNames: 'workspace store projects historians repositories'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'Monticello2-Project'!

!MDEnvironment class methodsFor: 'as yet unclassified' stamp: 'cwp 8/13/2009 18:23'!
createDefault
	^ self new! !

!MDEnvironment class methodsFor: 'as yet unclassified' stamp: 'cwp 8/13/2009 18:23'!
default
	^ Default ifNil: [Default := self createDefault]! !

!MDEnvironment class methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2009 15:58'!
forTesting
	^ MDEnvironment new
		addDomain: MDFakeDomain new;
		yourself! !

!MDEnvironment methodsFor: 'children' stamp: 'jf 10/21/2009 16:39'!
addDomain: aDomain 
	^ workspace 
		domainAt: aDomain name
		put: aDomain! !

!MDEnvironment methodsFor: 'children' stamp: 'jf 9/26/2009 01:46'!
addProject: aProject
	^ projects register: aProject.
! !

!MDEnvironment methodsFor: 'children' stamp: 'jf 10/21/2009 16:49'!
addRepository: aRepository
	| element |
	repositories register: aRepository.
	element := MDRepositoryElement id: aRepository id.
	MDAnnouncer announce: (MDElementAdded for: element).
	^ aRepository! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 9/6/2009 11:20'!
addRepository: aRepository toProject: aProject
	(self includesRepositoryId: aRepository id) ifFalse:
		[self addRepository: aRepository].
	aProject addRepository: aRepository! !

!MDEnvironment methodsFor: 'children' stamp: 'jf 10/21/2009 16:37'!
addSlice: aSlice
	| element |
	historians register: (MDHistorian forSlice: aSlice).
	element := MDSliceElement id: aSlice id.
	MDAnnouncer announce: (MDElementAdded for: element).
	^ aSlice! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 9/6/2009 11:22'!
addSlice: aSlice toProject: aProject
	(self includesSliceId: aSlice id) ifFalse: [self addSlice: aSlice].
	aProject addSlice: aSlice! !

!MDEnvironment methodsFor: 'content' stamp: 'cwp 8/16/2009 15:14'!
allElementsForSlice: aSlice do: aBlock 
	| elements parents snapshot elem memo |
	elements := aSlice elements.
	elements do: aBlock.
	parents := (self 
		historianWithId: aSlice id
		ifAbsent: [ ^ self ]) parents.
	parents isEmpty ifTrue: [ ^ self ].
	memo := (self store get: parents first) ifNil: [ ^ self ].
	snapshot := (self store get: memo reference) ifNil: [ ^ self ].
	(snapshot getVersionsFrom: self store) do: 
		[ :version | 
		elem := version element.
		(elements includes: elem) ifFalse: [ aBlock value: elem ] ]! !

!MDEnvironment methodsFor: 'notifications' stamp: 'cwp 8/14/2009 18:26'!
annElementChanged: announcement
	self noteElementChanged: announcement element! !

!MDEnvironment methodsFor: 'content' stamp: 'cwp 8/16/2009 15:14'!
changesForSlice: aSlice 
	| result parents memo snapshot |
	result := Set new.
	parents := (self 
		historianWithId: aSlice id
		ifAbsent: 
			[ ^ #() ]) parents.
	parents isEmpty ifTrue: [ ^ result ].
	memo := (self store get: parents first) ifNil: [ ^ result ].
	snapshot := (self store get: memo reference) ifNil: [ ^ result ].
	(aSlice expandVersions: (snapshot getVersionsFrom: self store)) do: 
		[ :version | 
		self workspace 
			changeFromVersion: version
			do: [ :change | result add: change ] ].
	^ result! !

!MDEnvironment methodsFor: 'accessing' stamp: 'cwp 8/14/2009 09:46'!
environment
	^ self! !

!MDEnvironment methodsFor: 'accessing' stamp: 'cwp 8/16/2009 15:14'!
historianWithId: aHashstamp 
	^ historians objectWithId: aHashstamp! !

!MDEnvironment methodsFor: 'accessing' stamp: 'cwp 8/16/2009 15:14'!
historianWithId: aHashstamp ifAbsent: aBlock 
	^ historians 
		objectWithId: aHashstamp
		ifAbsent: aBlock! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 8/14/2009 18:18'!
historians
	^ historians ! !

!MDEnvironment methodsFor: 'actions' stamp: 'cwp 8/16/2009 15:14'!
include: aMemo 
	| slice snapshot |
	slice := self sliceWithId: aMemo sliceId.
	snapshot := self store get: aMemo reference.
	
	[ slice 
		include: snapshot
		from: store
		in: workspace ] 
		on: MDMergeRequest
		do: [ :req | MDConflictBrowser handleRequest: req ].
	(self historianWithId: aMemo sliceId) noteInclude: aMemo! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 8/18/2009 22:11'!
includesProjectId: aHashstamp
	^ projects includesId: aHashstamp! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 8/18/2009 22:13'!
includesRepositoryId: aHashstamp 
	^ self repositories anySatisfy: [:ea | ea id = aHashstamp]! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 8/18/2009 22:15'!
includesSliceId: aHashstamp 
	^ self slices anySatisfy: [:ea | ea id = aHashstamp]! !

!MDEnvironment methodsFor: 'initialize-release' stamp: 'jf 9/8/2009 16:24'!
initialize
	workspace := MDWorkspace new.
	store := MDMemoryRepository named: 'store'.
	projects := MDRegistry new.
	historians := MDRegistry new.
	repositories := MDRegistry new.
	workspace 
		domainAt: MDMonticelloDomain type
		put: (MDMonticelloDomain on: self)! !

!MDEnvironment methodsFor: 'notifications' stamp: 'cwp 8/16/2009 15:14'!
isDirty: aSlice 
	^ (self 
		historianWithId: aSlice id
		ifAbsent: [ ^ false ]) isDirty! !

!MDEnvironment methodsFor: 'actions' stamp: 'cwp 8/16/2009 15:14'!
load: aMemo 
	| slice snapshot sliceId |
	sliceId := aMemo sliceId.
	slice := (self sliceWithId: sliceId) ifNil: [ MDExplicitSlice named: 'temporary' ].
	snapshot := self store get: aMemo reference.
	slice 
		load: snapshot
		from: store
		to: workspace.
	(self 
		historianWithId: aMemo sliceId
		ifAbsent: [ ^ self ]) noteLoad: aMemo! !

!MDEnvironment methodsFor: 'notifications' stamp: 'cwp 8/16/2009 15:14'!
noteClean: aSlice 
	^ (self historianWithId: aSlice id) markClean! !

!MDEnvironment methodsFor: 'notifications' stamp: 'cwp 8/16/2009 15:14'!
noteDirty: aSlice 
	^ (self historianWithId: aSlice id) markDirty! !

!MDEnvironment methodsFor: 'notifications' stamp: 'cwp 8/14/2009 22:03'!
noteElementChanged: anElement 
	historians objects do: [ :ea | ea noteElementChanged: anElement ]! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 8/18/2009 21:59'!
projectWithId: aHashstamp
	^ projects objectWithId: aHashstamp! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 8/16/2009 15:23'!
projects
	^ projects objects! !

!MDEnvironment methodsFor: 'children' stamp: 'jf 9/8/2009 23:43'!
removeProjectId: aHashstamp 
	| project |
	project := projects unregisterId: aHashstamp ifAbsent: [^ nil].
	MDAnnouncer announce: (MDElementRemoved for: (MDProjectElement for: project)).
	^ project! !

!MDEnvironment methodsFor: 'children' stamp: 'jf 9/8/2009 23:49'!
removeRepositoryId: aHashstamp 
	| repository |
	repository := repositories unregisterId: aHashstamp ifAbsent: [^ nil].
	self projects do: [:each | each removeRepository: repository].
	MDAnnouncer announce: (MDElementRemoved for:
		(MDRepositoryElement id: aHashstamp)).
	^ repository! !

!MDEnvironment methodsFor: 'children' stamp: 'jf 9/8/2009 23:46'!
removeSliceId: aHashstamp 
	| slice |
	slice := (historians unregisterId: aHashstamp ifAbsent: [^ nil]) slice.
	self projects do: [:each | each removeSlice: slice].
	MDAnnouncer announce: (MDElementRemoved for:
		(MDSliceElement id: aHashstamp)).
	^ slice! !

!MDEnvironment methodsFor: 'accessing' stamp: 'cwp 9/5/2009 22:00'!
repositories
	^ repositories objects! !

!MDEnvironment methodsFor: 'children' stamp: 'jf 9/8/2009 17:43'!
repositoryWithId: aHashstamp
	^ repositories objectWithId: aHashstamp! !

!MDEnvironment methodsFor: 'actions' stamp: 'cwp 8/16/2009 15:14'!
save: aSlice 
	| memo historian |
	historian := self historianWithId: aSlice id.
	memo := historian memo.
	^ memo ifNotNil: 
		[ aSlice 
			saveFrom: workspace
			to: store
			memo: memo.
		historian noteSave: memo.
		memo ]! !

!MDEnvironment methodsFor: 'accessing' stamp: 'jf 9/6/2009 13:34'!
sliceWithId: sliceId 
	| historian |
	historian := self historianWithId: sliceId.
	^ historian ifNotNil: [historian slice]! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 8/14/2009 17:57'!
slices
	^ historians objects collect: [:ea | ea slice]! !

!MDEnvironment methodsFor: 'accessing' stamp: 'cwp 8/12/2009 10:24'!
store
	^ store! !

!MDEnvironment methodsFor: 'notifications' stamp: 'cwp 8/14/2009 18:26'!
subscribe
	MDAnnouncer default 
		observe: MDElementChange
		send: #annElementChanged:
		to: self! !

!MDEnvironment methodsFor: 'content' stamp: 'cwp 8/12/2009 17:57'!
unsavedChangesForSlice: aSlice 
	| result |
	result := Set new.
	self 
		allElementsForSlice: aSlice
		do: 
			[ :element | 
			workspace 
				changeForElement: element
				do: [ :change | result add: change ] ].
	^ result! !

!MDEnvironment methodsFor: 'notifications' stamp: 'cwp 8/14/2009 18:26'!
unsubscribe
	MDAnnouncer default unsubscribe: self! !

!MDEnvironment methodsFor: 'accessing' stamp: 'cwp 8/12/2009 10:24'!
workspace
	^ workspace! !

Object subclass: #MDFakeElementAdaptor
	instanceVariableNames: 'image element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Fakes'!

!MDFakeElementAdaptor class methodsFor: 'instance creation' stamp: 'cwp 2/4/2005 00:35'!
forElement: anElement inImage: aDictionary
	^ self new setImage: aDictionary element: anElement! !

!MDFakeElementAdaptor methodsFor: 'private' stamp: 'cwp 2/13/2005 19:29'!
checkDependencies
	self isLoadable ifFalse: [self error: 'Unmet dependency']! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 5/24/2005 07:54'!
display: properties
	^ properties one asString! !

!MDFakeElementAdaptor methodsFor: 'private' stamp: 'cwp 5/11/2008 22:05'!
isLoadable
	| required |
	(element name includes: $/) ifFalse: [^ true].
	required := element name copyUpTo: $/.
	^ image elements anySatisfy: [:ea | ea name = required]
! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/13/2005 19:44'!
isLoadable: properties
	^ self isLoadable! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 5/11/2008 21:32'!
isPresent
	^ (image at: element ifAbsent: [^ false]) notNil! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/4/2005 00:39'!
isUpToDate: properties
	properties keysAndValuesDo: 
		[:key :value |
		(self properties at: key ifAbsent: [^ false]) = value ifFalse: [^ false]].
	^ true
	! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 3/25/2005 22:03'!
load: properties 
	self checkDependencies.
	self properties.
	properties keysAndValuesDo: [:key :value | self properties at: key put: value]! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'avi 3/16/2005 12:33'!
merge: aPropertyDictionary into: otherPropertyDictionary onFailure: aBlock
	^ aBlock value! !

!MDFakeElementAdaptor methodsFor: 'accessing' stamp: 'cwp 5/11/2008 22:04'!
properties
	^ image at: element! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 5/11/2008 21:33'!
remove
	image at: element put: nil! !

!MDFakeElementAdaptor methodsFor: 'initialize-release' stamp: 'cwp 5/22/2008 00:10'!
setImage: aFakeImageProxy element: anElement
	image := aFakeImageProxy.
	element := anElement! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/4/2005 00:33'!
update: properties
	self properties keysAndValuesDo: [:key :value | properties at: key put: value]! !

Object subclass: #MDHashedObject
	instanceVariableNames: 'hashstamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDHashedObject class methodsFor: 'serialization' stamp: 'avi 3/12/2005 02:51'!
extension
	self subclassResponsibility! !

!MDHashedObject class methodsFor: 'serialization' stamp: 'cwp 11/20/2008 18:49'!
new
	^ self basicNew initialize! !

!MDHashedObject methodsFor: 'comparing' stamp: 'cwp 3/16/2008 00:12'!
= other
	^ self species = other species
		and: [self hashstamp = other hashstamp]! !

!MDHashedObject methodsFor: 'comparing' stamp: 'cwp 8/9/2009 13:57'!
hash
	^ hashstamp hash! !

!MDHashedObject methodsFor: 'accessing' stamp: 'cwp 8/9/2009 13:57'!
hashstamp
	^ hashstamp! !

!MDHashedObject methodsFor: 'initialize-release' stamp: 'cwp 8/9/2009 13:57'!
initHashstamp
	hashstamp := MDHashstamp timestamp: hashstamp! !

!MDHashedObject methodsFor: 'initialize-release' stamp: 'cwp 8/9/2009 13:57'!
initialize
	hashstamp := MDTimestamp now! !

!MDHashedObject methodsFor: 'testing' stamp: 'cwp 1/19/2007 20:49'!
isMemo
	^ false! !

!MDHashedObject methodsFor: 'testing' stamp: 'cwp 1/1/2007 09:34'!
isSnapshot
	^ false! !

!MDHashedObject methodsFor: 'testing' stamp: 'cwp 11/28/2008 21:47'!
isVersion
	^ false! !

!MDHashedObject methodsFor: 'serialization' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	^ aSerializer serializeHashedObject: self! !

!MDHashedObject methodsFor: 'accessing' stamp: 'cwp 8/9/2009 13:57'!
timestamp
	^ hashstamp timestamp! !

MDHashedObject subclass: #MDMemo
	instanceVariableNames: 'reference parents properties sliceId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDMemo class methodsFor: 'instance creation' stamp: 'cwp 3/6/2008 19:37'!
new
	^ self parents: Array new properties: MDPropertyDictionary new! !

!MDMemo class methodsFor: 'instance creation' stamp: 'cwp 3/6/2008 19:37'!
parents: anArray
	^ self parents: anArray properties: MDPropertyDictionary new! !

!MDMemo class methodsFor: 'instance creation' stamp: 'cwp 1/16/2007 19:56'!
parents: anArray properties: properties
	^ self basicNew setParents: anArray properties: properties! !

!MDMemo class methodsFor: 'instance creation' stamp: 'cwp 1/19/2007 22:26'!
snapshot: aSnapshot slice: aSlice parents: aSet properties: aPropertyDictionary
	^ (self parents: aSet properties: aPropertyDictionary)
		setSnapshot: aSnapshot slice: aSlice;
		yourself! !

!MDMemo methodsFor: 'comparing' stamp: 'cwp 12/31/2007 14:55'!
<= aMemo
	^ self hashstamp <= aMemo hashstamp! !

!MDMemo methodsFor: 'accessing' stamp: 'cwp 4/1/2008 23:35'!
description
	^ String streamContents: 
		[:stream |
		self printPropertiesOn: stream.
		stream cr.
		properties comment ifNotNilDo: [:c | stream nextPutAll: c]]! !

!MDMemo methodsFor: 'repository' stamp: 'cwp 11/28/2008 21:26'!
getSnapshotFrom: aRepository
	^ aRepository get: reference! !

!MDMemo methodsFor: 'testing' stamp: 'cwp 1/19/2007 20:49'!
isMemo
	^ true! !

!MDMemo methodsFor: 'testing' stamp: 'cwp 1/19/2007 22:42'!
matchesSlice: aSlice
	^ sliceId = aSlice id! !

!MDMemo methodsFor: 'printing' stamp: 'cwp 12/28/2007 23:38'!
name
	
	^ String streamContents:
		[:stream | 
		self 
			printWithSliceName: properties sliceName 
			on: stream]! !

!MDMemo methodsFor: 'printing' stamp: 'cwp 12/28/2007 23:38'!
nameForSlice: aSlice
	
	^ String streamContents:
		[:stream | 
		self printWithSliceName: aSlice name on: stream]! !

!MDMemo methodsFor: 'accessing' stamp: 'cwp 1/15/2007 22:17'!
parents
	^ parents! !

!MDMemo methodsFor: 'printing' stamp: 'cwp 4/1/2008 23:37'!
printPropertiesOn: aStream
	
	| print dict |
	print := [:key :value |
			aStream 
				nextPutAll: key asString;
				nextPut: $:;
				space;
				print: value;
				cr].

	print value: #timestamp value: self timestamp.
	dict := properties copy
		removeKey: #initials ifAbsent: [];
		removeKey: #ordinal ifAbsent: [];
		removeKey: #comment ifAbsent: [];
		removeKey: #sliceName ifAbsent: [];
		yourself.
	dict keys asSortedArray do: [:key | print value: key value: (dict at: key)]! !

!MDMemo methodsFor: 'printing' stamp: 'cwp 5/22/2008 00:10'!
printWithSliceName: aString on: aStream
	| segment |
	aStream nextPutAll: aString.
	(segment := properties initials) ifNotNil: 
		[aStream position > 0 ifTrue: [aStream nextPut: $-].
		aStream nextPutAll: segment].
	(segment := properties ordinal) ifNotNil: 
		[aStream position > 0 ifTrue: [aStream nextPut: $.].
		aStream print: segment]! !

!MDMemo methodsFor: 'accessing' stamp: 'cwp 1/15/2007 22:17'!
properties
	^ properties! !

!MDMemo methodsFor: 'accessing' stamp: 'cwp 1/15/2007 22:16'!
reference
	^ reference! !

!MDMemo methodsFor: 'initialize-release' stamp: 'cwp 5/22/2008 00:10'!
setParents: anArray properties: propdict
	self initialize.
	parents := anArray.
	properties := propdict.
! !

!MDMemo methodsFor: 'initialize-release' stamp: 'cwp 5/22/2008 00:10'!
setSnapshot: aSnapshot slice: aSlice
	reference := aSnapshot hashstamp.
	sliceId := aSlice id.
	properties sliceName: aSlice name.
	self initHashstamp! !

!MDMemo methodsFor: 'accessing' stamp: 'cwp 1/19/2007 22:24'!
sliceId
	^ sliceId! !

!MDMemo methodsFor: 'accessing' stamp: 'cwp 1/19/2007 23:03'!
sliceName
	^ properties sliceName! !

MDHashedObject subclass: #MDSnapshot
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDSnapshot commentStamp: 'dc 6/14/2007 08:13' prior: 0!
This is a set of Versions which "go together." A snapshot is equivalent to an MCVersion in MC1. It's the unit at which code is moved between images.!

!MDSnapshot class methodsFor: 'serialization' stamp: 'avi 3/12/2005 02:52'!
extension
	^ 'snap'! !

!MDSnapshot class methodsFor: 'instance creation' stamp: 'cwp 3/23/2005 22:52'!
withVersions: versions
	^ self new setVersions: versions! !

!MDSnapshot methodsFor: 'accessing' stamp: 'cwp 3/27/2005 22:39'!
contents
	^ contents! !

!MDSnapshot methodsFor: 'repository' stamp: 'cwp 1/19/2007 23:27'!
getVersionsFrom: aRepository
	^ contents collect: [:ea | aRepository get: ea]! !

!MDSnapshot methodsFor: 'Monticello2-Versions' stamp: 'jf 9/8/2009 16:28'!
getVersionsFrom: aRepository for: aWorkspace
	| versions missing |
	versions := Set new.
	missing := Set new.
	contents do:
		[:hs |
		aWorkspace 
			versionForHashstamp: hs
			ifPresent: [:v | versions add: v]
			ifAbsent: [missing add: hs]].
	versions addAll: (aRepository getAll: missing).
	^ versions
! !

!MDSnapshot methodsFor: 'testing' stamp: 'cwp 1/1/2007 09:34'!
isSnapshot
	^ true! !

!MDSnapshot methodsFor: 'initialize-release' stamp: 'cwp 6/23/2008 08:52'!
setVersions: aSet
	contents := (aSet collect: [:ea | ea hashstamp]) asSet.
	self initHashstamp.! !

MDHashedObject subclass: #MDVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDVersion commentStamp: 'dc 6/14/2007 07:54' prior: 0!
This is the central class of MC2. It represents the state of an element at a particular point in the evolution of the system. It combines a variant with list of versions that have come before it. Each version has what we call a Hashstamp - combination of SHA1 hash and timestamp which uniquely identifies the version. A version's ancestry is a set of hashstamps specifying which versions are part of this version's history.!

MDVersion subclass: #MDElementVersion
	instanceVariableNames: 'variant ancestry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDElementVersion class methodsFor: 'instance creation' stamp: 'cwp 10/16/2005 14:19'!
variant: aVariant 
	^self variant: aVariant ancestry: Set new! !

!MDElementVersion class methodsFor: 'instance creation' stamp: 'cwp 10/16/2005 14:18'!
variant: aVariant ancestry: aSet 
	^self 
		variant: aVariant
		ancestry: aSet
		timestamp: MDTimestamp now! !

!MDElementVersion class methodsFor: 'instance creation' stamp: 'cwp 10/16/2005 14:18'!
variant: aVariant ancestry: aSet timestamp: aTimeStamp 
	^self basicNew 
		setVariant: aVariant
		ancestry: aSet
		timestamp: aTimeStamp! !

!MDElementVersion methodsFor: 'accessing' stamp: 'avi 11/29/2004 13:53'!
ancestry
	^ ancestry! !

!MDElementVersion methodsFor: 'accessing' stamp: 'cwp 10/16/2005 13:50'!
element
	^variant element! !

!MDElementVersion methodsFor: 'accessing' stamp: 'cwp 3/23/2005 23:15'!
fullAncestry
	^ancestry copyWith: self hashstamp! !

!MDElementVersion methodsFor: 'comparing' stamp: 'cwp 3/23/2005 23:15'!
precedes: aVersion 
	^aVersion ancestry includes: self hashstamp! !

!MDElementVersion methodsFor: 'conflicts' stamp: 'jf 10/4/2009 20:21'!
resolveConflictWith: aVersion in: aDomain using: twoArgBlock 
	(self variant autoMergeWith: aVersion variant in: aDomain) 
		ifNotNilDo: [:snap | ^snap].
	^twoArgBlock value: self value: aVersion! !

!MDElementVersion methodsFor: 'initialize-release' stamp: 'cwp 8/9/2009 13:57'!
setVariant: aVariant ancestry: aCollection timestamp: aTimestamp 
	variant := aVariant.
	ancestry := aCollection.
	hashstamp := aTimestamp.
	self initHashstamp! !

!MDElementVersion methodsFor: 'accessing' stamp: 'cwp 10/16/2005 13:50'!
variant
	^variant! !

MDVersion subclass: #MDNullVersion
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDNullVersion class methodsFor: 'instance creation' stamp: 'cwp 2/27/2005 21:31'!
forElement: anElement
	^ self new setElement: anElement! !

!MDNullVersion methodsFor: 'accessing' stamp: 'cwp 2/27/2005 22:24'!
ancestry
	^ Set new! !

!MDNullVersion methodsFor: 'accessing' stamp: 'cwp 2/27/2005 21:36'!
element
	^ element! !

!MDNullVersion methodsFor: 'accessing' stamp: 'cwp 2/27/2005 22:24'!
fullAncestry
	^ Set new! !

!MDNullVersion methodsFor: 'comparing' stamp: 'cwp 2/28/2005 21:47'!
precedes: anElementVersion 
	^true! !

!MDNullVersion methodsFor: 'initialize-release' stamp: 'dc 6/14/2007 08:10'!
setElement: anElement
	element := anElement.
	self initHashstamp! !

!MDNullVersion methodsFor: 'accessing' stamp: 'cwp 10/16/2005 14:17'!
variant
	^ MDRemovalVariant forElement: element! !

!MDVersion class methodsFor: 'serialization' stamp: 'avi 3/12/2005 02:53'!
extension
	^ 'vers'! !

!MDVersion methodsFor: 'comparing' stamp: 'dc 6/14/2007 07:55'!
conflictsWith: other
	^ ((self precedes: other)
			or: [self succeeds: other]) not! !

!MDVersion methodsFor: 'testing' stamp: 'cwp 11/28/2008 21:48'!
isVersion
	^ true! !

!MDVersion methodsFor: 'comparing' stamp: 'cwp 2/28/2005 21:47'!
succeeds: anElementVersion 
	^anElementVersion precedes: self! !

!MDVersion methodsFor: 'comparing' stamp: 'avi 3/21/2006 00:13'!
successor: other 
	(self = other) ifTrue: [^ self].
	(self succeeds: other) ifTrue: [^ self].
	(other succeeds: self) ifTrue: [^ other].
	^ nil! !

!MDVersion methodsFor: 'comparing' stamp: 'dc 6/14/2007 08:01'!
successor: other onConflict: aBlock 
	^ (self successor: other)
		ifNil: [MDElementVersion
					variant: aBlock value
					ancestry: self fullAncestry , other fullAncestry]! !

Object subclass: #MDHistorian
	instanceVariableNames: 'slice properties parents ordinal isDirty'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Project'!

!MDHistorian class methodsFor: 'as yet unclassified' stamp: 'cwp 3/8/2008 14:01'!
forSlice: aSlice
	^ self new setSlice: aSlice! !

!MDHistorian methodsFor: 'accessing' stamp: 'cwp 5/22/2008 00:10'!
basicMemo
	| memo |
	memo := MDMemo parents: self parents.
	self update: memo properties.
	MDPlatform current updateMemoProperties: memo properties.
	memo properties ordinal: (self ordinal).
	^ memo! !

!MDHistorian methodsFor: 'accessing' stamp: 'cwp 6/1/2008 20:30'!
clearParents
	parents := OrderedCollection new! !

!MDHistorian methodsFor: 'accessing' stamp: 'cwp 8/14/2009 18:19'!
id
	^ slice id! !

!MDHistorian methodsFor: 'ordinals' stamp: 'cwp 5/22/2008 00:10'!
incrementOrdinal
	ordinal := ordinal + 1! !

!MDHistorian methodsFor: 'accessing' stamp: 'cwp 3/8/2008 21:27'!
isDirty
	^ isDirty! !

!MDHistorian methodsFor: 'accessing' stamp: 'cwp 8/3/2008 21:50'!
markClean
	isDirty ifTrue: 
		[isDirty := false.
		MDAnnouncer default announce: (MDSliceClean for: slice)]! !

!MDHistorian methodsFor: 'accessing' stamp: 'cwp 8/3/2008 21:50'!
markDirty
	isDirty ifFalse: 
		[isDirty := true.
		MDAnnouncer default announce: (MDSliceDirty for: slice)]! !

!MDHistorian methodsFor: 'accessing' stamp: 'cwp 5/22/2008 00:10'!
memo
	| memo name |
	memo := self basicMemo.
	name := memo nameForSlice: slice.
	^ (MDCommentRequest signal: 'Comment for ', name) ifNotNilDo:
		[:comment | 
		comment isEmpty ifFalse: [memo properties comment: comment].
		self incrementOrdinal.
		memo].
	! !

!MDHistorian methodsFor: 'notification' stamp: 'cwp 7/26/2008 17:49'!
noteElementChanged: anElement 
	(slice includes: anElement) ifTrue: [ self markDirty ]! !

!MDHistorian methodsFor: 'notification' stamp: 'cwp 3/8/2008 12:45'!
noteInclude: aMemo
	parents add: aMemo hashstamp.
	self noteOrdinal: aMemo properties ordinal ! !

!MDHistorian methodsFor: 'notification' stamp: 'cwp 8/3/2008 21:47'!
noteLoad: aMemo
	parents := OrderedCollection with: aMemo hashstamp.
	self noteOrdinal: aMemo properties ordinal.
	self markClean! !

!MDHistorian methodsFor: 'ordinals' stamp: 'cwp 5/22/2008 00:10'!
noteOrdinal: anInteger 
	
	anInteger ifNotNil: [ordinal := ordinal max: anInteger + 1]! !

!MDHistorian methodsFor: 'notification' stamp: 'cwp 8/3/2008 21:47'!
noteSave: aMemo
	parents := OrderedCollection with: aMemo hashstamp.
	self markClean! !

!MDHistorian methodsFor: 'ordinals' stamp: 'cwp 3/8/2008 12:35'!
ordinal
	^ ordinal! !

!MDHistorian methodsFor: 'accessing' stamp: 'cwp 3/8/2008 12:36'!
parents
	^ parents asArray! !

!MDHistorian methodsFor: 'accessing' stamp: 'cwp 12/27/2007 21:47'!
properties
	^ properties! !

!MDHistorian methodsFor: 'initialize-release' stamp: 'cwp 5/22/2008 00:10'!
setSlice: aSlice
	slice := aSlice.
	properties := MDPropertyDictionary new.
	parents := OrderedCollection new.
	ordinal := 1.
	isDirty := false
	! !

!MDHistorian methodsFor: 'accessing' stamp: 'cwp 8/14/2009 08:46'!
slice
	^ slice! !

!MDHistorian methodsFor: 'updating' stamp: 'cwp 12/27/2007 21:27'!
update: props
	properties keysAndValuesDo: [:k :v | props at: k put: v]! !

Object subclass: #MDImageElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDImageElement commentStamp: 'dc 6/14/2007 05:21' prior: 0!
I am an abstract superclass. My subclasses are references to the parts of a Smalltalk program. 

These play the same role as MethodReferences. They are references to specific parts of a Smalltalk program. They're more fine-grained than Definitions in MC1 - you'll see separate elements for each instance variable, for example, so that they can referred to directly, rather than by implication in a class reference.!

MDImageElement subclass: #MDClassAwareElement
	instanceVariableNames: 'theClassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDClassAwareElement class methodsFor: 'instance creation' stamp: 'dc 6/14/2007 05:39'!
className: aSymbol
	^ self new
		setClassName: aSymbol;
		yourself! !

!MDClassAwareElement methodsFor: 'comparing' stamp: 'dc 6/14/2007 05:29'!
= other
	^ (self species = other species)
		and: [self theClassName = other theClassName]! !

!MDClassAwareElement methodsFor: 'accessing' stamp: 'cwp 5/26/2008 21:50'!
domain
	^ #smalltalk! !

!MDClassAwareElement methodsFor: 'comparing' stamp: 'dc 6/14/2007 05:29'!
hash
	^ theClassName hash! !

!MDClassAwareElement methodsFor: 'printing' stamp: 'cwp 10/22/2008 21:42'!
printStdIdOn: aStream with: aString
	aStream
		nextPutAll: self theClassName;
		nextPutAll: ': ';
		nextPutAll: aString;
		nextPutAll: ' ''';
		nextPutAll: self name;
		nextPut: $'! !

!MDClassAwareElement methodsFor: 'initialize-release' stamp: 'dc 6/14/2007 05:30'!
setClassName: aSymbol 
	theClassName := aSymbol! !

!MDClassAwareElement methodsFor: 'accessing' stamp: 'dc 6/14/2007 05:30'!
theClassName
	^ theClassName! !

MDClassAwareElement subclass: #MDClassAwareNamedElement
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDClassAwareNamedElement class methodsFor: 'intance creation' stamp: 'dc 6/14/2007 05:42'!
className: aSymbol name: aString
	^ self new
		setClassName: aSymbol name: aString;
		yourself! !

!MDClassAwareNamedElement methodsFor: 'comparing' stamp: 'dc 6/14/2007 05:43'!
= other
	^ super = other
		and: [self name = other name]! !

!MDClassAwareNamedElement methodsFor: 'comparing' stamp: 'dc 6/14/2007 05:43'!
hash
	^ super hash bitXor: name hash! !

!MDClassAwareNamedElement methodsFor: 'accessing' stamp: 'dc 6/14/2007 05:43'!
name
	^ name! !

!MDClassAwareNamedElement methodsFor: 'initialize-release' stamp: 'dc 6/14/2007 05:44'!
setClassName: aSymbol name: aString
	theClassName := aSymbol.
	name := aString! !

MDClassAwareNamedElement subclass: #MDClassInstVarElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDClassInstVarElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:27'!
handleWith: anObject
	^ anObject handleClassInstVar: self! !

!MDClassInstVarElement methodsFor: 'printing' stamp: 'cwp 10/22/2008 21:47'!
printOn: aStream
	self printStdIdOn: aStream with: 	'class instance variable'! !

MDClassAwareNamedElement subclass: #MDClassVarElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDClassVarElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:27'!
handleWith: anObject
	^ anObject handleClassVar: self! !

!MDClassVarElement methodsFor: 'printing' stamp: 'cwp 10/22/2008 21:45'!
printOn: aStream
	^ self printStdIdOn: aStream with: 'class variable'! !

MDClassAwareNamedElement subclass: #MDInstVarElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDInstVarElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:27'!
handleWith: anObject
	^ anObject handleInstVar: self! !

!MDInstVarElement methodsFor: 'printing' stamp: 'cwp 10/22/2008 21:47'!
printOn: aStream
	^ self printStdIdOn: aStream with: 'instance variable'! !

MDClassAwareNamedElement subclass: #MDPoolImportElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDPoolImportElement class methodsFor: 'instance creation' stamp: 'cwp 4/28/2008 22:04'!
className: classNameSymbol name: poolNameSymbol 
	^ self basicNew 
		setClassName: classNameSymbol
		name: poolNameSymbol! !

!MDPoolImportElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:28'!
handleWith: anObject
	^ anObject handlePoolImport: self! !

!MDPoolImportElement methodsFor: 'printing' stamp: 'cwp 10/22/2008 21:48'!
printOn: aStream
	self printStdIdOn: aStream with: 'pool import'! !

MDClassAwareElement subclass: #MDClassCommentElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDClassCommentElement commentStamp: 'cwp 5/7/2006 22:32' prior: 0!
I am a reference to the comment of a particular class.

theClassName - the name of the class to whose comment I refer

!

!MDClassCommentElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:28'!
handleWith: anObject
	^ anObject handleClassComment: self! !

!MDClassCommentElement methodsFor: 'printing' stamp: 'cwp 10/22/2008 21:54'!
printOn: aStream
	aStream
		nextPutAll: theClassName;
		space;
		nextPutAll: 'comment'! !

MDClassAwareElement subclass: #MDClassElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDClassElement commentStamp: 'cwp 5/7/2006 22:34' prior: 0!
I am a reference to a class.

theClassName - the name of the class
!

!MDClassElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:28'!
handleWith: anObject
	^ anObject handleClass: self! !

!MDClassElement methodsFor: 'printing' stamp: 'cwp 10/22/2008 21:52'!
printOn: aStream
	aStream nextPutAll: theClassName! !

MDClassAwareElement subclass: #MDMethodElement
	instanceVariableNames: 'selector classIsMeta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDMethodElement class methodsFor: 'instance creation' stamp: 'dc 6/14/2007 05:50'!
className: aString selector: aSymbol 
	^ self className: aString selector: aSymbol classIsMeta: false! !

!MDMethodElement class methodsFor: 'instance creation' stamp: 'dc 6/14/2007 05:50'!
className: aString selector: aSymbol classIsMeta: aBoolean
	^ self new
		setClassName: aString selector: aSymbol classIsMeta: aBoolean;
		yourself! !

!MDMethodElement methodsFor: 'comparing' stamp: 'cwp 3/16/2008 21:42'!
= other 
	^ super = other
		and: [self selector = other selector]
		and: [self classIsMeta = other classIsMeta]! !

!MDMethodElement methodsFor: 'accessing' stamp: 'cwp 2/12/2005 15:25'!
classIsMeta
	^ classIsMeta! !

!MDMethodElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:29'!
handleWith: anObject
	^ anObject handleMethod: self! !

!MDMethodElement methodsFor: 'comparing' stamp: 'cwp 3/16/2008 21:59'!
hash
	^ self printString hash! !

!MDMethodElement methodsFor: 'accessing' stamp: 'cwp 8/28/2005 17:15'!
name
	^ selector! !

!MDMethodElement methodsFor: 'printing' stamp: 'cwp 10/22/2008 21:59'!
printOn: aStream
	aStream nextPutAll: self theClassName.
	self classIsMeta ifTrue: [aStream nextPutAll: ' class'].
	aStream 
		nextPutAll: '>>';
		nextPutAll: self selector! !

!MDMethodElement methodsFor: 'accessing' stamp: 'avi 11/28/2004 16:26'!
selector
	^ selector! !

!MDMethodElement methodsFor: 'initialize-release' stamp: 'cwp 2/12/2005 15:15'!
setClassName: aString selector: aSymbol classIsMeta: aBoolean
	theClassName := aString.
	selector := aSymbol.
	classIsMeta := aBoolean! !

MDImageElement subclass: #MDFakeElement
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Fakes'!

!MDFakeElement class methodsFor: 'instance creation' stamp: 'cwp 2/5/2005 19:02'!
named: aSymbol
	^ self new name: aSymbol! !

!MDFakeElement methodsFor: 'comparing' stamp: 'cwp 2/5/2005 19:27'!
= other
	self species = other species ifFalse: [^ false].
	^ self name = other name! !

!MDFakeElement methodsFor: 'public' stamp: 'jf 10/4/2009 20:21'!
adaptedFor: aDomain 
	^ aDomain adaptorForElement: self! !

!MDFakeElement methodsFor: 'printing' stamp: 'cwp 4/25/2005 04:11'!
displayOn: aStream
	aStream nextPutAll: name! !

!MDFakeElement methodsFor: 'accessing' stamp: 'cwp 5/26/2008 22:00'!
domain
	^ #fake! !

!MDFakeElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:29'!
handleWith: anObject
	^ anObject handleFake: self! !

!MDFakeElement methodsFor: 'comparing' stamp: 'cwp 2/5/2005 19:27'!
hash
	^ name hash! !

!MDFakeElement methodsFor: 'accessing' stamp: 'cwp 2/5/2005 18:58'!
name
	^ name! !

!MDFakeElement methodsFor: 'accessing' stamp: 'cwp 5/22/2008 00:10'!
name: aSymbol
	name := aSymbol! !

!MDFakeElement methodsFor: 'printing' stamp: 'cwp 11/20/2008 19:05'!
printOn: aStream 
	aStream print: self class.
	aStream nextPut: $<.
	aStream nextPutAll: name.
	aStream nextPut: $>! !

!MDImageElement methodsFor: 'comparing' stamp: 'cwp 5/28/2008 21:43'!
<= other
	^ self printString <= other printString! !

!MDImageElement methodsFor: 'comparing' stamp: 'avi 11/28/2004 16:02'!
= other
	self subclassResponsibility ! !

!MDImageElement methodsFor: 'adapting' stamp: 'jf 10/4/2009 20:51'!
adaptedFor: aDomain
	"Visitor pattern. Subclasses should dispatch to an appropriate method on aDomain
	to return an adaptor appropriate for the receiver."
	
	self subclassResponsibility! !

!MDImageElement methodsFor: 'conflicts' stamp: 'avi 3/16/2005 12:27'!
alwaysPreferDefinition
	^ false! !

!MDImageElement methodsFor: 'conflicts' stamp: 'avi 3/16/2005 12:27'!
alwaysPreferRemoval
	^ false! !

!MDImageElement methodsFor: 'printing' stamp: 'cwp 8/28/2005 17:43'!
displayClassName
	^ 'Element'! !

!MDImageElement methodsFor: 'adapting' stamp: 'jf 10/4/2009 20:53'!
domain
	"Return the domain type that holds the elements of the receiver's type."
	
	self subclassResponsibility! !

!MDImageElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:26'!
handleWith: anObject
	self subclassResponsibility! !

!MDImageElement methodsFor: 'comparing' stamp: 'avi 11/28/2004 16:02'!
hash
	self subclassResponsibility ! !

!MDImageElement methodsFor: 'domain' stamp: 'cwp 10/16/2009 22:39'!
is: properties upToDateFor: aDomain
	^ (aDomain adapt: self) isUpToDate: properties! !

!MDImageElement methodsFor: 'domain' stamp: 'cwp 10/16/2009 22:39'!
isLoadable: properties into: aDomain
	^ (aDomain adapt: self) isLoadable: properties
! !

!MDImageElement methodsFor: 'domain' stamp: 'cwp 10/16/2009 22:40'!
load: properties into: aDomain
	^ (aDomain adapt: self) load: properties
! !

!MDImageElement methodsFor: 'conflicts' stamp: 'cwp 10/16/2009 22:40'!
merge: aPropertyDictionary into: otherPropertyDictionary in: aDomain onFailure: aBlock
	^ (aDomain adapt: self)
		merge: aPropertyDictionary
		into: otherPropertyDictionary
		onFailure: aBlock! !

!MDImageElement methodsFor: 'converting' stamp: 'dc 6/21/2007 18:31'!
newDefinitionVariant
	"Creates a new definition variant based on the receiver."
	^ MDDefinitionVariant forElement: self! !

!MDImageElement methodsFor: 'converting' stamp: 'dc 6/21/2007 18:31'!
newElementVersion
	"Creates a new version based on the receiver."
	^ self newDefinitionVariant newElementVersion ! !

!MDImageElement methodsFor: 'domain' stamp: 'cwp 10/16/2009 22:40'!
removeFrom: aDomain
	^ (aDomain adapt: self) remove! !

!MDImageElement methodsFor: 'domain' stamp: 'cwp 10/16/2009 22:40'!
update: properties from: aDomain
	^ (aDomain adapt: self) update: properties! !

Object subclass: #MDMarshal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Serialization'!

!MDMarshal commentStamp: 'cwp 11/17/2008 00:53' prior: 0!
I am a stub. The real work of serialization and materialization is done by MDSerializer and MDMaterializer. My purpose is for backward compatibility when updating MC2 itself.!

!MDMarshal class methodsFor: 'public' stamp: 'cwp 4/19/2008 19:49'!
isMemo: aByteArray
	"Evil hack to check whether a serialized object is an instance
	MDMemo, without actually materializing it."
	
	^ aByteArray beginsWith: #(23 5 9 7)! !

!MDMarshal class methodsFor: 'public' stamp: 'cwp 11/17/2008 00:50'!
materialize: aByteArray
	^ MDMaterializer materialize: aByteArray! !

!MDMarshal class methodsFor: 'public' stamp: 'cwp 11/17/2008 00:50'!
materializeFrom: aReadStream
	^ MDMaterializer materializeFrom: aReadStream! !

!MDMarshal class methodsFor: 'initializing' stamp: 'cwp 11/17/2008 00:50'!
resetMap
	MDMaterializer initializeTypes! !

!MDMarshal class methodsFor: 'public' stamp: 'cwp 11/17/2008 01:05'!
serialize: anObject
	"Returns a ByteArray containing a serialized version of the parameter."
	
	^ MDSerializer serialize: anObject! !

!MDMarshal class methodsFor: 'public' stamp: 'cwp 11/17/2008 00:51'!
serialize: anObject on: aWriteStream
	^ MDSerializer serialize: anObject on: aWriteStream! !

Object subclass: #MDMaterializer
	instanceVariableNames: 'decoder'
	classVariableNames: 'Types'
	poolDictionaries: ''
	category: 'Monticello2-Serialization'!

!MDMaterializer class methodsFor: 'as yet unclassified' stamp: 'cwp 4/12/2008 21:13'!
class: aClass
	^ self new setClass: aClass! !

!MDMaterializer class methodsFor: 'as yet unclassified' stamp: 'cwp 9/1/2008 19:39'!
initialize
	self initializeTypes! !

!MDMaterializer class methodsFor: 'as yet unclassified' stamp: 'cwp 11/15/2008 12:29'!
initializeTypes
	Types := #(
		materializeObject
		materializeClass
		materializeClass
		materializeClass
		materializeKnownClass
		materializeNil
		materializeTrue
		materializeFalse
		materializeByte		
		materializeSmallPositiveInteger
		materializeSmallNegativeInteger
		materializeLargePositiveInteger
		materializeLargeNegativeInteger
		materializeSymbol
		materializeUtf8String
		materializeUtf16String
		materializeArray
		materializeSet
		materializeDictionary
		materializeProperties
		materializeTimestamp
		materializeHashstamp
		materializeHashedObject
	)! !

!MDMaterializer class methodsFor: 'as yet unclassified' stamp: 'cwp 11/15/2008 12:57'!
isMemo: aByteArray
	"Evil hack to check whether a serialized object is an instance
	MDMemo, without actually materializing it."

	^ aByteArray beginsWith: #(23 5 9 7)! !

!MDMaterializer class methodsFor: 'as yet unclassified' stamp: 'cwp 8/31/2008 15:57'!
materialize: aByteArray
	^ self materializeFrom: aByteArray readStream! !

!MDMaterializer class methodsFor: 'as yet unclassified' stamp: 'cwp 8/31/2008 15:59'!
materializeFrom: aReadStream
	| instance |
	instance := self on: aReadStream.
	^ instance materialize! !

!MDMaterializer class methodsFor: 'as yet unclassified' stamp: 'cwp 8/31/2008 15:56'!
on: aReadStream
	^ self new setStream: aReadStream! !

!MDMaterializer methodsFor: 'private' stamp: 'cwp 11/15/2008 12:31'!
knownClasses
	^ { 
		MDSliceElement.
		MDDefinitionVariant.
		MDRemovalVariant.
		MDNullVersion.
		MDElementVersion.
		MDSnapshot.
		MDMemo.
		MDFakeElement.
		MDClassElement.
		MDClassCommentElement.
		MDInstVarElement.
		MDClassVarElement.
		MDClassInstVarElement.
		MDPoolImportElement.
		MDMethodElement
	 }! !

!MDMaterializer methodsFor: 'public' stamp: 'cwp 9/1/2008 20:02'!
materialize
	| type selector |
	type := decoder getType.
	selector := Types 
		at: type
		ifAbsent: [ self error: 'unrecognized type' ].
	^ self perform: selector! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 11/15/2008 12:49'!
materializeArray
	| size array |
	size := self materialize.
	array := Array new: size.
	1 	to: size
		do:	[:i | array at: i put: self materialize ].
	^ array! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 11/15/2008 12:49'!
materializeBlockContext
	| method sender pc numArgs startpc home context |
	context := Object new.
	method := self materialize.
	sender := self materialize.
	pc := self materialize.
	numArgs := self materialize.
	startpc := self materialize.
	home := self materialize.
	context become: (BlockContext newForMethod: method).
	context
		home: home startpc: startpc nargs: numArgs ;
		swapSender: sender ;
		pc: pc.
	^ context! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 9/1/2008 19:54'!
materializeByte
	^ decoder getByte! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 11/15/2008 12:49'!
materializeClass
	| name class |
	name := self materialize.
	class := Smalltalk at: name.

	"consume the inst var names"
	self materialize timesRepeat: [ self materialize ].
	^ class! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 11/15/2008 12:49'!
materializeDictionary
	| size dictionary |
	size := self materialize.
	dictionary := Dictionary new: size.
	size timesRepeat: 
		[ dictionary 
			at: self materialize
			put: self materialize ].
	^ dictionary! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 11/15/2008 12:30'!
materializeFalse
	^ false! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 9/1/2008 19:59'!
materializeFloat
	^ decoder getFloat! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 8/9/2009 00:53'!
materializeHashedObject
	| object |
	object := self materialize basicNew.
	1
		to: object class instSize 
		do: [:i | object instVarAt: i put: (self materialize)].
	^ object! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 11/15/2008 12:45'!
materializeHashstamp
	| ts |
	ts := MDHashstamp new.
	decoder getBytesInto: ts.
	^ ts! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 11/15/2008 12:32'!
materializeKnownClass
	| index |
	index := self materialize.
	^ self knownClasses at: index! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 9/2/2008 07:31'!
materializeLargeNegativeInteger
	| size |
	size := self materialize.
	^ (decoder getIntegerOfSize: size) negated! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 9/2/2008 07:31'!
materializeLargePositiveInteger
	| size |
	size := self materialize.
	^ decoder getIntegerOfSize: size! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 11/15/2008 12:49'!
materializeMethodContext
	| method sender pc stackp env receiver context |
	context := Object new.
	method := self materialize.
	sender := self materialize.
	pc := self materialize.
	stackp := self materialize.
	env := self materialize.
	receiver := self materialize.
	context become: (MethodContext newForMethod: method).
	context
		setSender: sender
			receiver: receiver
			method: method
			arguments: #() ;
		pc: pc ;
		stackp: stackp ;
		myEnv: env.
	self readPointersInto: context.
	^ context! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 11/15/2008 12:30'!
materializeNil
	^ nil! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 11/15/2008 12:49'!
materializeObject
	| theClass object tmp |
	object := Object new.
	theClass := self materialize.
	tmp := theClass isVariable 
		ifTrue: [ theClass new: self materialize ]
		ifFalse: [ theClass basicNew ].
	object become: tmp.
	1 
		to: object class instSize
		do: 
			[ : i | 
			object 
				instVarAt: i
				put: self materialize ].
	object class isVariable ifTrue: 
		[ object class isPointers 
			ifTrue: [ self readPointersInto: object ]
			ifFalse: [ decoder getBytesInto: object ] ].
	^ object! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 11/15/2008 12:35'!
materializeProperties
	| size dictionary |
	size := self materialize.
	dictionary := MDPropertyDictionary new: size.
	size timesRepeat: 
		[ dictionary 
			at: self materialize
			put: self materialize ].
	^ dictionary! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 11/15/2008 12:49'!
materializeSet
	| size set |
	size := self materialize.
	set := Set new: size.
	size timesRepeat: [ set add: self materialize ].
	^ set! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 9/1/2008 19:55'!
materializeSingleton
	^ decoder getSingleton! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 9/1/2008 19:57'!
materializeSmallNegativeInteger
	^ decoder getSmallInteger negated! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 9/1/2008 19:58'!
materializeSmallPositiveInteger
	^ decoder getSmallInteger! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 9/2/2008 07:35'!
materializeSymbol
	^ self materializeUtf8String asSymbol! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 11/15/2008 12:45'!
materializeTimestamp
	| ts |
	ts := MDTimestamp new.
	decoder getBytesInto: ts.
	^ ts! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 11/15/2008 12:30'!
materializeTrue
	^ true! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 9/2/2008 07:42'!
materializeUtf16String
	| size |
	size := self materialize.
	^ decoder getUtf16StringOfSize: size.
	! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 9/2/2008 07:41'!
materializeUtf8String
	| size |
	size := self materialize.
	^ decoder getUtf8StringOfSize: size.
	! !

!MDMaterializer methodsFor: 'as yet unclassified' stamp: 'cwp 4/8/2008 20:14'!
read: type with: aMarshal
	| object |
	object := self objectOfType: type.
	self readState: object with: aMarshal.
	^ object! !

!MDMaterializer methodsFor: 'as yet unclassified' stamp: 'cwp 4/8/2008 20:14'!
readBytes: anObject with: aMarshal
	1 
		to: anObject byteSize 
		do: [:index | anObject byteAt: index put: aMarshal read]! !

!MDMaterializer methodsFor: 'as yet unclassified' stamp: 'cwp 4/8/2008 20:15'!
readPointers: anObject with: aMarshal
	1 
		to: anObject size 
		do: [:index | anObject at: index put: aMarshal materialize]! !

!MDMaterializer methodsFor: 'private' stamp: 'cwp 9/3/2008 19:43'!
readPointersInto: anObject 

	1	to: anObject size
		do:	[ :i | anObject at: i put: self materialize ]! !

!MDMaterializer methodsFor: 'as yet unclassified' stamp: 'cwp 4/12/2008 21:13'!
setClass: aClass
	class := aClass! !

!MDMaterializer methodsFor: 'initialize-release' stamp: 'cwp 11/15/2008 12:47'!
setStream: aStream 
	decoder := MDObjectDecoder on: aStream.
	! !

Object subclass: #MDMerge
	instanceVariableNames: 'local remote resolution'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Utilities'!

!MDMerge class methodsFor: 'instance creation' stamp: 'jf 9/8/2009 16:32'!
toInclude: aVersion in: aWorkspace 
	| local |
	local := aWorkspace versionForElement: aVersion element.
	^ self basicNew setLocal: local remote: aVersion.
! !

!MDMerge methodsFor: 'operations' stamp: 'jf 9/8/2009 16:33'!
applyTo: aWorkspace
	aWorkspace includeVersion: resolution onConflict: [:l :r | r variant]! !

!MDMerge methodsFor: 'operations' stamp: 'cwp 5/22/2008 00:10'!
chooseLocal
	resolution := local! !

!MDMerge methodsFor: 'operations' stamp: 'cwp 5/22/2008 00:10'!
chooseRemote
	resolution := remote! !

!MDMerge methodsFor: 'printing' stamp: 'cwp 10/25/2008 14:39'!
displayOn: aStream
	self remote element printOn: aStream! !

!MDMerge methodsFor: 'testing' stamp: 'cwp 3/17/2005 23:21'!
isConflict
	^ remote conflictsWith: local! !

!MDMerge methodsFor: 'testing' stamp: 'cwp 3/17/2005 23:16'!
isLocal
	^ resolution == local! !

!MDMerge methodsFor: 'testing' stamp: 'avi 3/21/2006 00:14'!
isNoOp
	^ local = remote! !

!MDMerge methodsFor: 'testing' stamp: 'cwp 3/17/2005 23:19'!
isRemote
	^ resolution == remote! !

!MDMerge methodsFor: 'testing' stamp: 'cwp 6/9/2005 09:01'!
isResolved
	^ resolution notNil! !

!MDMerge methodsFor: 'accessing' stamp: 'cwp 3/17/2005 23:28'!
local
	^ local! !

!MDMerge methodsFor: 'accessing' stamp: 'cwp 3/17/2005 23:28'!
remote
	^ remote! !

!MDMerge methodsFor: 'accessing' stamp: 'cwp 3/17/2005 23:28'!
resolution
	^ resolution! !

!MDMerge methodsFor: 'initialize-release' stamp: 'cwp 5/22/2008 00:10'!
setLocal: localVersion remote: remoteVersion
	local := localVersion.
	remote := remoteVersion.
	resolution := local successor: remote! !

Object subclass: #MDObjectDecoder
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Serialization'!

!MDObjectDecoder class methodsFor: 'as yet unclassified' stamp: 'cwp 9/2/2008 07:38'!
on: aReadStream
	^ self new setStream: aReadStream! !

!MDObjectDecoder methodsFor: 'public' stamp: 'cwp 8/31/2008 19:30'!
getByte
	^ stream next! !

!MDObjectDecoder methodsFor: 'public' stamp: 'cwp 9/2/2008 00:50'!
getBytesInto: anObject 
	1 
		to: anObject byteSize
		do: 
			[ : index | 
			anObject 
				byteAt: index
				put: stream next ]! !

!MDObjectDecoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:32'!
getFloat
	| hi lo |
	hi := self getIntegerOfSize: 4.
	lo := self getIntegerOfSize: 4.
	^ (Float basicNew: 2)
		at: 1 put: hi;
		at: 2 put: lo;
		yourself! !

!MDObjectDecoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:32'!
getIntegerOfSize: size 
	| value |
	value := 0.
	size timesRepeat: [value := (value bitShift: 8) bitOr: stream next].
	^ value! !

!MDObjectDecoder methodsFor: 'public' stamp: 'cwp 9/1/2008 19:34'!
getSingleton
	| index |
	index := stream next.
	^ #(nil true false) at: index! !

!MDObjectDecoder methodsFor: 'public' stamp: 'cwp 8/31/2008 16:46'!
getSmallInteger
	| hi lo |
	hi := stream next.
	lo := stream next.
	^ (hi bitShift: 8) + lo! !

!MDObjectDecoder methodsFor: 'public' stamp: 'cwp 8/31/2008 16:45'!
getType
	^ stream next! !

!MDObjectDecoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:44'!
getUtf16StringOfSize: size 
	| string |
	string := WideString new: size.
	1 to: size do: 
		[ :index | 
		string at: index put: self readUtf16Character ].
	^ string! !

!MDObjectDecoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:43'!
getUtf8StringOfSize: size
	| string |
	string := ByteString new: size.
	1 to: size do: [:index | string at: index put: self readUtf8Character].
	^ string! !

!MDObjectDecoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:39'!
readTwoBytes
	| hi lo |
	hi := stream next.
	lo := stream next.
	^ (hi bitShift: 8) bitOr: lo! !

!MDObjectDecoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:37'!
readUtf16Character
	| value |
	value := self readTwoBytes.
	^ (value < 56320 or: [ value > 57343 ]) 
		ifTrue: [ Unicode value: value ]
		ifFalse: [ self readUtf16CharacterGiven: value ]! !

!MDObjectDecoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:44'!
readUtf16CharacterGiven: first
	| second |
	second := self readTwoBytes.
	^ Unicode value: ((first bitShift: 10) bitOr: second) + 16r10000! !

!MDObjectDecoder methodsFor: 'private' stamp: 'cwp 9/9/2008 08:00'!
readUtf8Character
	| value |
	value := stream next.
	value <= 127 
		ifTrue: [ ^ Unicode value: value ]
		ifFalse: 
			[value <= 223 
				ifTrue: 
					[ value := (value bitAnd: 31) bitShift: 6.
					value := value bitOr: (stream next bitAnd: 63)]
				ifFalse: 
					[ value := (value bitAnd: 15) bitShift: 12.
					value := value bitOr: ((stream next bitAnd: 63) bitShift: 6).
					value := value bitOr: (stream next bitAnd: 63)].
			^ Unicode value: value ]! !

!MDObjectDecoder methodsFor: 'initialize-release' stamp: 'cwp 9/2/2008 07:38'!
setStream: aReadStream 
	stream := aReadStream.
! !

Object subclass: #MDObjectEncoder
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Serialization'!

MDObjectEncoder class
	instanceVariableNames: 'stream'!

MDObjectEncoder class
	instanceVariableNames: 'stream'!

!MDObjectEncoder class methodsFor: 'as yet unclassified' stamp: 'cwp 8/31/2008 16:30'!
on: aWriteStream
	^ self new setStream: aWriteStream! !

!MDObjectEncoder methodsFor: 'public' stamp: 'cwp 8/31/2008 19:24'!
putByte: anInteger
	stream nextPut: anInteger! !

!MDObjectEncoder methodsFor: 'public' stamp: 'cwp 9/2/2008 00:44'!
putBytesFrom: anObject
	1 
		to: anObject byteSize 
		do: [:index | stream nextPut: (anObject byteAt: index)]! !

!MDObjectEncoder methodsFor: 'public' stamp: 'cwp 8/31/2008 20:19'!
putFloat: aFloat
	self write32BitInteger: (aFloat at: 1).
	self write32BitInteger: (aFloat at: 2).! !

!MDObjectEncoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:24'!
putLargeInteger: anInteger size: size
	| byte |
	(size - 1 to: 0 by: -1) do:
		[:index |
		byte := (anInteger bitShift: index * -8) bitAnd: 255.
		stream nextPut: byte]! !

!MDObjectEncoder methodsFor: 'public' stamp: 'cwp 11/12/2008 20:39'!
putSingleton: anObject
	| index |
	index := #(nil true false) indexOf: anObject.
	stream nextPut: index + 5! !

!MDObjectEncoder methodsFor: 'public' stamp: 'cwp 8/31/2008 16:38'!
putSmallInteger: anInteger
	stream nextPut: (anInteger bitShift: -8).
	stream nextPut: (anInteger bitAnd: 255). 3! !

!MDObjectEncoder methodsFor: 'public' stamp: 'cwp 8/31/2008 16:28'!
putType: aByte
	stream nextPut: aByte! !

!MDObjectEncoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:25'!
putUtf16String: aString
	| value |
	aString do:
		[:char |
		value := char asUnicode.
		value < 16r10000 
			ifTrue: [self writeTwoByteCode: value]
			ifFalse: [self writeFourByteCode: value]]! !

!MDObjectEncoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:25'!
putUtf8String: aString
	
	aString do: [ :char | self writeUtf8Code: char asUnicode ]! !

!MDObjectEncoder methodsFor: 'initialize-release' stamp: 'cwp 8/31/2008 16:30'!
setStream: aWriteStream
	stream := aWriteStream! !

!MDObjectEncoder methodsFor: 'private' stamp: 'cwp 8/31/2008 20:18'!
write32BitInteger: anInteger
	stream		
		nextPut: (anInteger bitShift: -24);
		nextPut: ((anInteger bitShift: -16) bitAnd: 255);
		nextPut: ((anInteger bitShift: -8) bitAnd: 255);
		nextPut: (anInteger bitAnd: 255)! !

!MDObjectEncoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:28'!
writeFourByteCode: anInteger
	| value |
	value := 16r10000 - anInteger.
	stream nextPut: ((value bitShift: -18) bitOr: 16rD8).
	stream nextPut: ((value bitShift: -10) bitAnd: 16rFF).
	stream nextPut: ((value bitShift: -8) bitOr: 16rDC).
	stream nextPut: (value bitAnd: 16rFF).
	

! !

!MDObjectEncoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:27'!
writeTwoByteCode: value
	stream nextPut: (value bitShift: -8).
	stream nextPut: (value bitAnd: 16rFF).! !

!MDObjectEncoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:23'!
writeUtf8Code: value
	value <= 16r7F
		ifTrue: [stream nextPut: value]
		ifFalse:
			[value <= 16r7FF
				ifTrue: 
					[stream nextPut: ((value bitShift: -6) bitOr: 16rC0).
					stream nextPut: ((value bitAnd: 16r3F) bitOr: 16r80)]
				ifFalse:
					[value <= 16rFFFF
						ifTrue:
							[stream nextPut: ((value bitShift: -12) bitOr: 16rE0).
							stream nextPut: (((value bitShift: -6) bitAnd: 16r3F) bitOr: 16r80).
							stream nextPut: ((value bitAnd: 16r3F) bitOr: 16r80)]]]! !

Object subclass: #MDPearsonsHash
	instanceVariableNames: ''
	classVariableNames: 'Cipher'
	poolDictionaries: ''
	category: 'Monticello2-Utilities'!

!MDPearsonsHash class methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2009 18:40'!
hashMessage: bytes
	^ self new 
		nextPutAll: bytes; 
		value! !

!MDPearsonsHash class methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2009 18:12'!
initialize
	Cipher := #(233 180 75 24 226 106 137 114 122 62 201 20 96 23 73 237 93 103 79 225 171 241 221 29 194 113 136 44 207 250 45 83 209 15 158 87 248 35 7 153 116 42 95 230 178 216 26 232 57 150 58 48 2 71 117 195 165 173 214 60 161 200 249 220 77 191 97 166 193 227 52 46 31 92 143 167 164 236 224 134 56 142 243 185 197 247 217 246 179 80 244 22 21 231 32 155 124 49 204 205 182 54 133 18 14 211 64 76 47 163 13 156 90 212 28 187 210 128 102 138 132 121 17 40 104 39 61 101 170 151 98 186 91 126 115 119 235 206 125 55 30 229 99 145 111 9 127 218 43 86 65 123 59 130 19 251 53 74 94 172 34 240 36 51 141 160 12 139 78 38 89 3 203 234 254 188 11 162 184 41 222 112 109 105 140 154 33 50 147 190 245 107 181 208 88 189 6 242 66 175 110 16 149 135 100 129 0 196 183 157 152 228 63 255 144 252 199 69 27 146 118 192 131 215 37 177 68 148 4 168 81 213 8 253 223 169 1 120 159 5 198 67 238 108 239 176 174 72 10 85 202 70 84 82 25 219) asByteArray! !

!MDPearsonsHash methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2009 18:01'!
initialize
	value := 0! !

!MDPearsonsHash methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2009 19:40'!
next: count putAll: aCollection startingAt: start
	start to: start + count -1 do:
		[:index | self nextPut: (aCollection byteAt: index)]! !

!MDPearsonsHash methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2009 18:36'!
nextPut: aByte
	value := Cipher at: (aByte bitXor: value) + 1! !

!MDPearsonsHash methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2009 18:39'!
nextPutAll: aCollection
	1 
		to: aCollection byteSize 
		do:
			[:i | self nextPut: (aCollection byteAt: i)]! !

!MDPearsonsHash methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2009 18:31'!
printOn: aStream
	self class printOn: aStream.
	aStream nextPut: $(.
	value printOn: aStream.
	aStream nextPut: $)! !

!MDPearsonsHash methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2009 18:01'!
value
	^ value! !

Object subclass: #MDRegistry
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Project'!

!MDRegistry class methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2008 18:53'!
new
	^ self basicNew initialize! !

!MDRegistry methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 22:23'!
commit! !

!MDRegistry methodsFor: 'testing' stamp: 'cwp 11/9/2007 21:42'!
includesId: id
	^ objects includesKey: id! !

!MDRegistry methodsFor: 'initialization' stamp: 'cwp 5/22/2008 00:10'!
initialize
	objects := Dictionary new.
	! !

!MDRegistry methodsFor: 'accessing' stamp: 'cwp 6/14/2008 13:32'!
objectWithId: id
	^ objects at: id ifAbsent: [nil]! !

!MDRegistry methodsFor: 'accessing' stamp: 'cwp 8/14/2009 18:13'!
objectWithId: id ifAbsent: aBlock
	^ objects at: id ifAbsent: aBlock! !

!MDRegistry methodsFor: 'accessing' stamp: 'cwp 11/9/2007 22:00'!
objectWithId: id satisfies: aBlock
	^ aBlock value: (objects at: id ifAbsent: [^ false])! !

!MDRegistry methodsFor: 'accessing' stamp: 'cwp 11/9/2007 21:29'!
objects
	^ objects values! !

!MDRegistry methodsFor: 'adding' stamp: 'jf 9/26/2009 01:46'!
register: anObject
	^ objects at: anObject id put: anObject! !

!MDRegistry methodsFor: 'removing' stamp: 'cwp 11/19/2007 23:36'!
unregister: anObject
	^ self unregisterId: anObject id! !

!MDRegistry methodsFor: 'removing' stamp: 'jf 9/8/2009 23:36'!
unregister: anObject ifAbsent: absentBlock
	^ self unregisterId: anObject id ifAbsent: absentBlock! !

!MDRegistry methodsFor: 'removing' stamp: 'jf 9/8/2009 23:34'!
unregisterId: id
	^ self unregisterId: id ifAbsent: [nil]! !

!MDRegistry methodsFor: 'removing' stamp: 'jf 9/8/2009 23:34'!
unregisterId: id ifAbsent: absentBlock
	^ objects removeKey: id ifAbsent: absentBlock! !

Object subclass: #MDReplicator
	instanceVariableNames: 'source dest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Utilities'!

!MDReplicator class methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 20:31'!
from: sourceRepository to: destRepository
	^ self new setSource: sourceRepository destination: destRepository! !

!MDReplicator methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 20:46'!
copyAll
	source memos do: [:ea | self copyMemo: ea]! !

!MDReplicator methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 20:40'!
copyMemo: aMemo
	| objects snapshot |
	objects := Set new.
	objects add: aMemo.
	snapshot := source get: aMemo reference.
	objects add: snapshot.
	objects addAll: (snapshot getVersionsFrom: source).
	dest putAll: objects! !

!MDReplicator methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 21:03'!
reject: aBlock
	source memos do:
		[:memo | 
		(aBlock value: memo) ifFalse: [self copyMemo: memo]]! !

!MDReplicator methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 20:59'!
select: aBlock
	source memos do:
		[:memo | 
		(aBlock value: memo) ifTrue: [self copyMemo: memo]]! !

!MDReplicator methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 20:31'!
setSource: sourceRepository destination: destRepository
	source := sourceRepository.
	dest := destRepository.! !

Object subclass: #MDSerializer
	instanceVariableNames: 'encoder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Serialization'!

!MDSerializer class methodsFor: 'instance creation' stamp: 'cwp 8/31/2008 15:47'!
on: aWriteStream
	^ self new setStream: aWriteStream! !

!MDSerializer class methodsFor: 'serializing' stamp: 'cwp 11/11/2008 23:19'!
serialize: anObject
	| stream |
	stream := (ByteArray new: 100) writeStream.
	self serialize: anObject on: stream.
	^ stream contents! !

!MDSerializer class methodsFor: 'serializing' stamp: 'cwp 11/11/2008 23:19'!
serialize: anObject on: aStream
	(self on: aStream) serialize: anObject.
	! !

!MDSerializer class methodsFor: 'as yet unclassified' stamp: 'cwp 4/8/2008 20:49'!
type: anInteger
	^ self new setType: anInteger! !

!MDSerializer methodsFor: 'private' stamp: 'cwp 9/4/2008 08:03'!
indexOf: anObject in: anIndex ifPresent: pBlock ifAbsent: aBlock
	| id |
	(anIndex includesKey: anObject)
		ifTrue: 
			[id := anIndex at: anObject.
			pBlock value: id]
		ifFalse:
			[id := anIndex size + 1.
			anIndex at: anObject put: id.
			aBlock value: id].
	
		! !

!MDSerializer methodsFor: 'private' stamp: 'cwp 11/15/2008 11:54'!
knownClasses
	^ { 
		MDSliceElement.
		MDDefinitionVariant.
		MDRemovalVariant.
		MDNullVersion.
		MDElementVersion.
		MDSnapshot.
		MDMemo.
		MDFakeElement.
		MDClassElement.
		MDClassCommentElement.
		MDInstVarElement.
		MDClassVarElement.
		MDClassInstVarElement.
		MDPoolImportElement.
		MDMethodElement
	 }! !

!MDSerializer methodsFor: 'public' stamp: 'cwp 11/20/2008 19:18'!
serialize: anObject 
	anObject mdSerializeWith: self! !

!MDSerializer methodsFor: 'private' stamp: 'cwp 11/11/2008 23:05'!
serialize: anObject with: aBlock 
	aBlock value! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 20:24'!
serializeArray: anArray
	self serialize: anArray with:
		[encoder putType: 17.
		self serialize: anArray size.
		anArray do: [:ea | self serialize: ea]]! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 9/23/2008 07:50'!
serializeBlockContext: aContext
	self serialize: aContext with:
		[encoder putType: 21.
		self serialize: aContext method.
		self serialize: aContext sender.
		self serialize: aContext pc.
		self serialize: aContext numArgs.
		self serialize: aContext startpc.
		self serialize: aContext home]! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 20:30'!
serializeByte: anInteger 
	encoder putType: 9.
	encoder putByte: anInteger.
	! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/15/2008 11:54'!
serializeClass: aClass
	| index |
	index := self knownClasses indexOf: aClass.
	index = 0
		ifTrue: [self serializeFullClass: aClass]
		ifFalse:
			[encoder putType: 5.
			self serialize: index]! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 22:59'!
serializeDictionary: aDictionary

	encoder putType: 19.
	self serialize: aDictionary size.
	aDictionary keys asArray sort do:
		[:key |
		self serialize: key.
		self serialize: (aDictionary at: key)]! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 8/31/2008 19:51'!
serializeFloat: aFloat
	encoder putType: 16.
	encoder putFloat: aFloat! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/15/2008 11:51'!
serializeFullClass: aClass
	| type vars |
	
	type :=  aClass isVariable 
		ifFalse: [2]				"named inst vars only"
		ifTrue: 
			[aClass isPointers 
				ifTrue: [3]		"named + indexed object references"
				ifFalse: [4]].	"bytes or words"
		
	encoder putType: type.
	vars := aClass allInstVarNames.
	self serialize: aClass name.
	self serialize: vars size.
	vars do: [:ea | self serialize: ea]! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 8/9/2009 00:56'!
serializeHashedObject: anObject
	encoder putType: 23.
	self serialize: anObject class.
	1
		to: anObject class instSize
		do: [:i | self serialize: (anObject instVarAt: i)]! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 22:17'!
serializeHashstamp: aHashstamp
	encoder putType: 22.
	encoder putBytesFrom: aHashstamp! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 21:54'!
serializeInteger: anInteger 
	anInteger < -65535 ifTrue: 
		[ ^ self 
			writeLargeInteger: anInteger negated
			type: 13 ].
	anInteger < 0 ifTrue: [ ^ self serializeSmallNegativeInteger: anInteger ].
	anInteger < 256 ifTrue: [ ^ self serializeByte: anInteger ].
	anInteger < 65535 ifTrue: [ ^ self serializeSmallPositiveInteger: anInteger ].
	self 
		writeLargeInteger: anInteger
		type: 12! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 22:02'!
serializeMethodContext: aContext 
	self 
		serialize: aContext
		with: 
			[ encoder putType: 22.
			self serialize: aContext method.
			self serialize: aContext sender.
			self serialize: aContext pc.
			self serialize: aContext stackPtr.
			self serialize: aContext myEnv.
			self serialize: aContext receiver.
			self writePointersFrom: aContext ]! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 22:03'!
serializeObject: anObject 
	encoder putType: 1.
	self serialize: anObject class.
	1	to: anObject class instSize
		do: [:i | self serialize: (anObject instVarAt: i)].
	anObject class isVariable ifTrue: 
		[self serialize: anObject size.
		anObject class isPointers 
			ifTrue: [self writePointersFrom: anObject]
			ifFalse: [encoder putBytesFrom: anObject]]! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 23:00'!
serializeProperties: aPropertyDictionary
	encoder putType: 20.
	self serialize: aPropertyDictionary size.
	aPropertyDictionary keys asArray sort do:
		[:key |
		self serialize: key.
		self serialize: (aPropertyDictionary at: key)]! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 9/3/2008 19:15'!
serializeReference: anInteger
	encoder putType: 2.
	self serialize: anInteger! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 21:43'!
serializeSet: aSet
	encoder putType: 18.
	self serialize: aSet size.
	aSet do: [:ea | self serialize: ea]! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 20:39'!
serializeSingleton: anObject
	encoder putSingleton: anObject! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 20:29'!
serializeSmallNegativeInteger: anInteger 
	encoder putType: 11.
	encoder putSmallInteger: anInteger abs.
	! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 20:31'!
serializeSmallPositiveInteger: anInteger 
	encoder putType: 10.
	encoder putSmallInteger: anInteger.
	! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 21:11'!
serializeSymbol: aSymbol
	encoder putType: 14.
	self serialize: aSymbol size.
	encoder putUtf8String: aSymbol! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 22:11'!
serializeTimestamp: aTimestamp
	encoder putType: 21.
	encoder putBytesFrom: aTimestamp! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 20:51'!
serializeUtf16String: aString
	encoder putType: 16.
	self serialize: aString size.
	encoder putUtf16String: aString! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 20:51'!
serializeUtf8String: aString
	encoder putType: 15.
	self serialize: aString size.
	encoder putUtf8String: aString! !

!MDSerializer methodsFor: 'initialize-release' stamp: 'cwp 11/11/2008 23:10'!
setStream: aWriteStream 
	encoder := MDObjectEncoder on: aWriteStream.
	! !

!MDSerializer methodsFor: 'as yet unclassified' stamp: 'cwp 4/8/2008 20:50'!
setType: anInteger
	type := anInteger! !

!MDSerializer methodsFor: 'as yet unclassified' stamp: 'cwp 4/12/2008 02:19'!
write: anObject with: aMarshal
	aMarshal write: type.
	self writeState: anObject with: aMarshal! !

!MDSerializer methodsFor: 'private' stamp: 'cwp 9/2/2008 07:23'!
writeLargeInteger: anInteger type: type 
	| size |
	encoder putType: type.
	size := (anInteger log: 256) floor + 1.
	self serialize: size.
	encoder putLargeInteger: anInteger size: size.
	^ self! !

!MDSerializer methodsFor: 'private' stamp: 'cwp 11/12/2008 22:02'!
writePointersFrom: anObject 
	1	to: anObject size
		do: [ :i | self serialize: (anObject at: i) ]! !

!MDSerializer methodsFor: 'as yet unclassified' stamp: 'cwp 3/1/2008 23:45'!
writeState: anObject with: aMarshal! !

Object subclass: #MDTestBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 10/16/2005 13:43'!
definition
	^ MDDefinitionVariant forElement: self element! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 5/22/2008 00:10'!
definition: aSymbol
	| definition |
	definition := MDDefinitionVariant forElement: (self element: aSymbol).
	definition properties at: #one put: 1.
	^ definition! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:31'!
element
	^ self element: #Alpha! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:31'!
element: aSymbol
	^ MDFakeElement named: aSymbol! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:31'!
elements
	^ Set
		with: (MDFakeElement named: #Alpha)
		with: (MDFakeElement named: #Beta)! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 1/19/2007 22:26'!
memo
	^ self memo: #abc! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 1/19/2007 22:28'!
memo: aSymbol
	^ MDMemo
		snapshot: self snapshot
		slice: self slice
		parents: Set new
		properties: (MDPropertyDictionary new id: aSymbol; yourself)! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 9/4/2009 16:42'!
merge
	^ self mergeIn: MDEnvironment forTesting! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 12/16/2007 22:41'!
mergeIn: wc
	
	wc loadVersion: (self versionWith: 'alpha').
	^ MDMerge
		toInclude: (self versionWith: 'beta')
		in: wc.! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 10/16/2005 13:45'!
removal
	^ MDRemovalVariant forElement: self element! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 10/16/2005 13:45'!
removal: aSymbol
	^ MDRemovalVariant forElement: (self element: aSymbol)! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 1/19/2007 23:12'!
slice
	^ MDExplicitSlice named: 'TestSlice'.! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'jf 10/21/2009 16:43'!
sliceVariant
	| slice variant environment domain |
	environment := MDEnvironment forTesting.
	domain := environment addDomain: (MDMonticelloDomain on: environment).
	slice := environment addSlice: self slice.
	variant := MDDefinitionVariant forElement: slice asElement.
	domain updateVariant: variant.
	^ variant! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 7/23/2008 07:14'!
sliceVersion
	^ MDElementVersion variant: self sliceVariant! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:09'!
snapshot
	^ self snapshot: [:versions | ].
! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 7/23/2008 07:10'!
snapshot: aBlock
	| versions |
	versions := Set new.	
	versions 
		add: (self versionFor: #Alpha with: 'alpha');
		add: (self versionFor: #Beta with: 'beta')	.
	aBlock value: versions.
	^ MDSnapshot withVersions: versions! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 10/16/2005 14:12'!
updateVersion: anElementVersion property: aSymbol put: anObject 
	| newVariant |
	newVariant := anElementVersion variant copy.
	newVariant properties at: aSymbol put: anObject.
	^MDElementVersion 
		variant: newVariant
		ancestry: anElementVersion fullAncestry! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 10/16/2005 14:39'!
version
	^ MDElementVersion variant: self definition! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 3/25/2005 22:55'!
versionFor: elementName
	^ self versionFor: elementName with: elementName asLowercase! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 5/22/2008 00:10'!
versionFor: elementName with: value
	| element snapshot |
	element := MDFakeElement named: elementName.
	snapshot := MDDefinitionVariant forElement: element.
	snapshot properties at: #one put: value.
	^ MDElementVersion variant: snapshot! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 5/22/2008 00:10'!
versionWith: value
	| snapshot |
	snapshot := MDDefinitionVariant forElement: self element.
	snapshot properties at: #one put: value.
	^ MDElementVersion variant: snapshot! !

Object subclass: #MDTimestampPrinter
	instanceVariableNames: 'year month day hours minutes seconds'
	classVariableNames: 'MDMap MDMonthNames'
	poolDictionaries: ''
	category: 'Monticello2-Utilities'!

!MDTimestampPrinter commentStamp: 'cwp 4/9/2005 04:06' prior: 0!
%V - If the week containing 1 January has four or more days in the new year, then it is considered week 1. Otherwise, it is the last week of the previous year, and the next week is week 1.
%W - the week number of the year (Monday as the first day of the week) as a decimal number [00,53]. All days in a new year preceding the first Monday are considered to be in week 0.!

!MDTimestampPrinter class methodsFor: 'class initialization' stamp: 'cwp 10/2/2008 20:15'!
initialize
	MDMonthNames := #(
		#January
		#February
		#March
		#April
		#May
		#June
		#July
		#August
		#September
		#Ocober
		#November
		#December
	).
	MDMap := Dictionary new.
	MDMap
		at: $a
			put: #abbreviatedWeekdayName:;
		at: $A
			put: #fullWeekdayName:;
		at: $b
			put: #abbreviatedMonthName:;
		at: $B
			put: #fullMonthName:;
		at: $C
			put: #centuryNumber:;
		at: $d
			put: #paddedDay:;
		at: $D
			put: #usDate:;
		at: $e
			put: #unpaddedDay:;
		at: $h
			put: #unpaddedHour24;
		at: $H
			put: #paddedHour24:;
		at: $i
			put: #unpaddedHour12:;
		at: $I
			put: #paddedHour12:;
		at: $j
			put: #dayOfYear:;
		at: $l
			put: #unpaddedMonth:;
		at: $m
			put: #paddedMonth:;
		at: $M
			put: #paddedMinute:;
		at: $n
			put: #newline:;
		at: $p
			put: #ampm:;
		at: $S
			put: #paddedSecond:;
		at: $t
			put: #tab:;
		at: $u
			put: #weekDayMonday:;
		at: $U
			put: #weekNumberSunday:;
		at: $V
			put: #weekNumberMonday:;
		at: $w
			put: #weekDaySunday:;
		at: $W
			put: #weekNumberMonday2:;
		at: $y
			put: #yearShort:;
		at: $Y
			put: #yearLong:;
		at: $%
			put: #percent:! !

!MDTimestampPrinter class methodsFor: 'instance creation' stamp: 'cwp 4/9/2005 03:03'!
year: year month: month day: day hours: hours minutes: minutes seconds: seconds
	^ self new
		year: year;
		month: month;
		day: day;
		hours: hours;
		minutes: minutes;
		seconds: seconds;
		yourself! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 10/2/2008 20:15'!
abbreviatedMonthName: aStream 
	aStream nextPutAll: ((MDMonthNames at: month) first: 3)! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 04:22'!
ampm: aStream
	aStream nextPutAll: (hours > 12 ifFalse: ['am'] ifTrue: ['pm'])! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:07'!
day
	^day! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:07'!
day: anObject
	day := anObject! !

!MDTimestampPrinter methodsFor: 'errors' stamp: 'cwp 10/2/2008 20:15'!
doesNotUnderstand: aMessage 
	(MDMap values includes: aMessage selector) ifTrue: [ self error: 'Unimplemented specifier' ].
	^ super doesNotUnderstand: aMessage! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 10/2/2008 20:15'!
fullMonthName: aStream 
	aStream nextPutAll: (MDMonthNames at: month)! !

!MDTimestampPrinter methodsFor: 'private' stamp: 'cwp 5/22/2008 00:10'!
hour12
	| int |
	int := hours \\ 12.
	int = 0 ifTrue: [int := 12].
	^ int! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
hours
	^hours! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
hours: anObject
	hours := anObject! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
minutes
	^minutes! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
minutes: anObject
	minutes := anObject! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
month
	^month! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
month: anObject
	month := anObject! !

!MDTimestampPrinter methodsFor: 'private' stamp: 'cwp 4/9/2005 03:52'!
pad: anInteger on: aStream
	anInteger < 10 ifTrue: [aStream nextPut: $0]! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 03:52'!
paddedDay: aStream
	self pad: day on: aStream.
	self unpaddedDay: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 5/22/2008 00:10'!
paddedHour12: aStream
	| int |
	int := self hour12.
	self pad: int on: aStream.
	int printOn: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 03:58'!
paddedHour24: aStream
	self pad: hours on: aStream.
	hours printOn: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 03:57'!
paddedMinute: aStream
	self pad: minutes on: aStream.
	minutes printOn: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 03:51'!
paddedMonth: aStream
	self pad: month on: aStream.
	self unpaddedMonth: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 04:21'!
paddedSecond: aStream
	self pad: seconds on: aStream.
	seconds printOn: aStream! !

!MDTimestampPrinter methodsFor: 'printing' stamp: 'cwp 5/22/2008 00:10'!
printFormat: aString
	| stream |
	stream := (String new: 10) writeStream.
	self printOn: stream format: aString.
	^ stream contents! !

!MDTimestampPrinter methodsFor: 'printing' stamp: 'cwp 5/22/2008 00:10'!
printOn: aStream format: aString
	| specification char |
	specification := aString readStream.
	[specification atEnd]	 whileFalse: 
		[char := specification next.
		char = $%
			ifTrue: [self printOn: aStream specifier: specification next]
			ifFalse: [aStream nextPut: char]]! !

!MDTimestampPrinter methodsFor: 'printing' stamp: 'cwp 10/2/2008 20:15'!
printOn: aStream specifier: aCharacter 
	| selector |
	selector := MDMap 
		at: aCharacter
		ifAbsent: [ self error: 'Unrecognized specifier: ' , aCharacter ].
	self 
		perform: selector
		with: aStream! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:01'!
seconds
	^seconds! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:01'!
seconds: anObject
	seconds := anObject! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 03:52'!
unpaddedDay: aStream
	day printOn: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 04:20'!
unpaddedHour12: aStream
	self hour12 printOn: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 03:47'!
unpaddedMonth: aStream
	month printOn: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 04:08'!
weekNumberMonday
	"From the Unix spec: 'If the week containing 1 January has four or more days
	in the new year, then it is considered week 1. Otherwise, it is the last week of
	the previous year, and the next week is week 1.'"

	self error: 'Unimplemented Specifier'! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 04:08'!
weekNumberMonday2
	"From the Unix spec: 'If the week containing 1 January has four or more days in the new year, 
	then it is considered week 1. Otherwise, it is the last week of the previous year, 
	and the next week is week 1.'"

	self error: 'Unimplemented Specifier'! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
year
	^year! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
year: anObject
	year := anObject! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 03:53'!
yearLong: aStream
	year printOn: aStream! !

Object subclass: #MDVariant
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDVariant commentStamp: 'dc 6/14/2007 06:15' prior: 0!
A variant describes the state of a particular element. That state might be "not present in the image," in the case of a RemovalVariant, or the properties of the element, in the case of a DefinitionVariant. One of the things that we noticed with MC1 is that the exact components of a definition are most likely to change, so we encode them using a PropertyDictionary instead of dedicated objects.!

MDVariant subclass: #MDDefinitionVariant
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDDefinitionVariant commentStamp: 'dc 6/14/2007 06:28' prior: 0!
A variant describes the state of a particular element. That state is the properties of the element, in the case of this class. One of the things that we noticed with MC1 is that the exact components of a definition are most likely to change, so we encode them using a PropertyDictionary instead of dedicated objects.!

!MDDefinitionVariant methodsFor: 'comparing' stamp: 'dc 6/14/2007 06:21'!
= other
	^ super = other
		and: [self properties = other properties]! !

!MDDefinitionVariant methodsFor: 'conflicts' stamp: 'jf 10/4/2009 20:21'!
autoMergeWith: aVariant in: aDomain 
	^aVariant autoMergeWithDefinition: self in: aDomain! !

!MDDefinitionVariant methodsFor: 'conflicts' stamp: 'jf 10/4/2009 20:21'!
autoMergeWithDefinition: anElementDefinition in: aDomain
	| newDefinition |
	newDefinition := self copy.
	element
		merge: anElementDefinition properties
		into: newDefinition properties
		in: aDomain
		onFailure: [^ nil].
	^ newDefinition! !

!MDDefinitionVariant methodsFor: 'conflicts' stamp: 'jf 10/4/2009 20:21'!
autoMergeWithRemoval: aRemovalVariant in: aDomain 
	element alwaysPreferRemoval ifTrue: [^aRemovalVariant].
	element alwaysPreferDefinition ifTrue: [^self].
	^nil! !

!MDDefinitionVariant methodsFor: 'copying' stamp: 'dc 6/14/2007 06:23'!
copy
	| new |
	new := self species forElement: element.
	properties keysAndValuesDo:
		[:k :v|
		new properties at: k put: v].
	^ new! !

!MDDefinitionVariant methodsFor: 'comparing' stamp: 'dc 6/14/2007 06:22'!
hash
	^ super hash bitXor: self properties hash! !

!MDDefinitionVariant methodsFor: 'initialize-release' stamp: 'dc 6/14/2007 06:18'!
initializeWithElement: anElement
	super initializeWithElement: anElement.
	properties := MDPropertyDictionary new! !

!MDDefinitionVariant methodsFor: 'image proxy' stamp: 'jf 10/4/2009 20:21'!
isLoadableInto: aDomain
	^ element isLoadable: properties into: aDomain! !

!MDDefinitionVariant methodsFor: 'testing' stamp: 'avi 12/2/2004 01:51'!
isRemoval
	^ false! !

!MDDefinitionVariant methodsFor: 'image proxy' stamp: 'jf 10/4/2009 20:21'!
isUpToDateFor: aDomain
	^ (aDomain hasElement: element)
		and: [element is: properties upToDateFor: aDomain]! !

!MDDefinitionVariant methodsFor: 'image proxy' stamp: 'jf 10/4/2009 20:21'!
loadInto: aDomain
	element load: properties into: aDomain! !

!MDDefinitionVariant methodsFor: 'accessing' stamp: 'avi 11/28/2004 16:06'!
properties
	^ properties! !

!MDDefinitionVariant methodsFor: 'image proxy' stamp: 'jf 10/4/2009 20:21'!
updateFrom: aDomain
	(aDomain hasElement: element) ifFalse: [^ MDRemovalVariant forElement: element].
	element update: properties from: aDomain.
	^ self! !

MDVariant subclass: #MDRemovalVariant
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDRemovalVariant commentStamp: 'dc 6/14/2007 06:27' prior: 0!
A variant describes the state of a particular element. That state is "not present in the image," in the case of this class.!

!MDRemovalVariant methodsFor: 'conflicts' stamp: 'jf 10/4/2009 20:21'!
autoMergeWith: aVariant in: aDomain 
	^aVariant autoMergeWithRemoval: self in: aDomain! !

!MDRemovalVariant methodsFor: 'conflicts' stamp: 'jf 10/4/2009 20:21'!
autoMergeWithDefinition: anElementDefinition in: aDomain
	^ anElementDefinition autoMergeWithRemoval: self in: aDomain! !

!MDRemovalVariant methodsFor: 'image proxy' stamp: 'jf 10/4/2009 20:21'!
displayFor: aDomain
	^ '-- removed --'! !

!MDRemovalVariant methodsFor: 'image proxy' stamp: 'jf 10/4/2009 20:21'!
isLoadableInto: aDomain
	"Removals are always loadable."
	
	^ true! !

!MDRemovalVariant methodsFor: 'testing' stamp: 'avi 12/2/2004 01:51'!
isRemoval
	^ true! !

!MDRemovalVariant methodsFor: 'testing' stamp: 'jf 10/4/2009 20:21'!
isUpToDateFor: aDomain
	^ (aDomain hasElement: element) not! !

!MDRemovalVariant methodsFor: 'image proxy' stamp: 'jf 10/4/2009 20:21'!
loadInto: aDomain
	element removeFrom: aDomain! !

!MDRemovalVariant methodsFor: 'image proxy' stamp: 'jf 10/4/2009 20:21'!
updateFrom: aDomain
	^ (MDDefinitionVariant forElement: element) updateFrom: aDomain! !

!MDVariant class methodsFor: 'instance creation' stamp: 'dc 6/14/2007 06:17'!
forElement: anElement
	^ self new
		initializeWithElement: anElement;
		yourself! !

!MDVariant methodsFor: 'comparing' stamp: 'dc 6/14/2007 06:21'!
= other
	^ self species = other species
		and: [self element = other element]! !

!MDVariant methodsFor: 'accessing' stamp: 'cwp 10/16/2005 14:43'!
element
	^ element! !

!MDVariant methodsFor: 'comparing' stamp: 'dc 6/14/2007 06:20'!
hash
	^ element hash! !

!MDVariant methodsFor: 'initialize-release' stamp: 'dc 6/14/2007 06:18'!
initializeWithElement: anImageElement
	element := anImageElement! !

!MDVariant methodsFor: 'converting' stamp: 'dc 6/21/2007 18:32'!
newElementVersion
	"Creates a new version based on the receiver."
	^ MDElementVersion variant: self! !

Object subclass: #MDVersionedObject
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Utilities'!

MDVersionedObject subclass: #MDProject
	instanceVariableNames: 'name slices repositories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Project'!

!MDProject class methodsFor: 'instance creation' stamp: 'cwp 5/31/2008 14:32'!
forDomain: aDomain 
	| inst |
	inst := self named: aDomain name.
	inst workspace 
		domainAt: aDomain name
		put: aDomain.
	^ inst! !

!MDProject class methodsFor: 'instance creation' stamp: 'cwp 9/4/2009 15:57'!
forTesting
	^ self named: 'Test Project'! !

!MDProject class methodsFor: 'instance creation' stamp: 'cwp 5/27/2008 20:49'!
named: aString
	^ self new setName: aString! !

!MDProject methodsFor: 'accessing' stamp: 'jf 10/21/2009 16:50'!
addRepository: aRepository 
	| element |
	repositories register: aRepository.
	element := MDRepositoryAssociationElement 
		projectId: self id
		repositoryId: aRepository id.
	MDAnnouncer announce: (MDElementAdded for: element).
	^ aRepository! !

!MDProject methodsFor: 'accessing' stamp: 'jf 10/21/2009 16:37'!
addSlice: aSlice 
	| element |
	slices register: aSlice.
	element := MDSliceAssociationElement forSlice: aSlice inProject: self.
	MDAnnouncer announce: (MDElementAdded for: element).
	^ aSlice! !

!MDProject methodsFor: 'initialize-release' stamp: 'cwp 9/8/2009 23:07'!
initialize
	self initId.
	slices := MDRegistry new.
	repositories := MDRegistry new.! !

!MDProject methodsFor: 'accessing' stamp: 'cwp 5/31/2008 14:34'!
name
	^ name ! !

!MDProject methodsFor: 'accessing' stamp: 'cwp 7/28/2008 22:26'!
name: aString
	| element |
	name := aString.
	
	element := MDProjectElement for: self.
	MDAnnouncer announce: (MDElementModified for: element)! !

!MDProject methodsFor: 'accessing' stamp: 'jf 9/8/2009 23:58'!
removeRepository: aRepository 
	| repository |
	repository := repositories unregister: aRepository ifAbsent: [^ nil].
	MDAnnouncer announce: (MDElementRemoved for:
		(MDRepositoryAssociationElement
			projectId: self id
			repositoryId: repository id)).
	^ repository! !

!MDProject methodsFor: 'accessing' stamp: 'jf 9/8/2009 23:47'!
removeSlice: aSlice 
	| slice |
	slice := slices unregister: aSlice ifAbsent: [^ nil].
	MDAnnouncer announce: (MDElementRemoved for:
		(MDSliceAssociationElement forSlice: slice inProject: self)).
	^ slice! !

!MDProject methodsFor: 'accessing' stamp: 'cwp 8/18/2009 01:50'!
repositories
	^ repositories objects! !

!MDProject methodsFor: 'initialize-release' stamp: 'cwp 5/31/2008 14:33'!
setName: aString
	name := aString.
	self initId! !

!MDProject methodsFor: 'accessing' stamp: 'cwp 8/18/2009 01:50'!
slices
	^ slices objects! !

MDVersionedObject subclass: #MDRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Repositories'!

!MDRepository commentStamp: 'dc 6/14/2007 06:45' prior: 0!
Repositories are similar to those in MC1, but have a different protocol and different performance characteristics. Conceptually, repositories are dictionaries, mapping hashstamps to versions or snapshots. This makes for a very fine-grained protocol - versions are loaded individually. That makes directory or HTTP repositories impractical, since loading a slice for a medium-size package would involve opening and reading hundreds of files. (A snapshot of OB, for example runs at over 600 versions).!

MDRepository subclass: #MDMemoryRepository
	instanceVariableNames: 'name objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Repositories'!

!MDMemoryRepository class methodsFor: 'as yet unclassified' stamp: 'cwp 7/28/2008 21:10'!
forTesting
	^ self named: 'forTesting'! !

!MDMemoryRepository class methodsFor: 'as yet unclassified' stamp: 'cwp 10/18/2009 21:40'!
id: aHashstamp name: aString
	^ self basicNew initializeWithId: aHashstamp name: aString! !

!MDMemoryRepository class methodsFor: 'as yet unclassified' stamp: 'cwp 10/18/2009 19:47'!
named: aString
	^ self id: MDHashstamp new name: aString! !

!MDMemoryRepository class methodsFor: 'as yet unclassified' stamp: 'cwp 5/31/2008 14:49'!
type
	^ #Memory! !

!MDMemoryRepository methodsFor: 'synchronization' stamp: 'cwp 8/9/2009 13:12'!
allHashstamps
	^ objects keys! !

!MDMemoryRepository methodsFor: 'converting' stamp: 'cwp 10/17/2009 23:22'!
elementClass
	^ MDMemoryRepositoryElement! !

!MDMemoryRepository methodsFor: 'public' stamp: 'cwp 8/9/2009 13:12'!
get: aHashstamp 
	^ objects 
		at: aHashstamp
		ifAbsent: [ nil ]! !

!MDMemoryRepository methodsFor: 'synchronization' stamp: 'cwp 8/9/2009 13:12'!
includes: aHashstamp 
	^ objects includesKey: aHashstamp! !

!MDMemoryRepository methodsFor: 'initialize-release' stamp: 'cwp 10/19/2009 02:21'!
initialize
	objects := Dictionary new.! !

!MDMemoryRepository methodsFor: 'initialize-release' stamp: 'cwp 10/19/2009 02:21'!
initializeWithId: aHashstamp name: aString 
	self initialize.
	id := aHashstamp.
	name := aString! !

!MDMemoryRepository methodsFor: 'public' stamp: 'cwp 8/9/2009 13:12'!
memos
	^ objects values select: [ :ea | ea isMemo ]! !

!MDMemoryRepository methodsFor: 'accessing' stamp: 'cwp 5/31/2008 14:41'!
name
	^ name! !

!MDMemoryRepository methodsFor: 'accessing' stamp: 'cwp 8/9/2009 13:12'!
objects
	^ objects! !

!MDMemoryRepository methodsFor: 'accessing' stamp: 'cwp 5/31/2008 18:00'!
properties: properties
	name := properties name! !

!MDMemoryRepository methodsFor: 'public' stamp: 'cwp 8/9/2009 13:12'!
put: anElementVersion 
	objects 
		at: anElementVersion hashstamp
		put: anElementVersion! !

!MDMemoryRepository methodsFor: 'accessing' stamp: 'cwp 8/9/2009 13:13'!
versions
	^ objects select: [:ea | ea isKindOf: MDElementVersion]! !

!MDRepository class methodsFor: 'instance creation' stamp: 'jf 10/21/2009 15:46'!
classForType: type 
	| class |
	class := self allSubclasses 
		detect: [ :ea | ea type = type ]
		ifNone: [ self error: 'Couldn''t find an appropriate type' ].
	^ class! !

!MDRepository class methodsFor: 'accessing' stamp: 'jf 10/21/2009 15:46'!
type
	^ nil! !

!MDRepository class methodsFor: 'instance creation' stamp: 'jf 10/21/2009 15:47'!
withProperties: properties 
	^ (self classForType: properties type) new
		load: properties;
		initId;
		yourself! !

!MDRepository methodsFor: 'synchronization' stamp: 'cwp 12/22/2007 23:45'!
allHashstamps
	self subclassResponsibility ! !

!MDRepository methodsFor: 'converting' stamp: 'cwp 10/17/2009 23:21'!
asElement
	^ self elementClass for: self ! !

!MDRepository methodsFor: 'public' stamp: 'cwp 12/29/2006 18:02'!
close
! !

!MDRepository methodsFor: 'public' stamp: 'cwp 5/31/2008 14:41'!
description
	^ self name! !

!MDRepository methodsFor: 'converting' stamp: 'cwp 10/17/2009 23:21'!
elementClass
	self subclassResponsibility ! !

!MDRepository methodsFor: 'public' stamp: 'dc 6/14/2007 07:17'!
get: aHashstamp 
	self subclassResponsibility ! !

!MDRepository methodsFor: 'public' stamp: 'cwp 5/22/2008 00:10'!
getAll: aSet
	| result |
	result := Set new.
	aSet do: [:hashstamp | (self get: hashstamp) ifNotNilDo: [:obj | result add: obj]].
	^ result! !

!MDRepository methodsFor: 'synchronization' stamp: 'cwp 12/22/2007 23:48'!
includes: aHashstamp
	self subclassResponsibility! !

!MDRepository methodsFor: 'public' stamp: 'dc 6/14/2007 07:17'!
memos
	self subclassResponsibility ! !

!MDRepository methodsFor: 'accessing' stamp: 'jf 10/21/2009 15:34'!
properties
	^ self update: MDPropertyDictionary new! !

!MDRepository methodsFor: 'synchronization' stamp: 'cwp 5/22/2008 00:10'!
pushTo: aRepository
	| wanted |
	wanted := aRepository selectFrom: self allHashstamps.
	aRepository putAll: (wanted collect: [:ea | self get: ea])! !

!MDRepository methodsFor: 'public' stamp: 'dc 6/14/2007 07:17'!
put: aHashedObject
	self subclassResponsibility ! !

!MDRepository methodsFor: 'public' stamp: 'cwp 12/22/2007 22:26'!
putAll: aSet
	aSet do: [:ea | self put: ea]! !

!MDRepository methodsFor: 'synchronization' stamp: 'cwp 12/22/2007 23:49'!
selectFrom: aSet
	^ aSet reject: [:ea | self includes: ea]! !

!MDRepository methodsFor: 'synchronization' stamp: 'cwp 12/22/2007 23:53'!
synchronizeWith: aRepository
	self pushTo: aRepository.
	aRepository pushTo: self! !

!MDRepository methodsFor: 'accessing' stamp: 'jf 10/21/2009 15:34'!
type
	^ self class type! !

!MDRepository methodsFor: 'accessing' stamp: 'jf 10/21/2009 15:34'!
update: properties
	^ properties
		name: self name;
		yourself! !

MDRepository subclass: #MDStore
	instanceVariableNames: 'repositories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Repositories'!

MDStore class
	instanceVariableNames: 'default'!

!MDStore commentStamp: 'dc 6/14/2007 07:22' prior: 0!
A store is a Composite of repositories.!

MDStore class
	instanceVariableNames: 'default'!

!MDStore class methodsFor: 'private' stamp: 'dc 7/19/2007 12:55'!
createDefault
	^ self new
		addRepository: (MDMemoryRepository new);
		yourself! !

!MDStore class methodsFor: 'accessing' stamp: 'dc 6/14/2007 07:09'!
default
	^ default ifNil: [default := self createDefault]! !

!MDStore class methodsFor: 'instance creation' stamp: 'cwp 11/20/2008 18:54'!
new
	^ self basicNew initialize! !

!MDStore class methodsFor: 'accessing' stamp: 'dc 6/14/2007 07:09'!
resetDefault
	default := nil! !

!MDStore class methodsFor: 'accessing' stamp: 'cwp 5/31/2008 14:52'!
type
	^ #Store! !

!MDStore methodsFor: 'actions' stamp: 'jf 10/21/2009 16:50'!
addRepository: aRepository
	^ repositories add: aRepository! !

!MDStore methodsFor: 'synchronization' stamp: 'cwp 5/22/2008 00:10'!
allHashstamps
	| all |
	all := Set new.
	repositories do: [:ea | all addAll: ea allHashstamps].
	^ all! !

!MDStore methodsFor: 'actions' stamp: 'cwp 12/23/2006 20:59'!
ensureRepository: aRepository
	(repositories includes: aRepository)
		ifFalse: [repositories add: aRepository]! !

!MDStore methodsFor: 'public' stamp: 'cwp 5/23/2006 20:17'!
get: aHashstamp
	repositories do: [:ea | (ea get: aHashstamp) ifNotNilDo: [:object | ^ object]].
	^ nil! !

!MDStore methodsFor: 'synchronization' stamp: 'cwp 12/23/2007 00:14'!
includes: aHashstamp
	^ repositories anySatisfy: [:ea | ea includes: aHashstamp]! !

!MDStore methodsFor: 'initialize-release' stamp: 'cwp 5/24/2008 13:09'!
initialize
	repositories := OrderedCollection new.
	self initId! !

!MDStore methodsFor: 'public' stamp: 'dc 6/14/2007 07:20'!
memos
	| memos |
	memos := Set new.
	repositories do: [:ea | memos addAll: ea memos].
	^ memos asArray! !

!MDStore methodsFor: 'public' stamp: 'cwp 5/31/2008 14:42'!
name
	^ 'store'! !

!MDStore methodsFor: 'accessing' stamp: 'cwp 5/31/2008 22:52'!
properties: aPropertyDictionary
	"Ignore"! !

!MDStore methodsFor: 'public' stamp: 'cwp 3/13/2005 00:26'!
put: anObject
	repositories do: [:ea | ea put: anObject]! !

!MDStore methodsFor: 'actions' stamp: 'cwp 12/29/2006 16:58'!
removeRepository: aRepository
	repositories remove: aRepository! !

!MDStore methodsFor: 'accessing' stamp: 'cwp 9/5/2009 21:54'!
repositories
	^ repositories! !

MDVersionedObject subclass: #MDSlice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Slices'!

!MDSlice commentStamp: 'dc 6/14/2007 07:32' prior: 0!
A slice is sub-set of the elements in the image. It's main responsibility is to define which elements are part of the slice and which are not. Slices can be based on any set of criteria - PackageInfo, ChangeSets, an explicit collection, whatever. Slices can overlap. Elements can belong to more than one slice at the same time.!

MDSlice subclass: #MDChangeSetSlice
	instanceVariableNames: 'changeSet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Slices'!

!MDChangeSetSlice class methodsFor: 'as yet unclassified' stamp: 'cwp 9/12/2009 11:36'!
elementClass
	^ MDChangeSetSliceElement! !

!MDChangeSetSlice class methodsFor: 'as yet unclassified' stamp: 'jf 10/16/2009 17:06'!
id: aHashstamp
	^ self id: aHashstamp changeSet: nil! !

!MDChangeSetSlice class methodsFor: 'as yet unclassified' stamp: 'jf 10/16/2009 17:19'!
id: aHashstamp changeSet: aChangeSet 
	^ self new
		setId: aHashstamp changeSet: aChangeSet;
		yourself! !

!MDChangeSetSlice class methodsFor: 'as yet unclassified' stamp: 'jf 10/16/2009 17:16'!
on: aChangeSet
	^ self new
		setId: MDHashstamp new changeSet: aChangeSet;
		yourself! !

!MDChangeSetSlice methodsFor: 'private' stamp: 'cwp 2/7/2008 21:52'!
addNameOfPool: anObject to: aSet
	aSet add: (Smalltalk keyAtIdentityValue: anObject ifAbsent: [^ self])! !

!MDChangeSetSlice methodsFor: 'enumerating' stamp: 'cwp 5/22/2008 00:10'!
class: name do: aBlock
	| changes |
	changes := changeSet classChangeAt: name.
	changes isEmpty ifFalse: [aBlock value: (MDClassElement className: name)].
	(changes includes: #comment) ifTrue: [self commentFor: name do: aBlock].
	(changes includes: #change) ifTrue: [self instVarsFor: name do: aBlock].
	self classVarsFor: name do: aBlock.
	self poolImportsFor: name do: aBlock.
	self methodsFor: name do: aBlock.
	
	changes := changeSet classChangeAt: name, ' class'.
	(changes includes: #change) ifTrue: [self classInstVarsFor: name do: aBlock].
	self classMethodsFor: name do: aBlock.! !

!MDChangeSetSlice methodsFor: 'enumerating' stamp: 'cwp 2/6/2008 21:07'!
classInstVarsFor: name do: aBlock	
	(self instVarsFor: name, ' class') do:
		[:ivar | aBlock value: (MDClassInstVarElement className: name name: ivar)]! !

!MDChangeSetSlice methodsFor: 'enumerating' stamp: 'cwp 2/6/2008 20:22'!
classMethodsFor: className do: aBlock
	(changeSet methodChangesAtClass: className, ' class') keys do: 
		[:ea | 
		aBlock value: (MDMethodElement 
						className: className 
						selector: ea 
						classIsMeta: true)]! !

!MDChangeSetSlice methodsFor: 'private' stamp: 'cwp 6/14/2008 12:44'!
classVarsFor: className 
	| classVars class |
	class := self currentClass: className.
	classVars := class ifNil: [Set new] ifNotNil: [class classVarNames].
	classVars addAll: (self oldClassVarsFor: className).
	^ classVars! !

!MDChangeSetSlice methodsFor: 'enumerating' stamp: 'cwp 2/6/2008 22:26'!
classVarsFor: name do: aBlock	
	(self classVarsFor: name) do:
		[:cvar | aBlock value: (MDClassVarElement 
								className: name 
								name: cvar)]! !

!MDChangeSetSlice methodsFor: 'enumerating' stamp: 'cwp 2/5/2008 22:34'!
commentFor: className do: aBlock
	aBlock value: (MDClassCommentElement className: className)! !

!MDChangeSetSlice methodsFor: 'private' stamp: 'cwp 2/5/2008 22:31'!
currentClass: className
	^ Smalltalk classNamed: className! !

!MDChangeSetSlice methodsFor: 'enumerating' stamp: 'cwp 2/6/2008 22:41'!
elementsDo: aBlock
	(changeSet changedClassNames reject: [:ea | ea includes: $ ])
		do: [:ea | self class: ea do: aBlock]! !

!MDChangeSetSlice methodsFor: 'testing' stamp: 'cwp 10/17/2009 20:49'!
includes: anElement 
	^ anElement handleWith: (MDSmalltalkInclusionHandler on: self)! !

!MDChangeSetSlice methodsFor: 'dispatching' stamp: 'cwp 2/5/2008 00:28'!
includesClass: anElement
	^ (changeSet classChangeAt: anElement theClassName) isEmpty not! !

!MDChangeSetSlice methodsFor: 'dispatching' stamp: 'cwp 2/5/2008 00:13'!
includesClassComment: anElement
	^ (changeSet classChangeAt: anElement theClassName) includes: #comment! !

!MDChangeSetSlice methodsFor: 'dispatching' stamp: 'cwp 2/6/2008 21:20'!
includesClassInstVar: anElement 
	^ (self instVarsFor: anElement theClassName, ' class') includes: anElement name! !

!MDChangeSetSlice methodsFor: 'dispatching' stamp: 'cwp 2/6/2008 23:00'!
includesClassVar: anElement 
	^ (self classVarsFor: anElement theClassName) includes: anElement name! !

!MDChangeSetSlice methodsFor: 'dispatching' stamp: 'cwp 2/5/2008 22:17'!
includesInstVar: anElement 
	^ (self instVarsFor: anElement theClassName) includes: anElement name! !

!MDChangeSetSlice methodsFor: 'dispatching' stamp: 'cwp 5/22/2008 00:10'!
includesMethod: anElement
	| name |
	name := anElement classIsMeta
				ifTrue: [anElement theClassName, ' class']
				ifFalse: [anElement theClassName].
	^ (changeSet methodChangesAtClass: name)
		keys includes: anElement selector! !

!MDChangeSetSlice methodsFor: 'dispatching' stamp: 'cwp 2/7/2008 22:16'!
includesPoolImport: anElement 
	^ (self poolImportsFor: anElement theClassName) includes: anElement name! !

!MDChangeSetSlice methodsFor: 'private' stamp: 'cwp 6/14/2008 12:50'!
instVarsFor: className 
	| instVars class |
	instVars := Set new.
	(changeSet structures at: className ifAbsent: [#(first)]) allButFirst 
		collect: [:ea | instVars add: ea].
	class := self currentClass: className.
	class ifNotNil: [class instVarNames do: [:ea | instVars add: ea]].
	^ instVars! !

!MDChangeSetSlice methodsFor: 'enumerating' stamp: 'cwp 2/5/2008 22:24'!
instVarsFor: name do: aBlock	
	(self instVarsFor: name) do:
		[:ivar | aBlock value: (MDInstVarElement className: name name: ivar)]! !

!MDChangeSetSlice methodsFor: 'enumerating' stamp: 'cwp 2/5/2008 23:41'!
methodsFor: className do: aBlock
	(changeSet methodChangesAtClass: className) keys do: 
		[:ea | aBlock value: (MDMethodElement className: className selector: ea)]! !

!MDChangeSetSlice methodsFor: 'accessing' stamp: 'cwp 5/28/2008 21:50'!
name
	^ changeSet name! !

!MDChangeSetSlice methodsFor: 'private' stamp: 'cwp 5/22/2008 00:10'!
oldClassVarsFor: className
	| definition tokens |
	definition := (changeSet changeRecorderFor: className) priorDefinition.
	definition ifNil: [^ #()].
	tokens := Scanner new scanTokens: definition.
	^ ((tokens at: 7) findTokens: $ ) collect: [:ea | ea asSymbol]! !

!MDChangeSetSlice methodsFor: 'private' stamp: 'cwp 6/14/2008 12:58'!
poolImportsFor: className 
	| names class |
	names := Set new.
	class := self currentClass: className.
	class ifNotNil: 
		[class sharedPools do: 
			[:each | 
			self 
				addNameOfPool: each
				to: names]].
	^ names! !

!MDChangeSetSlice methodsFor: 'enumerating' stamp: 'cwp 2/7/2008 22:13'!
poolImportsFor: className do: aBlock
	(self poolImportsFor: className) do:
		[:ea | aBlock value: (MDPoolImportElement className: className name: ea)]! !

!MDChangeSetSlice methodsFor: 'initializing' stamp: 'jf 10/16/2009 17:06'!
setId: aHashstamp changeSet: aChangeSet
	self setId: aHashstamp.
	changeSet := aChangeSet! !

MDSlice subclass: #MDExplicitSlice
	instanceVariableNames: 'name elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Slices'!

!MDExplicitSlice class methodsFor: 'instance creation' stamp: 'dc 6/14/2007 07:39'!
basedOn: aSlice
	^ self new 
			setName: aSlice name 
			elements: aSlice elements;
		yourself! !

!MDExplicitSlice class methodsFor: 'as yet unclassified' stamp: 'cwp 9/12/2009 11:36'!
elementClass
	^ MDExplicitSliceElement! !

!MDExplicitSlice class methodsFor: 'instance creation' stamp: 'cwp 12/31/2006 18:32'!
forDefinition: properties
	^ self named: properties name! !

!MDExplicitSlice class methodsFor: 'instance creation' stamp: 'cwp 6/7/2008 13:46'!
forTesting
	^ self named: 'TestSlice'! !

!MDExplicitSlice class methodsFor: 'instance creation' stamp: 'jf 10/16/2009 22:11'!
id: aHashstamp named: aString
	^ self id: aHashstamp named: aString elements: Set new! !

!MDExplicitSlice class methodsFor: 'instance creation' stamp: 'jf 10/16/2009 22:10'!
id: aHashstamp named: aString elements: aCollection
	^ self new
		setId: aHashstamp name: aString elements: aCollection;
		yourself! !

!MDExplicitSlice class methodsFor: 'instance creation' stamp: 'dc 6/14/2007 07:38'!
named: aString
	^ self new
		setName: aString;
		yourself! !

!MDExplicitSlice methodsFor: 'accessing' stamp: 'cwp 2/27/2005 18:54'!
addElement: anElement
	elements add: anElement! !

!MDExplicitSlice methodsFor: 'accessing' stamp: 'jf 10/21/2009 14:52'!
elements
	^ elements! !

!MDExplicitSlice methodsFor: 'enumerating' stamp: 'cwp 1/18/2007 23:59'!
elementsDo: aBlock
	elements do: aBlock.! !

!MDExplicitSlice methodsFor: 'testing' stamp: 'cwp 8/28/2005 23:34'!
includes: anElement
	^ elements includes: anElement! !

!MDExplicitSlice methodsFor: 'accessing' stamp: 'cwp 3/15/2005 22:26'!
name
	^ name! !

!MDExplicitSlice methodsFor: 'initialize-release' stamp: 'jf 10/16/2009 22:10'!
setId: aHashstamp name: aString elements: aCollection
	self setId: aHashstamp.
	name := aString.
	elements := aCollection asSet! !

!MDExplicitSlice methodsFor: 'initialize-release' stamp: 'cwp 12/29/2006 17:53'!
setName: aString
	^ self setName: aString elements: Set new! !

!MDExplicitSlice methodsFor: 'initialize-release' stamp: 'dc 6/14/2007 07:48'!
setName: aString elements: aSet
	name := aString.
	elements := aSet.
	self initId.! !

!MDSlice class methodsFor: 'converting' stamp: 'cwp 9/12/2009 11:33'!
elementClass
	self subclassResponsibility! !

!MDSlice methodsFor: 'converting' stamp: 'cwp 9/12/2009 11:33'!
asElement
	^ self class elementClass id: self id! !

!MDSlice methodsFor: 'converting' stamp: 'cwp 3/14/2005 22:28'!
asExplicitSlice
	^ MDExplicitSlice basedOn: self! !

!MDSlice methodsFor: 'private' stamp: 'jf 9/8/2009 16:29'!
basicLoad: aSnapshot from: aRepository to: aWorkspace
	| versions expanded |
	versions := aSnapshot getVersionsFrom: aRepository for: aWorkspace.
	expanded := self expandVersions: versions.
	aWorkspace transaction: 
		[expanded do: [:ea | aWorkspace loadVersion: ea]]! !

!MDSlice methodsFor: 'private' stamp: 'jf 9/8/2009 16:29'!
basicSaveFrom: aWorkspace to: aRepository memo: aMemo
	| objects snapshot |
	objects := Set new.	
	self do: [:ea | objects add: (aWorkspace versionForElement: ea)].
	snapshot := MDSnapshot withVersions: objects.
	objects add: snapshot.
	aMemo ifNotNil: 
		[aMemo setSnapshot: snapshot slice: self.
		objects add: aMemo].
	aRepository putAll: objects.
	^ snapshot! !

!MDSlice methodsFor: 'enumerating' stamp: 'cwp 5/7/2008 07:42'!
do: aBlock
	self elementsDo: aBlock! !

!MDSlice methodsFor: 'accessing' stamp: 'dc 6/14/2007 07:41'!
elements
	| result |
	result := Set new.
	self do: [:ea | result add: ea].
	^ result! !

!MDSlice methodsFor: 'enumerating' stamp: 'jf 10/4/2009 21:07'!
elementsDo: aBlock
	"Evaluate aBlock once for every element that is currently present and
	included in the receiving Slice."! !

!MDSlice methodsFor: 'private' stamp: 'dc 6/14/2007 07:44'!
expandVersions: versions
	| existingElements result |
	existingElements := versions collect: [:ea | ea element]. 
	result := versions copy.
	self do: [:el | (existingElements includes: el) 
					ifFalse: [result add: (MDNullVersion forElement: el)]].
	^ result! !

!MDSlice methodsFor: 'public' stamp: 'jf 9/8/2009 16:29'!
include: aSnapshot from: aRepository in: aWorkspace
	| versions |
	MDPlatform current 
		withCursor: #read 
		do: [versions := aSnapshot getVersionsFrom: aRepository for: aWorkspace].
	MDMergeRequest
		includeAll: (self expandVersions: versions)
		in: aWorkspace! !

!MDSlice methodsFor: 'testing' stamp: 'cwp 10/16/2009 21:32'!
includes: anElement
	self subclassResponsibility! !

!MDSlice methodsFor: 'public' stamp: 'jf 9/8/2009 16:29'!
load: aSnapshot from: aRepository to: aWorkspace
	
	MDPlatform current 
		withCursor: #read 
		do: [self basicLoad: aSnapshot from: aRepository to: aWorkspace]! !

!MDSlice methodsFor: 'public' stamp: 'jf 9/8/2009 16:29'!
saveFrom: aWorkspace to: aRepository memo: aMemo
	^ MDPlatform current 
		withCursor: #write 
		do: [self basicSaveFrom: aWorkspace to: aRepository memo: aMemo].
	! !

!MDSlice methodsFor: 'private' stamp: 'cwp 11/16/2007 00:55'!
withCursor: aSymbol do: aBlock
	MDPlatform current showCursor: aSymbol.
	aBlock ensure: [MDPlatform current showCursor: nil]! !

MDSlice subclass: #MDUnionSlice
	instanceVariableNames: 'name slices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Slices'!

!MDUnionSlice class methodsFor: 'as yet unclassified' stamp: 'cwp 9/12/2009 12:31'!
elementClass
	^ MDUnionSliceElement! !

!MDUnionSlice class methodsFor: 'as yet unclassified' stamp: 'jf 10/16/2009 22:02'!
id: aHashstamp named: aString slices: aCollection
	^ self new
		setId: aHashstamp name: aString slices: aCollection;
		yourself! !

!MDUnionSlice class methodsFor: 'as yet unclassified' stamp: 'cwp 5/29/2008 08:00'!
name: aString
	^ self name: aString slices: Set new! !

!MDUnionSlice class methodsFor: 'as yet unclassified' stamp: 'cwp 5/29/2008 07:59'!
name: aString slices: aCollection
	^ self new setName: aString slices: aCollection! !

!MDUnionSlice methodsFor: 'accessing' stamp: 'jf 10/21/2009 16:38'!
addSlice: aSlice
	^ slices add: aSlice! !

!MDUnionSlice methodsFor: 'enumerating' stamp: 'cwp 5/22/2008 00:10'!
elementsDo: aBlock
	| done |
	done := Set new.
	slices do:
		[:slice |
		slice elementsDo:
			[:element |
			(done includes: element) ifFalse:
				[aBlock value: element.
				done add: element]]]! !

!MDUnionSlice methodsFor: 'testing' stamp: 'cwp 2/3/2008 20:47'!
includes: anElement
	^ slices anySatisfy: [:ea | ea includes: anElement]! !

!MDUnionSlice methodsFor: 'accessing' stamp: 'cwp 6/14/2008 17:47'!
includesSlice: aSlice
	^ slices includes: aSlice! !

!MDUnionSlice methodsFor: 'accessing' stamp: 'cwp 5/29/2008 08:00'!
name
	^ name! !

!MDUnionSlice methodsFor: 'accessing' stamp: 'jf 10/16/2009 21:59'!
removeSlice: aSlice
	slices remove: aSlice! !

!MDUnionSlice methodsFor: 'initialize-release' stamp: 'jf 10/16/2009 21:59'!
setId: aHashstamp name: aString slices: aCollection
	self setId: aHashstamp.
	name := aString.
	slices := aCollection asSet! !

!MDUnionSlice methodsFor: 'initialize-release' stamp: 'jf 10/16/2009 21:59'!
setName: aString slices: aCollection
	name := aString.
	slices := aCollection asSet.
	self initId! !

!MDUnionSlice methodsFor: 'accessing' stamp: 'jf 10/21/2009 15:08'!
slices
	^ slices! !

!MDVersionedObject class methodsFor: 'instance creation' stamp: 'cwp 5/31/2008 14:28'!
id: aHashstamp
	^ self new setId: aHashstamp! !

!MDVersionedObject class methodsFor: 'instance creation' stamp: 'cwp 11/20/2008 18:51'!
new
	^ self basicNew initialize! !

!MDVersionedObject methodsFor: 'comparing' stamp: 'cwp 5/31/2008 14:17'!
= other 
	^ id = other id! !

!MDVersionedObject methodsFor: 'comparing' stamp: 'cwp 5/31/2008 14:14'!
hash
	^ id hash! !

!MDVersionedObject methodsFor: 'accessing' stamp: 'cwp 5/31/2008 14:13'!
id
	^ id! !

!MDVersionedObject methodsFor: 'private' stamp: 'cwp 8/8/2009 17:31'!
initId
	
	id := MDHashstamp new! !

!MDVersionedObject methodsFor: 'accessing' stamp: 'cwp 5/31/2008 14:26'!
name
	^ self subclassResponsibility! !

!MDVersionedObject methodsFor: 'private' stamp: 'cwp 5/31/2008 14:14'!
setId: aHashstamp
	id := aHashstamp! !

!MDVersionedObject methodsFor: 'accessing' stamp: 'cwp 5/31/2008 18:25'!
timestamp
	^ nil! !

Object subclass: #MDWorkspace
	instanceVariableNames: 'domains versions slush transaction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDWorkspace commentStamp: 'dc 6/14/2007 08:30' prior: 0!
I'm not terribly happy with this name, but I can't think of a better one. It keeps track of the state of the image with respect to versioning. It knows, for example, which versions image is based on, and can perform tasks like creating new versions based on the state of the image, or loading existing versions into the image.!

!MDWorkspace class methodsFor: 'instance creation' stamp: 'cwp 5/27/2008 06:58'!
forDomain: aDomain 
	^ self new
		domainAt: aDomain name
			put: aDomain;
		yourself! !

!MDWorkspace class methodsFor: 'instance creation' stamp: 'cwp 5/26/2008 22:01'!
forTesting
	^ self new 
		domainAt: #fake put: MDFakeDomain new;
		yourself! !

!MDWorkspace class methodsFor: 'instance creation' stamp: 'cwp 11/20/2008 18:54'!
new
	^ self basicNew initialize! !

!MDWorkspace methodsFor: 'public' stamp: 'cwp 5/26/2008 20:14'!
changeForElement: anElement do: aBlock
	| version variant domain |
	domain := self domainForElement: anElement.
	version := versions 
		at: anElement 
		ifAbsent: [MDNullVersion forElement: anElement].
	^ (domain isUpToDate: version variant) ifFalse:
		[variant := domain updateVariant: version variant copy.
		aBlock value: (MDChange version: version variant: variant)]! !

!MDWorkspace methodsFor: 'public' stamp: 'cwp 8/3/2008 20:58'!
changeFromVersion: aVersion do: aBlock 
	| variant domain |
	domain := self domainForElement: aVersion element.
	(domain isUpToDate: aVersion variant) ifFalse:
		[variant := domain updateVariant: aVersion variant copy.
		aBlock value: (MDChange version: aVersion variant: variant) ]! !

!MDWorkspace methodsFor: 'private' stamp: 'cwp 5/26/2008 20:10'!
createVersionForElement: anElement 
	| variant version domain |
	domain := self domainForElement: anElement.
	(domain hasElement: anElement) 
		ifFalse: [^MDNullVersion forElement: anElement].
	variant := (MDDefinitionVariant forElement: anElement) updateFrom: domain.
	version := MDElementVersion variant: variant.
	versions at: anElement put: version.
	^version! !

!MDWorkspace methodsFor: 'private' stamp: 'cwp 5/26/2008 21:40'!
domainAt: index in: aCollection transaction: aBlock
	^ (aCollection size < index) 
		ifTrue: aBlock
		ifFalse: 
			[(aCollection at: index) transaction: 
				[self domainAt: index + 1 in: aCollection transaction: aBlock]]! !

!MDWorkspace methodsFor: 'public' stamp: 'jf 10/21/2009 16:39'!
domainAt: aSymbol put: aDomain
	^ domains at: aSymbol put: aDomain! !

!MDWorkspace methodsFor: 'private' stamp: 'cwp 6/17/2008 00:10'!
domainForElement: anElement
	^ domains 
		at: anElement domain
		ifAbsentPut: [MDDomain defaultForType: anElement domain]! !

!MDWorkspace methodsFor: 'private' stamp: 'cwp 10/17/2005 08:31'!
ensureTransactionDuring: aBlock
	^ transaction
		ifNil: [self transaction: aBlock]
		ifNotNil: [aBlock value]! !

!MDWorkspace methodsFor: 'public' stamp: 'cwp 5/26/2008 23:26'!
hasDomainNamed: aSymbol
	^ domains includesKey: aSymbol! !

!MDWorkspace methodsFor: 'public' stamp: 'cwp 5/26/2008 20:07'!
includeVersion: anElementVersion onConflict: twoArgBlock 
	| current successor element domain |
	element := anElementVersion element.
	current := self versionForElement: element.
	domain := self domainForElement: element.
	successor := current 
		successor: anElementVersion
		onConflict: 
			[ current 
				resolveConflictWith: anElementVersion
				in: domain
				using: twoArgBlock ].
	successor == current ifTrue: [ ^ false ].
	self loadVersion: successor.
	^ true! !

!MDWorkspace methodsFor: 'initialize-release' stamp: 'cwp 5/26/2008 19:53'!
initialize
	domains := Dictionary new.
	versions := Dictionary new.
	slush := Set new.! !

!MDWorkspace methodsFor: 'private' stamp: 'dc 7/4/2007 16:38'!
loadSlush
	"Tries to load all versions in slush. Keeps trying until nothing is loadable anymore."
	[| oldSize 
	 |oldSize := slush size.
	 slush := self loadSlush: slush.
	 slush size ~= oldSize] whileTrue.
	! !

!MDWorkspace methodsFor: 'private' stamp: 'cwp 5/26/2008 21:44'!
loadSlush: elementVersions 
	"Tries to load all element versions in the parameter. Collect all versions that can't be loaded and return them."
	| unloadable domain |
	unloadable := Set new.
	elementVersions do: 
		[:ea | 
		domain := self domainForElement: ea element.
		(domain isLoadable: ea variant) 
			ifTrue: [domain loadVariant: ea variant]
			ifFalse: [unloadable add: ea]].
	^ unloadable! !

!MDWorkspace methodsFor: 'public' stamp: 'cwp 2/4/2006 20:45'!
loadVersion: anElementVersion

	self ensureTransactionDuring: 
		[versions at: anElementVersion element put: anElementVersion.
		transaction add: anElementVersion]
! !

!MDWorkspace methodsFor: 'private' stamp: 'cwp 5/26/2008 20:04'!
newVersionForElement: anImageElement 
	| oldVersion newVariant domain |
	oldVersion := versions at: anImageElement.
	newVariant := oldVersion variant copy.
	domain := self domainForElement: anImageElement.
	^ versions 
		at: anImageElement
		put: (MDElementVersion 
				variant: (domain updateVariant: newVariant)
				ancestry: oldVersion fullAncestry)! !

!MDWorkspace methodsFor: 'public' stamp: 'cwp 5/26/2008 21:40'!
transaction: aBlock
	| result |
	transaction := OrderedCollection new.
	result := aBlock value.
	slush := transaction, slush asOrderedCollection.
	transaction := nil.
	self domainAt: 1 in: domains asArray transaction: [self loadSlush].
	^ result! !

!MDWorkspace methodsFor: 'public' stamp: 'cwp 5/26/2008 20:02'!
versionForElement: anElement
	| old |
	old := versions 
			at: anElement 
			ifAbsent: [^ self createVersionForElement: anElement].
	^ ((self domainForElement: anElement) isUpToDate: old variant)
		ifTrue: [old]
		ifFalse: [self newVersionForElement: anElement]! !

!MDWorkspace methodsFor: 'public' stamp: 'cwp 12/22/2007 22:10'!
versionForHashstamp: aHashstamp ifPresent: pBlock ifAbsent: aBlock
	versions do: [:ea | ea hashstamp = aHashstamp ifTrue: [^ pBlock value: ea]].
	^ aBlock value! !

!Object methodsFor: '*monticello2' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	aSerializer serializeObject: self! !

!ByteString methodsFor: '*monticello2' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	aSerializer serializeUtf8String: self! !

!UndefinedObject methodsFor: '*monticello2-serialization' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	^ aSerializer serializeSingleton: self! !

!Dictionary methodsFor: '*monticello2' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	^ aSerializer serializeDictionary: self! !

Dictionary subclass: #MDPropertyDictionary
	instanceVariableNames: 'localReference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDPropertyDictionary commentStamp: 'cwp 5/9/2006 23:27' prior: 0!
I store the state of particular variant of an element. !

!MDPropertyDictionary methodsFor: 'accessing' stamp: 'cwp 4/3/2005 20:33'!
at: key
	^ self at: key ifAbsent: [nil]! !

!MDPropertyDictionary methodsFor: 'accessing' stamp: 'cwp 4/3/2005 20:31'!
at: key put: anObject
	anObject ifNotNil: [super at: key put: anObject]! !

!MDPropertyDictionary methodsFor: 'convenience' stamp: 'cwp 4/3/2005 20:36'!
doesNotUnderstand: aMessage
	aMessage selector isUnary ifTrue: [^ self at: aMessage selector].
	(aMessage selector isKeyword
		and: [aMessage arguments size = 1])
			ifTrue: [^ self
						at: aMessage selector allButLast asSymbol
						put: aMessage arguments first].
	super doesNotUnderstand: aMessage.! !

!MDPropertyDictionary methodsFor: 'accessing' stamp: 'avi 3/14/2005 18:08'!
localReference
	^ localReference! !

!MDPropertyDictionary methodsFor: 'accessing' stamp: 'dc 6/14/2007 06:12'!
localReference: anObject
	localReference := anObject! !

!MDPropertyDictionary methodsFor: 'serialization' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	aSerializer serializeProperties: self! !

!MDPropertyDictionary methodsFor: 'convenience' stamp: 'cwp 12/31/2006 01:09'!
name
	^ self at: #name! !

!Integer methodsFor: '*monticello2' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	aSerializer serializeInteger: self! !

Notification subclass: #MDCommentRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Project'!

!MDCommentRequest methodsFor: 'defaults' stamp: 'cwp 12/27/2007 21:36'!
defaultAction
	^ self resume: nil! !

Notification subclass: #MDMergeRequest
	instanceVariableNames: 'merges workspace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Utilities'!

!MDMergeRequest class methodsFor: 'signalling' stamp: 'jf 9/8/2009 16:32'!
includeAll: versions in: aWorkspace
	| merges |
	merges := versions
				collect: [:ea | MDMerge toInclude: ea in: aWorkspace]
				thenSelect: [:ea | ea isNoOp not].
	^ self new
		merges: merges;
		workspace: aWorkspace;
		signal! !

!MDMergeRequest methodsFor: 'accessing' stamp: 'cwp 3/25/2005 21:23'!
merges
	^ merges! !

!MDMergeRequest methodsFor: 'accessing' stamp: 'dc 6/14/2007 10:17'!
merges: aCollection
	merges := aCollection! !

!MDMergeRequest methodsFor: 'accessing' stamp: 'jf 9/8/2009 16:31'!
workspace
	^ workspace! !

!MDMergeRequest methodsFor: 'accessing' stamp: 'jf 9/8/2009 16:31'!
workspace: aWorkspace 
	workspace := aWorkspace! !

!Set methodsFor: '*monticello2-serialization' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	aSerializer serializeSet: self! !

Magnitude variableByteSubclass: #MDHashstamp
	instanceVariableNames: ''
	classVariableNames: 'MDArbitrary MDCharMap'
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDHashstamp commentStamp: 'dc 6/14/2007 08:17' prior: 0!
A Hashstamp is combination of SHA1 hash and timestamp which uniquely identifies the version.!

!MDHashstamp class methodsFor: 'serializing' stamp: 'cwp 10/2/2008 20:19'!
decodeString: aString 
	| write read a b c d |
	write := (ByteArray new: self hashstampSize) writeStream.
	read := aString readStream.
	[ read atEnd ] whileFalse: 
		[ a := (MDCharMap indexOf: read next) - 1.
		b := (MDCharMap indexOf: read next) - 1.
		write nextPut: (a bitShift: 2) + (b bitShift: -4).
		b := b bitAnd: 15.
		c := (MDCharMap indexOf: read next) - 1.
		write nextPut: (b bitShift: 4) + (c bitShift: -2).
		c := c bitAnd: 3.
		d := (MDCharMap indexOf: read next) - 1.
		write nextPut: (c bitShift: 6) + d ].
	^ write contents! !

!MDHashstamp class methodsFor: 'instance creation' stamp: 'cwp 5/22/2008 00:10'!
fromBytes: aByteArray
	| hashstamp |
	aByteArray size = self hashstampSize ifFalse: [self error: 'Incorrect byte size'].
	hashstamp := self new.
	1 to: 24 do: [:i | hashstamp byteAt: i put: (aByteArray at: i)].
	^ hashstamp! !

!MDHashstamp class methodsFor: 'instance creation' stamp: 'avi 3/14/2005 12:46'!
fromString: aString
	^ self fromBytes: (self decodeString: aString)! !

!MDHashstamp class methodsFor: 'accessing defaults' stamp: 'dc 6/27/2007 13:48'!
hashstampSize
	^ 24! !

!MDHashstamp class methodsFor: 'initialize-release' stamp: 'cwp 8/8/2009 14:48'!
initialize
	MDCharMap := '+-0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'.
	MDArbitrary := Random seed: (Time millisecondClockValue bitAnd: 16r3FFFFFFF)! !

!MDHashstamp class methodsFor: 'instance creation' stamp: 'cwp 8/8/2009 15:08'!
new
	^ (self new: self hashstampSize) initialize! !

!MDHashstamp class methodsFor: 'instance creation' stamp: 'cwp 8/8/2009 16:03'!
tag: aByteArray timestamp: aTimestamp
	^ (self basicNew: self hashstampSize)
		setTag: aByteArray timestamp: aTimestamp! !

!MDHashstamp class methodsFor: 'instance creation' stamp: 'cwp 8/8/2009 16:01'!
timestamp: aTimestamp
	^ (self basicNew: self hashstampSize)
		setTimestamp: aTimestamp! !

!MDHashstamp methodsFor: 'comparing' stamp: 'cwp 5/22/2008 00:10'!
< other
	| selfByte otherByte |
	1 to: self byteSize do: 
		[:i | 
			selfByte := self byteAt: i.
			otherByte := other byteAt: i.
			(selfByte == otherByte) ifFalse: [^ selfByte < otherByte]].
	^ false! !

!MDHashstamp methodsFor: 'comparing' stamp: 'cwp 9/11/2005 17:56'!
= other
	self class = other class ifFalse: [^ false].
	1 to: self size do: [:i | (self at: i) = (other at: i) ifFalse: [^ false]].
	^ true! !

!MDHashstamp methodsFor: 'serializing' stamp: 'cwp 6/23/2008 13:19'!
asByteArray
	^ self bytes! !

!MDHashstamp methodsFor: 'bytes' stamp: 'cwp 4/18/2005 13:17'!
byteAt: index
	^ self basicAt: index! !

!MDHashstamp methodsFor: 'bytes' stamp: 'cwp 4/18/2005 13:41'!
byteAt: index put: value
	self basicAt: index put: value! !

!MDHashstamp methodsFor: 'bytes' stamp: 'cwp 4/18/2005 13:46'!
byteSize
	^ self basicSize! !

!MDHashstamp methodsFor: 'serializing' stamp: 'cwp 5/22/2008 00:10'!
bytes
	| bytes |
	bytes := ByteArray new: self size.
	bytes replaceFrom: 1 to: self size with: self startingAt: 1.
	^ bytes! !

!MDHashstamp methodsFor: 'accessing' stamp: 'cwp 8/8/2009 15:12'!
checkByte
	^ self at: 24! !

!MDHashstamp methodsFor: 'comparing' stamp: 'cwp 4/18/2005 13:35'!
hash
	^ByteArray
		hashBytes: self
		startingWith: self species hash! !

!MDHashstamp methodsFor: 'accessing' stamp: 'cwp 9/6/2009 11:21'!
id
	^ self! !

!MDHashstamp methodsFor: 'initialize-release' stamp: 'cwp 8/8/2009 16:26'!
initCheckByte
	| hash |
	hash := MDPearsonsHash new.
	hash next: 23 putAll: self startingAt: 1.
	self byteAt: 24 put: hash value! !

!MDHashstamp methodsFor: 'initialize-release' stamp: 'cwp 8/8/2009 15:05'!
initTag
	5 
		to: 23
		do: 
			[ :i | 
			self 
				byteAt: i
				put: (MDArbitrary nextInt: 256) - 1 ]! !

!MDHashstamp methodsFor: 'initialize-release' stamp: 'cwp 8/8/2009 15:07'!
initTimestamp
	self replaceFrom: 1 to: 4 with: MDTimestamp now.! !

!MDHashstamp methodsFor: 'initialize-release' stamp: 'cwp 8/8/2009 15:09'!
initialize
	self 
		initTimestamp;
		initTag;
		initCheckByte! !

!MDHashstamp methodsFor: 'testing' stamp: 'cwp 8/8/2009 16:24'!
isValid
	| hash |
	hash := MDPearsonsHash new.
	hash next: 23 putAll: self startingAt: 1.
	^ hash value = self checkByte! !

!MDHashstamp methodsFor: 'serializing' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	aSerializer serializeHashstamp: self! !

!MDHashstamp methodsFor: 'printing' stamp: 'cwp 10/2/2008 20:19'!
printFirst: first second: second third: third on: aStream 
	| a b c d |
	a := first bitShift: -2.
	b := ((first bitShift: 4) bitOr: (second bitShift: -4)) bitAnd: 63.
	c := ((second bitShift: 2) bitOr: (third bitShift: -6)) bitAnd: 63.
	d := third bitAnd: 63.
	aStream
		nextPut: (MDCharMap at: a + 1);
		nextPut: (MDCharMap at: b + 1);
		nextPut: (MDCharMap at: c + 1);
		nextPut: (MDCharMap at: d + 1)! !

!MDHashstamp methodsFor: 'printing' stamp: 'cwp 5/22/2008 00:10'!
printOn: aStream
	| bytes |
	bytes := self bytes.
	1 to: 24 by: 3 do: [:i | self 
							printFirst: (bytes at: i) 
							second: (bytes at: i+1)
							third: (bytes at: i+2)
							on: aStream].! !

!MDHashstamp methodsFor: 'private' stamp: 'cwp 5/22/2008 00:10'!
replaceFrom: start to: end with: bytes
	| offset |
	offset := start - 1.
	1 to: (end - offset) do: [:i | self basicAt: offset + i put: (bytes basicAt: i)]! !

!MDHashstamp methodsFor: 'initialize-release' stamp: 'cwp 8/8/2009 15:06'!
setTag: aByteArray timestamp: aTimestamp 
	self 
		replaceFrom: 1
		to: 4
		with: aTimestamp.
	self 
		replaceFrom: 5
		to: 23
		with: aByteArray.
	self initCheckByte! !

!MDHashstamp methodsFor: 'initialize-release' stamp: 'cwp 8/8/2009 15:05'!
setTimestamp: aTimestamp 
	self replaceFrom: 1 to: 4 with: aTimestamp.
	self initTag.
	self initCheckByte! !

!MDHashstamp methodsFor: 'accessing' stamp: 'cwp 8/8/2009 15:11'!
tag
	| bytes |
	bytes := ByteArray new: 19.
	bytes replaceFrom: 1 to: 19 with: self startingAt: 5.
	^ bytes! !

!MDHashstamp methodsFor: 'accessing' stamp: 'cwp 4/18/2005 13:15'!
timestamp
	^ MDTimestamp fromHashstamp: self! !

Magnitude variableByteSubclass: #MDTimestamp
	instanceVariableNames: ''
	classVariableNames: 'MDDay MDHour MDLeapCycle MDMinute MDMonths MDSecond MDYear'
	poolDictionaries: ''
	category: 'Monticello2-Utilities'!

MDTimestamp class
	instanceVariableNames: 'parts'!

MDTimestamp class
	instanceVariableNames: 'parts'!

!MDTimestamp class methodsFor: 'private' stamp: 'cwp 5/22/2008 00:10'!
compose: units
	| int accumulate |
	parts := units readStream.
	accumulate := [:ea | int := parts next * ea + int].
	int := 0.
	self highConstants do: accumulate.
	(MDMonths first: parts next) do: [:ea | int := ea + int].
	self lowConstants do: accumulate.
	^ int! !

!MDTimestamp class methodsFor: 'accessing' stamp: 'cwp 4/9/2005 05:04'!
epoch
	^ self new! !

!MDTimestamp class methodsFor: 'accessing' stamp: 'cwp 4/9/2005 01:29'!
epochYear
	^ 1980! !

!MDTimestamp class methodsFor: 'instance creation' stamp: 'cwp 5/22/2008 00:10'!
fromHashstamp: hashstamp
	| inst |
	inst := self new.
	1 to: 4 do: [:i | inst byteAt: i put: (hashstamp byteAt: i)].
	^ inst! !

!MDTimestamp class methodsFor: 'instance creation' stamp: 'cwp 5/22/2008 00:10'!
fromInteger: int	
	| ts |
	int > self range ifTrue: [self error: 'Timestamp out of range'].
	ts := self new: 4.
	ts byteAt: 1 put: (int bitShift: -24).
	ts byteAt: 2 put: ((int bitShift: -16) bitAnd: 16rFF).
	ts byteAt: 3 put: ((int bitShift: -8) bitAnd: 16rFF).
	ts byteAt: 4 put: (int bitAnd: 16rFF).
	^ ts! !

!MDTimestamp class methodsFor: 'private' stamp: 'cwp 4/16/2005 16:16'!
highConstants
	^ Array
		with: MDLeapCycle
		with: MDYear! !

!MDTimestamp class methodsFor: 'initializing' stamp: 'cwp 5/22/2008 00:10'!
initialize
	MDSecond := 1.
	MDMinute := 60 * MDSecond.
	MDHour := 60 * MDMinute.
	MDDay := 24 * MDHour.
	MDYear := MDDay * 365.
	MDLeapCycle := MDYear * 4 + MDDay.
	self initializeMonths.
	! !

!MDTimestamp class methodsFor: 'initializing' stamp: 'cwp 5/22/2008 00:10'!
initializeMonths
	MDMonths := #(31 30 31 30 31 31 30 31 30 31 31) collect: [:ea | ea * MDDay].
! !

!MDTimestamp class methodsFor: 'accessing' stamp: 'cwp 4/9/2005 01:40'!
last
	^ self fromInteger: self range! !

!MDTimestamp class methodsFor: 'private' stamp: 'cwp 4/16/2005 16:17'!
lowConstants
	^ Array
		with: MDDay
		with: MDHour
		with: MDMinute
		with: MDSecond! !

!MDTimestamp class methodsFor: 'instance creation' stamp: 'cwp 4/9/2005 05:04'!
new
	^ self new: 4! !

!MDTimestamp class methodsFor: 'instance creation' stamp: 'cwp 5/10/2008 18:40'!
now
	| platform |
	platform := MDPlatform current.
	^ self fromInteger: platform timestampSeconds! !

!MDTimestamp class methodsFor: 'accessing' stamp: 'cwp 4/9/2005 01:43'!
range
	^ 3786825599! !

!MDTimestamp class methodsFor: 'instance creation' stamp: 'cwp 5/22/2008 00:10'!
year: aYear month: aMonth day: day hour: hour minute: minute second: second
	| year month units |
	aMonth < 3 
		ifTrue: [year := aYear - self epochYear - 1. month := aMonth + 10]
		ifFalse: [year := aYear - self epochYear. month := aMonth - 2].
	units := Array new: 7.
	units at: 1 put: year // 4.
	units at: 2 put: year \\ 4.
	units at: 3 put: month - 1.
	units at: 4 put: day - 1.
	units at: 5 put: hour.
	units at: 6 put: minute.
	units at: 7 put: second.
	^ self fromInteger: (self compose: units)! !

!MDTimestamp methodsFor: 'comparing' stamp: 'cwp 9/11/2005 17:25'!
< other
	^ self asInteger < other asInteger! !

!MDTimestamp methodsFor: 'comparing' stamp: 'cwp 9/11/2005 17:25'!
= other
	self class == other class ifFalse: [^ false].
	self byteSize = other byteSize ifFalse: [^ false].
	^ self asInteger = other asInteger! !

!MDTimestamp methodsFor: 'converting' stamp: 'cwp 9/10/2005 23:30'!
asInteger
	| integer |
	integer := 0.
	1 to: self size do: [:i | integer := (integer bitShift: 8) + (self byteAt: i)].
	^ integer! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 4/5/2005 21:19'!
byteAt: index
	^ self basicAt: index! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 4/5/2005 21:20'!
byteAt: index put: byte
	^ self basicAt: index put: byte! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 4/9/2005 04:59'!
byteSize
	^ self basicSize! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 6/18/2005 16:04'!
day
	^ (self decompose at: 4) + 1! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 5/22/2008 00:10'!
decompose
	| results int reduce |
	results := (Array new: 7) writeStream.
	int := self asInteger.
	reduce := [:unit | results nextPut: int // unit. int := int \\ unit].
	reduce value: MDLeapCycle.
	int := self reduceYearsIn: int on: results.
	int := self reduceMonthsIn: int on: results.
	self lowConstants do: reduce.
	^ results contents! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 4/9/2005 01:14'!
epochYear
	^ self class epochYear! !

!MDTimestamp methodsFor: 'comparing' stamp: 'cwp 9/11/2005 18:28'!
hash
	^ self asInteger hash! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 4/16/2005 16:17'!
highConstants
	^ self class highConstants! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 6/18/2005 16:04'!
hour
	^ self decompose at: 5! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 4/16/2005 16:18'!
lowConstants
	^ self class lowConstants! !

!MDTimestamp methodsFor: 'printing' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	aSerializer serializeTimestamp: self! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 6/18/2005 16:04'!
minute
	^ self decompose at: 6! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 4/9/2005 04:27'!
month
	^ self monthFrom: self decompose! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 6/18/2005 16:04'!
monthFrom: anArray
	^ (anArray at: 3) + 2 \\ 12 + 1! !

!MDTimestamp methodsFor: 'printing' stamp: 'cwp 4/9/2005 02:55'!
printFormat: aString
	^ self printer printFormat: aString! !

!MDTimestamp methodsFor: 'printing' stamp: 'cwp 4/9/2005 04:23'!
printOn: aStream
	self printer printOn: aStream format: '%e %B %Y %i:%M:%S %p' ! !

!MDTimestamp methodsFor: 'printing' stamp: 'cwp 6/18/2005 16:04'!
printer
	| units |
	units := self decompose.
	^ MDTimestampPrinter
		year: (self yearFrom: units)
		month: (self monthFrom: units)
		day: (units at: 4) + 1
		hours: (units at: 5)
		minutes: (units at: 6)
		seconds: (units at: 7)! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 6/18/2005 16:04'!
reduceMonthsIn: anInteger on: aStream
	| months int |
	months := 0.
	int := anInteger.
	MDMonths do: [:ea | 
				int < ea
					ifTrue: [aStream nextPut: months. ^ int]
					ifFalse: [int := int - ea].
				months := months + 1].
	aStream nextPut: months.
	^ int! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 8/21/2005 02:37'!
reduceYearsIn: anInteger on: aStream
	| years |
	years := anInteger // MDYear min: 3.
	aStream nextPut: years.
	^ anInteger - (MDYear * years)! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 4/23/2008 07:29'!
second
	^ self decompose at: 7! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 8/9/2005 21:21'!
timestamp
	^ self! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 4/9/2005 04:29'!
year
	^ self yearFrom: self decompose! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 8/20/2005 21:48'!
yearFrom: anArray
	| years |
	years := anArray first * 4 + (anArray at: 2).
	years := years + self epochYear.
	^ (anArray at: 3) < 10 ifTrue: [years] ifFalse: [years + 1]! !

!Array methodsFor: '*monticello2-serialization' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	self class = Array 
		ifTrue: [ aSerializer serializeArray: self ]
		ifFalse: [ super mdSerializeWith: aSerializer ]! !

!WideString methodsFor: '*monticello2-serialization' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	aSerializer serializeUtf16String: self! !

!Boolean methodsFor: '*monticello2-serialization' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	aSerializer serializeSingleton: self! !
MDMaterializer initialize!
MDPearsonsHash initialize!
MDTimestampPrinter initialize!
MDHashstamp initialize!
MDTimestamp initialize!
